/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 2 "src/mup/gram.y" /* yacc.c:339  */


/*
 Copyright (c) 1995-2024  by Arkkra Enterprises.
 All rights reserved.

 Redistribution and use in source and binary forms,
 with or without modification, are permitted provided that
 the following conditions are met:

 1. Redistributions of source code must retain
 the above copyright notice, this list of conditions
 and the following DISCLAIMER.

 2. Redistributions in binary form must reproduce the above
 copyright notice, this list of conditions and
 the following DISCLAIMER in the documentation and/or
 other materials provided with the distribution.

 3. Any additions, deletions, or changes to the original files
 must be clearly indicated in accompanying documentation,
 including the reasons for the changes,
 and the names of those who made the modifications.

	DISCLAIMER

 THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESS
 OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 THE IMPLIED WARRANTIES OF MERCHANTABILITY
 AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY DIRECT,
 INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO
 PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/* This file contains the parser code for the Mup music publication program.
 * It uses lex to get the tokens.
 */


#include "rational.h"
#include "globals.h"
#include "defines.h"
#include "structs.h"
#include <errno.h>

#define YYDEBUG 1


/* how many items to allocate at a time for
 * "with" list, and location lists, etc */
#define ITEMS	(4)

/* Shorter way to refer to the current entry when building an entry from
 * accidentals context */
#define CURR_ACC_ENTRY	Acc_contexts_list_p->info[Curr_acc_index]

/* It user gives consecutive restoreparms with no intervening saveparms,
 * all but the last are pointless, as the last overwrites. So we have simple
 * state machine to catch this and print a warning. Even with an intervening
 * saveparms, multiple restoreparms is dubious, because really all you could
 * do is save something that you had already saved, but under a different
 * name. But we distinguish those cases. These value record what was
 * the previous control {Save|Restore}parms command type.
 * Once we see warn case, we stay in that state
 * to avoid duplicate warnings for the same issue.
 */
#define SR_SAVE		(0)
#define SR_RESTORE	(1)
#define SR_WARN	(2)


static struct MAINLL *Currstruct_p;	/* main list struct being filled in */
static struct BLOCKHEAD *Currblock_p;	/* current block, if non-zero */

static struct INPCOORD *Curr_loc_info_p; /* location info being collected */
static struct USER_SYMBOL *Curr_usym_p;	/* user-defined symbol being defined */


static short Saw_restoreparms;		/* Yes if we have seen a restoreparms
					 * in the current control context */
static short Prev_control_parms;	/* Previous {save|restore}parms */
static short Getting_tup_dur;		/* YES if currently collection tuplet
					 * duration rather than GRPSYL dur */

static struct GRPSYL *Curr_grpsyl_p;	/* current GRPSYL struct being filled in */
static struct GRPSYL *Last_grpsyl_p;	/* previous GRPSYL struct filled in (contains
					 * defaults for the current one */
static struct TIMELIST *Extra_time_p;	/* If user enters times to be added
					 * together, like 2.+16 this points to
					 * a linked list of the extra times */
static struct TIMELIST *Curr_timelist_p;/* current additive time, used to know
					 * where to link items to the list */
static struct TIMELIST *Last_alloced_timelist_p; /* Most recently allocated
					 * list. Keeping track of this lets us
					 * avoid trying to free the list
					 * when Extra_time_p is pointing
					 * to a list from an SSV. */
static struct GRPSYL *Prev_grpsyl_p;	/* Like Last_grpsyl_p except in the
					 * case of additive times,
					 * in which case it points to the
					 * first group. This is needed in case
					 * the following group is to get its
					 * time value by defaulting to that
					 * of its previous group. */
static int Extra_basictime;		/* for saving basictime, when doing
					 * additive times */
static int Doing_timeunit = NO;		/* YES if gathering timeunit param */
static short Doing_vcombine;		/* YES if gathering vcombine param */
static short Doing_samescore = NO;	/* YES if after samescorebegin */
static short Doing_samepage = NO;	/* YES if after samepagebegin */
static struct GRPSYL *Lyrics_p;		/* pointer to current list of lyrics */
static struct WITH_ITEM *Curr_marklist;	/* current "with" list */
static int Mark_start;			/* Index into Curr_marklist at which
					 * the currently-being-gathered list
					 * began, since user could do things
					 * like [with - above;with . below][with "sfz"]
					 * Since we don't know the place till
					 * the end of a list, this lets us
					 * know how far back in the list to
					 * update with above or below.
					 */
static struct PRINTDATA **Next_print_link_p_p;	/* points to where to attach next
						 * print command that we get */
static int Mirrored;			/* YES if title has "mirrored" option */
static int Item_count;			/* items in current list */
static int Max_items;			/* current amount of space in lists
					 * "with" list, curve locations, etc) */

static int Plus_minus;			/* if 1 add, if -1 subtract offset */
static int Defining_multiple = NO;	/* if defining multiple voices at once */
static int Chord_at_a_time = NO;	/* YES for chord-at-a-time,
					 * NO for voice-at-a-time */
static short Meas_rpt_type;		/* Current MRT_* value */
static int EM_staff;			/* Staff number of most recent
					 * emptymeas parameter usage */
static short Endingloc;			/* if current bar starts or ends an
					 * ending, etc (STARTITEM, ENDITEM, etc) */
static short Endending_type;		/* EE_* value. Only relevent if
					 * Endingloc == ENDITEM */
static short Got_ending;		/* YES if got ending on this bar */

static int Til_bars;			/* number of bars in "til" clause */
static int Bar_between;                 /* YES or NO, if to put bar lines
                                         * between staffs rather than on then */
static struct SUBBAR_APPEARANCE *Subbar_app_p;	/* Info for subbartype parameter */
static double Dist;			/* dist for a specific STUFF */
static int Dist_usage;			/* meaning of Dist field */
static int Aligntag = NOALIGNTAG;	/* align tag number for STUFF */
static short User_meas_time;		/* YES if user specified a time for
					 * an 'm' item. Only valid on mr */
static int Order_place;			/* PL_* for markorder in SSV */
static int Order_prio;			/* value in markorder in SSV */
static int Start_gracebackup;		/* how many grace notes to back up
					 * before starting a "stuff" */
static int End_gracebackup;		/* how many grace notes to back up
					 * before ending a "stuff" */
static char *Grid_alias;		/* name to used where used */
static float Til_offset;		/* beat count in "til" clause */
static float Til_steps;			/* stepsize offset of "til" clause */
static int Linetype;			/* L_DOTTED, L_DASHED, or L_NORMAL */

static char *String1, *String2;		/* to temporarily keep track
					 * of labels and other temporary
					 * strings */
static char Tmpbuff[20];		/* temporary buffer for converting
					 * float numbers */
static char Stringbuff[100];		/* temporary string storage */
static int Titlefont, Titlesize;	/* font/size for title command */
static double Extra;			/* extra vertical space for prints */
static short Good_till_canceled = NO;	/* if [] things should be continued
					 * until turned off */
static short Curr_paratype = J_JUSTPARA; /* current paragraph type */
static char Curr_accs[2*MAX_ACCS];	/* list of current note's accidentals */
static int Acc_offset;			/* Current place in Curr_accs */
static int Curr_acc_index;		/* Current place in info array of
					 * current accidentals context */
static struct TIMEDSSV *Curr_tssv_p;	/* current mid-measure param change */
static char Timerep[MAXTSLEN];		/* Internal representation of time
					 * signature being collected */
static int Tsig_offset;			/* Current place in Timerep while
					 * collecting a time signature */
static struct TAG_REF *Curr_timeref_tag_p; /* Time offsets are relative
					 * to the most recent horizontal tag.
					 * This points to that tag,
					 * or is zero if no such tag yet */



/* static functions */
static char *stripquotes P((char *string));	/* rmv double quotes
						 * from string */
static void chkdup_headfoot P((int bit, char *which, struct BLOCKHEAD *block_p));
static void chkdup_topbot P((struct BLOCKHEAD **block_p_p, char *blocktype));
static void end_prev_context P((void));
static void clone_staff_ssvs P((struct MAINLL *insert_p));
static void clone_voice_ssvs P((struct MAINLL *insert_p));
static void clone1ssv P((struct SSV *clone_src_p, struct MAINLL *insert_p,
		int staffno, int voiceno));
static void chk_ssv_ranges P((UINT32B context));
static void var_valid P((void));	 /* check if okay to set location var */
static struct PRINTDATA * proc_printcmd P((int justifytype,
		struct INPCOORD *inpc_p, char *str, int font, int size,
		int got_nl, int isPostScript, int ps_usage, int isfilename, 
		struct VAR_EXPORT *export_p, double extra));
static void mirror P((struct PRINTDATA *left_p, struct PRINTDATA *right_p));
static struct VAR_EXPORT *add_export P((char *varname, int index));
static double extra_needed P((int font, int size, char **string_p));
static void keyword_notes P((char *str));
static void free_extra_time P((void));
static void tsig_item P((int item));
static struct EXPR_NODE *newnode P((int op));
static void clear_curr_accs P((void));
static void add_acc P((char *acc_name));
static void new_acc_entry P((char *acc_name));
static void add_acc_offset P((int letter, double offset));
#ifdef __STDC__
static int comp_subbar P((const void *item1_p, const void *item2_p));
#else
static int comp_subbar P((char *item1_p, char *item2_p));
#endif
static int multiwhole2basictime P((int value));
static void parse_doremi_string P((char *str));



#line 300 "src/mup/ytab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "ytab.h".  */
#ifndef YY_YY_SRC_MUP_YTAB_H_INCLUDED
# define YY_YY_SRC_MUP_YTAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    T_1ARG_FUNC = 258,
    T_2ARG_FUNC = 259,
    T_2FNUMVAR = 260,
    T_ABM = 261,
    T_ACCIDENTALS = 262,
    T_ADDSUB_OP = 263,
    T_ALIGN = 264,
    T_ALIGNLABELS = 265,
    T_ALL = 266,
    T_ALT = 267,
    T_AMPERSAND = 268,
    T_ANY = 269,
    T_ARRAYVAR = 270,
    T_AUTO = 271,
    T_BARSTLISTVAR = 272,
    T_BARTYPE = 273,
    T_BBOX = 274,
    T_BLOCKHEAD = 275,
    T_BM = 276,
    T_BULGE = 277,
    T_BYMEAS = 278,
    T_CENTS = 279,
    T_CHORDTRANSLATION = 280,
    T_CLEF = 281,
    T_CLEFVAR = 282,
    T_COLON = 283,
    T_COMMA = 284,
    T_COMMON = 285,
    T_CONTROL = 286,
    T_CUE = 287,
    T_CURVE = 288,
    T_CUT = 289,
    T_DASH = 290,
    T_DBL = 291,
    T_DBLFLAT = 292,
    T_DIAM = 293,
    T_DEFAULTPHRASESIDE = 294,
    T_DOT = 295,
    T_DOWN = 296,
    T_DRUM = 297,
    T_EABM = 298,
    T_EBM = 299,
    T_EM_BEGIN = 300,
    T_EM_END = 301,
    T_ENDENDING = 302,
    T_ENDING = 303,
    T_ENDSTYLE = 304,
    T_ENDTYPE = 305,
    T_EPH = 306,
    T_EQUAL = 307,
    T_ESBM = 308,
    T_EVERY = 309,
    T_EXCLAM = 310,
    T_FAMILY = 311,
    T_FFAMILY = 312,
    T_FILE = 313,
    T_FIRSTPAGE = 314,
    T_FNUMVAR = 315,
    T_FONT = 316,
    T_FONTVAR = 317,
    T_GRACE = 318,
    T_GRIDS = 319,
    T_HAT = 320,
    T_HEADSHAPES = 321,
    T_HIDECHANGES = 322,
    T_HO = 323,
    T_HS = 324,
    T_INPUTDIR = 325,
    T_JUSTIFYTYPE = 326,
    T_KEY = 327,
    T_KEYMAP = 328,
    T_KEYMAPVAR = 329,
    T_LBRACE = 330,
    T_LBRACKET = 331,
    T_LEN = 332,
    T_LET = 333,
    T_LETTER = 334,
    T_LET_M = 335,
    T_LET_N = 336,
    T_LET_R = 337,
    T_LET_S = 338,
    T_LET_U = 339,
    T_LET_X = 340,
    T_LINE = 341,
    T_LINETYPE = 342,
    T_LPAREN = 343,
    T_LVAR = 344,
    T_LYRICS = 345,
    T_L_ANGLE = 346,
    T_L_DBLANGLE = 347,
    T_MEASNUM = 348,
    T_MIDDLE = 349,
    T_MIDI = 350,
    T_MIRRORED = 351,
    T_MNUM = 352,
    T_MODIFIER = 353,
    T_MULDIV_OP = 354,
    T_MULTIREST = 355,
    T_MULTIWHOLE = 356,
    T_MUSIC = 357,
    T_MUSSYM = 358,
    T_NEWLINE = 359,
    T_NL = 360,
    T_NONE = 361,
    T_NONNAT = 362,
    T_NOWHERE_SLIDE = 363,
    T_NUM = 364,
    T_NUMBER = 365,
    T_NUMVAR = 366,
    T_OCTAVE = 367,
    T_OPTSTRVAR = 368,
    T_ORDER = 369,
    T_ORIENTATION = 370,
    T_OTHERTEXT = 371,
    T_PAD = 372,
    T_PAGESIDE = 373,
    T_PAGESIZE = 374,
    T_PARAGRAPH = 375,
    T_PARATYPE = 376,
    T_PEDAL = 377,
    T_PEDSTAR = 378,
    T_PEDSTYLE = 379,
    T_PH = 380,
    T_PHRASE = 381,
    T_PITCH = 382,
    T_PLACE = 383,
    T_PLUS = 384,
    T_POSTSCRIPT = 385,
    T_PRINTTYPE = 386,
    T_PRINTEDTIME = 387,
    T_PSHOOKLOC = 388,
    T_PSVAR = 389,
    T_QUAD = 390,
    T_QUESTION = 391,
    T_RANGELISTVAR = 392,
    T_RATNUMLISTVAR = 393,
    T_RBRACE = 394,
    T_RBRACKET = 395,
    T_REHEARSAL = 396,
    T_REHTYPE = 397,
    T_REH_STYLE = 398,
    T_REPEATDOTS = 399,
    T_RESTOREPARMS = 400,
    T_ROLL = 401,
    T_RPAREN = 402,
    T_RPT = 403,
    T_R_ANGLE = 404,
    T_R_DBLANGLE = 405,
    T_SAMEPAGE = 406,
    T_SAMESCORE = 407,
    T_SAVEPARMS = 408,
    T_SCORE = 409,
    T_SCOREFEED = 410,
    T_SCOREPAD = 411,
    T_SCORESEP = 412,
    T_SEMICOLON = 413,
    T_SHAPES = 414,
    T_SHARP = 415,
    T_SHORTEN = 416,
    T_SLASH = 417,
    T_SLASHMARK = 418,
    T_SLOPE = 419,
    T_SLUR = 420,
    T_STAFF = 421,
    T_STAFFLINES = 422,
    T_STANDARD = 423,
    T_STAR = 424,
    T_STEMOFFSET = 425,
    T_STRING = 426,
    T_STRINGFUNC = 427,
    T_STRVAR = 428,
    T_SUBBARSTYLE = 429,
    T_SWINGUNIT = 430,
    T_SYMBOL = 431,
    T_TAB = 432,
    T_TICKS = 433,
    T_TIE = 434,
    T_TIL = 435,
    T_TILDE = 436,
    T_TIME = 437,
    T_TIMEUNIT = 438,
    T_TITLE = 439,
    T_TO = 440,
    T_TRANSPOSE = 441,
    T_TRANSUSAGE = 442,
    T_TUNINGTYPE = 443,
    T_TUNINGVAR = 444,
    T_UNARY_OP = 445,
    T_UNDERSCORE = 446,
    T_UNITS = 447,
    T_UNITTYPE = 448,
    T_UNSET = 449,
    T_UP = 450,
    T_USEACCS = 451,
    T_USING = 452,
    T_VCOMBINE = 453,
    T_VCOMBVAL = 454,
    T_VISVAR = 455,
    T_VOICE = 456,
    T_VVAR = 457,
    T_WHEREUSED = 458,
    T_WITH = 459,
    T_XNOTE = 460,
    T_XPOS_INT = 461,
    T_YESNOVAR = 462
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 239 "src/mup/gram.y" /* yacc.c:355  */

int	intval;		/* for tokens/nonterminals that return int values */
char	*stringval;	/* for tokens/nonterminals that return strings */
float	floatval;	/* for nonterminals that return floats */
RATIONAL ratval;	/* for nonterminals that return rational numbers */
struct INPCOORD *inpcoord_p;	/* for nonterminals that return coord info */
struct EXPR_NODE *expr_p;/* for nonterminals that return coord expression */
struct TAG_REF *tag_p;	/* for nonterminals that return a tag reference */
struct VAR_EXPORT *export_p;	/* for Mup variables to be passed to user PostScript */

#line 559 "src/mup/ytab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_SRC_MUP_YTAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 576 "src/mup/ytab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  248
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1810

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  208
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  351
/* YYNRULES -- Number of rules.  */
#define YYNRULES  824
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1257

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   462

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   598,   598,   601,   604,   607,   610,   613,   616,   619,
     622,   625,   628,   631,   634,   640,   652,   659,   663,   669,
     673,   677,   681,   685,   689,   693,   708,   717,   717,   737,
     737,   755,   757,   761,   766,   768,   771,   777,   783,   789,
    1042,  1047,  1053,  1058,  1063,  1105,  1113,  1121,  1131,  1135,
    1141,  1147,  1153,  1159,  1169,  1178,  1191,  1204,  1227,  1249,
    1257,  1266,  1275,  1278,  1284,  1294,  1300,  1303,  1306,  1309,
    1328,  1343,  1349,  1365,  1371,  1377,  1383,  1396,  1400,  1407,
    1413,  1423,  1429,  1435,  1447,  1457,  1465,  1468,  1474,  1480,
    1483,  1493,  1498,  1504,  1510,  1541,  1554,  1560,  1566,  1569,
    1575,  1605,  1605,  1620,  1632,  1637,  1642,  1653,  1674,  1702,
    1733,  1739,  1745,  1751,  1757,  1763,  1775,  1781,  1800,  1821,
    1841,  1853,  1869,  1880,  1885,  1891,  1896,  1911,  1924,  1930,
    1950,  1956,  1969,  1982,  1987,  1991,  1995,  2001,  2004,  2010,
    2014,  2014,  2019,  2077,  2096,  2101,  2106,  2111,  2117,  2123,
    2129,  2135,  2141,  2145,  2149,  2152,  2155,  2164,  2170,  2182,
    2188,  2195,  2201,  2207,  2211,  2217,  2221,  2224,  2227,  2230,
    2237,  2241,  2245,  2257,  2265,  2270,  2276,  2282,  2287,  2292,
    2309,  2319,  2327,  2330,  2339,  2358,  2364,  2369,  2375,  2378,
    2381,  2387,  2390,  2394,  2427,  2433,  2438,  2458,  2466,  2474,
    2481,  2493,  2499,  2505,  2511,  2530,  2536,  2542,  2548,  2554,
    2576,  2579,  2579,  2585,  2590,  2590,  2596,  2602,  2608,  2631,
    2643,  2651,  2654,  2657,  2676,  2681,  2687,  2692,  2701,  2711,
    2726,  2738,  2748,  2759,  2798,  2817,  2825,  2831,  2837,  2844,
    2850,  2856,  2866,  2873,  2878,  2884,  2894,  2899,  2911,  2917,
    2923,  2932,  2937,  2945,  2951,  2962,  2972,  2977,  2991,  3009,
    3019,  3034,  3052,  3064,  3068,  3074,  3078,  3090,  3096,  3102,
    3105,  3134,  3139,  3146,  3146,  3151,  3156,  3163,  3168,  3174,
    3182,  3187,  3195,  3200,  3207,  3213,  3222,  3228,  3234,  3239,
    3255,  3261,  3267,  3272,  3276,  3281,  3286,  3291,  3296,  3301,
    3321,  3326,  3332,  3337,  3342,  3347,  3353,  3362,  3386,  3414,
    3509,  3516,  3523,  3526,  3529,  3532,  3535,  3538,  3541,  3544,
    3547,  3550,  3553,  3556,  3559,  3562,  3565,  3568,  3571,  3574,
    3577,  3580,  3583,  3586,  3589,  3592,  3595,  3598,  3601,  3604,
    3607,  3610,  3613,  3616,  3619,  3622,  3625,  3628,  3631,  3634,
    3637,  3640,  3643,  3646,  3649,  3652,  3655,  3658,  3668,  3678,
    3684,  3690,  3703,  3722,  3757,  3763,  3767,  3773,  3779,  3782,
    3785,  3788,  3793,  3798,  3804,  3810,  3817,  3820,  3827,  3835,
    3844,  3851,  3854,  3860,  3869,  3875,  3885,  3903,  3929,  3933,
    3940,  3943,  3947,  3950,  3993,  3997,  4001,  4004,  4008,  4017,
    4023,  4029,  4036,  4039,  4043,  4056,  4073,  4089,  4094,  4098,
    4114,  4120,  4125,  4130,  4136,  4140,  4148,  4155,  4162,  4165,
    4168,  4171,  4186,  4189,  4192,  4195,  4212,  4229,  4240,  4267,
    4278,  4303,  4309,  4315,  4335,  4340,  4345,  4348,  4352,  4355,
    4359,  4362,  4375,  4403,  4422,  4433,  4448,  4462,  4473,  4478,
    4484,  4489,  4496,  4501,  4518,  4521,  4524,  4540,  4549,  4553,
    4560,  4567,  4574,  4580,  4592,  4604,  4614,  4625,  4631,  4637,
    4665,  4671,  4677,  4683,  4714,  4723,  4734,  4739,  4755,  4781,
    4829,  4834,  4838,  4853,  4874,  4879,  4893,  4898,  4904,  4911,
    4916,  4922,  4942,  4948,  4954,  4960,  4973,  4978,  4982,  4986,
    5005,  5027,  5046,  5087,  5105,  5118,  5137,  5160,  5163,  5166,
    5170,  5177,  5182,  5222,  5229,  5237,  5243,  5246,  5256,  5272,
    5288,  5306,  5327,  5334,  5346,  5357,  5369,  5381,  5389,  5394,
    5406,  5416,  5426,  5442,  5448,  5458,  5474,  5480,  5486,  5495,
    5501,  5515,  5520,  5537,  5544,  5550,  5555,  5560,  5564,  5570,
    5575,  5580,  5585,  5589,  5594,  5600,  5606,  5612,  5618,  5624,
    5631,  5637,  5643,  5650,  5657,  5663,  5669,  5681,  5691,  5697,
    5703,  5709,  5716,  5723,  5730,  5739,  5746,  5750,  5753,  5757,
    5769,  5778,  5784,  5792,  5799,  5806,  5813,  5820,  5827,  5834,
    5841,  5848,  5855,  5862,  5868,  5875,  5882,  5894,  5899,  5905,
    5910,  5924,  5931,  5938,  5942,  5954,  5958,  5963,  5973,  5979,
    5986,  5993,  6000,  6006,  6011,  6019,  6022,  6032,  6035,  6043,
    6050,  6060,  6066,  6070,  6070,  6072,  6072,  6076,  6081,  6092,
    6097,  6102,  6110,  6116,  6122,  6131,  6143,  6149,  6155,  6158,
    6161,  6164,  6186,  6190,  6197,  6203,  6209,  6212,  6216,  6227,
    6232,  6341,  6344,  6348,  6347,  6461,  6495,  6533,  6536,  6540,
    6544,  6547,  6550,  6620,  6626,  6632,  6644,  6647,  6650,  6653,
    6657,  6660,  6663,  6718,  6724,  6746,  6754,  6777,  6781,  6787,
    6790,  6794,  6802,  6813,  6846,  6860,  6867,  6882,  6888,  6893,
    6910,  6919,  6934,  6944,  6952,  6961,  6970,  6978,  6986,  6995,
    7001,  7008,  7016,  7026,  7043,  7049,  7057,  7065,  7079,  7087,
    7095,  7102,  7144,  7166,  7183,  7189,  7199,  7205,  7211,  7216,
    7222,  7229,  7235,  7238,  7243,  7246,  7274,  7281,  7286,  7291,
    7296,  7301,  7314,  7327,  7330,  7333,  7336,  7340,  7343,  7347,
    7363,  7400,  7408,  7415,  7430,  7440,  7447,  7450,  7457,  7466,
    7490,  7502,  7508,  7514,  7520,  7527,  7533,  7539,  7544,  7550,
    7556,  7569,  7575,  7588,  7593,  7599,  7604,  7615,  7618,  7622,
    7630,  7640,  7645,  7651,  7656,  7662,  7667,  7673,  7678,  7685,
    7698,  7705,  7710,  7715,  7733,  7741,  7747,  7755,  7762,  7766,
    7771,  7778,  7785,  7789,  7796,  7802,  7805,  7812,  7819,  7825,
    7830,  7853,  7863,  7868,  7874,  7880,  7889,  7896,  7901,  7907,
    7910,  7922,  7929,  7936,  7950,  7956,  7965,  7971,  7978,  7983,
    7986,  7989,  7993,  8000,  8007
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "T_1ARG_FUNC", "T_2ARG_FUNC",
  "T_2FNUMVAR", "T_ABM", "T_ACCIDENTALS", "T_ADDSUB_OP", "T_ALIGN",
  "T_ALIGNLABELS", "T_ALL", "T_ALT", "T_AMPERSAND", "T_ANY", "T_ARRAYVAR",
  "T_AUTO", "T_BARSTLISTVAR", "T_BARTYPE", "T_BBOX", "T_BLOCKHEAD", "T_BM",
  "T_BULGE", "T_BYMEAS", "T_CENTS", "T_CHORDTRANSLATION", "T_CLEF",
  "T_CLEFVAR", "T_COLON", "T_COMMA", "T_COMMON", "T_CONTROL", "T_CUE",
  "T_CURVE", "T_CUT", "T_DASH", "T_DBL", "T_DBLFLAT", "T_DIAM",
  "T_DEFAULTPHRASESIDE", "T_DOT", "T_DOWN", "T_DRUM", "T_EABM", "T_EBM",
  "T_EM_BEGIN", "T_EM_END", "T_ENDENDING", "T_ENDING", "T_ENDSTYLE",
  "T_ENDTYPE", "T_EPH", "T_EQUAL", "T_ESBM", "T_EVERY", "T_EXCLAM",
  "T_FAMILY", "T_FFAMILY", "T_FILE", "T_FIRSTPAGE", "T_FNUMVAR", "T_FONT",
  "T_FONTVAR", "T_GRACE", "T_GRIDS", "T_HAT", "T_HEADSHAPES",
  "T_HIDECHANGES", "T_HO", "T_HS", "T_INPUTDIR", "T_JUSTIFYTYPE", "T_KEY",
  "T_KEYMAP", "T_KEYMAPVAR", "T_LBRACE", "T_LBRACKET", "T_LEN", "T_LET",
  "T_LETTER", "T_LET_M", "T_LET_N", "T_LET_R", "T_LET_S", "T_LET_U",
  "T_LET_X", "T_LINE", "T_LINETYPE", "T_LPAREN", "T_LVAR", "T_LYRICS",
  "T_L_ANGLE", "T_L_DBLANGLE", "T_MEASNUM", "T_MIDDLE", "T_MIDI",
  "T_MIRRORED", "T_MNUM", "T_MODIFIER", "T_MULDIV_OP", "T_MULTIREST",
  "T_MULTIWHOLE", "T_MUSIC", "T_MUSSYM", "T_NEWLINE", "T_NL", "T_NONE",
  "T_NONNAT", "T_NOWHERE_SLIDE", "T_NUM", "T_NUMBER", "T_NUMVAR",
  "T_OCTAVE", "T_OPTSTRVAR", "T_ORDER", "T_ORIENTATION", "T_OTHERTEXT",
  "T_PAD", "T_PAGESIDE", "T_PAGESIZE", "T_PARAGRAPH", "T_PARATYPE",
  "T_PEDAL", "T_PEDSTAR", "T_PEDSTYLE", "T_PH", "T_PHRASE", "T_PITCH",
  "T_PLACE", "T_PLUS", "T_POSTSCRIPT", "T_PRINTTYPE", "T_PRINTEDTIME",
  "T_PSHOOKLOC", "T_PSVAR", "T_QUAD", "T_QUESTION", "T_RANGELISTVAR",
  "T_RATNUMLISTVAR", "T_RBRACE", "T_RBRACKET", "T_REHEARSAL", "T_REHTYPE",
  "T_REH_STYLE", "T_REPEATDOTS", "T_RESTOREPARMS", "T_ROLL", "T_RPAREN",
  "T_RPT", "T_R_ANGLE", "T_R_DBLANGLE", "T_SAMEPAGE", "T_SAMESCORE",
  "T_SAVEPARMS", "T_SCORE", "T_SCOREFEED", "T_SCOREPAD", "T_SCORESEP",
  "T_SEMICOLON", "T_SHAPES", "T_SHARP", "T_SHORTEN", "T_SLASH",
  "T_SLASHMARK", "T_SLOPE", "T_SLUR", "T_STAFF", "T_STAFFLINES",
  "T_STANDARD", "T_STAR", "T_STEMOFFSET", "T_STRING", "T_STRINGFUNC",
  "T_STRVAR", "T_SUBBARSTYLE", "T_SWINGUNIT", "T_SYMBOL", "T_TAB",
  "T_TICKS", "T_TIE", "T_TIL", "T_TILDE", "T_TIME", "T_TIMEUNIT",
  "T_TITLE", "T_TO", "T_TRANSPOSE", "T_TRANSUSAGE", "T_TUNINGTYPE",
  "T_TUNINGVAR", "T_UNARY_OP", "T_UNDERSCORE", "T_UNITS", "T_UNITTYPE",
  "T_UNSET", "T_UP", "T_USEACCS", "T_USING", "T_VCOMBINE", "T_VCOMBVAL",
  "T_VISVAR", "T_VOICE", "T_VVAR", "T_WHEREUSED", "T_WITH", "T_XNOTE",
  "T_XPOS_INT", "T_YESNOVAR", "$accept", "song", "item", "context",
  "ssv_context", "$@1", "$@2", "ssv_stafflist", "ssv_staff_item",
  "ssv_sv_list", "ssv_sv_item", "alloc_ssv", "new_context",
  "blockhead_context", "music_context", "grid_context",
  "accidentals_context", "begin_acc_context", "acc_context_name",
  "acc_entry", "acc_name", "offsets_spec", "offsets_list", "acc_offset",
  "keymap_context", "control_context", "control_item", "stringpair",
  "headshape_context", "shapes_context", "symbol_context", "staffnum",
  "voicenum", "num", "value", "assignment", "terminator", "assign", "$@3",
  "visval", "opt_pageside", "opt_print_clef", "measnumval", "vschemetype",
  "allocbeamlist", "ratnumlist", "nonempty_ratnumlist", "subbeam", "$@4",
  "time_item", "swing_time", "opt_rs", "alloc_rangelist", "rangelist",
  "rangelistA", "rangeitem", "rangetail", "grplabel", "optlabel2",
  "glabel", "alloc_barstlist", "barstlist", "opt_between", "between",
  "barst_item", "subbar_check", "subbar_list", "alloc_subbar",
  "alloc_sb_barstlist", "sb_linetype", "sb_bartype", "sb_appearance",
  "line_ref", "line_offset", "sb_barstlist", "sb_timelist", "sb_count",
  "repeatdots_value", "mark_order", "orderlist", "orderitem", "marktype",
  "timesig", "tsiglist", "$@5", "meas_tsig", "$@6", "fraction",
  "numerator", "numerator_value", "opt_ts_visibility", "opt_n",
  "printed_timesig", "keyspec", "useaccs_value", "useaccs_qual",
  "stafflinedef", "prclef", "ch_tran_type", "tab_string_list", "tab_item",
  "opt_str_acc", "opt_ticks", "flagval", "minscsep", "maxscsep",
  "minscpad", "maxscpad", "shorten_opts", "shorten_range", "inputdir",
  "pagesize", "orientation", "vcombine_clause", "$@7", "vcombine_value",
  "vcombine_quals", "opt_vcombine_qualifier", "opt_bymeas", "end_type",
  "updown", "majmin", "pedstyle", "transpose_interval", "trans_usage",
  "title", "opt_mirrored", "tfont", "title_font", "font_family",
  "title_size", "titleA", "paragraph", "opt_paratype", "paramname",
  "string", "string_part", "music_input", "noteinfo", "init_staff",
  "sv_spec", "sv_map_list", "sv_map_entry", "map_start", "map_finish",
  "sv_map_item_list", "voice_id", "sv_and", "sv_item", "notecolon",
  "grp_stafflist", "grp_staff_item", "grp_staff_range", "voice_spec",
  "voice_tail", "groupinfo", "groupdata", "mid_meas_param",
  "mid_meas_list", "mid_meas_item", "mm_context", "mm_params",
  "mm_param_item", "grp_attributes", "styleinfo", "gtc", "extra_styleinfo",
  "alloc_grpsyl", "marklist", "marklistA", "markitem", "hor_offset",
  "opt_plus_or_minus", "other_attr", "attr_list", "attr_item",
  "alloc_marklist", "mark_place", "opt_dir", "opt_to_voice", "marks",
  "mark", "mark_item", "shorthand_mark", "notetype", "dir", "beammark",
  "time_val", "crossbeam", "basic_time_val", "opt_more_time",
  "more_time_item", "alloc_timelist", "opt_m", "opt_dbl_or_quad", "dots",
  "padding", "padspec", "opt_minus", "group", "special_group",
  "extra_attr", "spec_grp_alloc", "extra_item", "note_opts", "notelist",
  "opt_other_staff", "css_with", "some_notes", "notedata", "notedata1",
  "opt_bend", "pitch", "opt_accidental", "opt_acc_list", "opt_octave",
  "acc_list", "begin_acc_list", "acc_list_tail", "note_acc", "acc_symbol",
  "octave", "minuslist", "pluslist", "slur_item", "start_slur", "slurlist",
  "fullslurlist", "slurnote", "grp_locsave", "loc_variable", "arraytag",
  "ntuplet", "printtup", "start_tuplet", "rbrace", "opt_side", "opt_time",
  "opt_tuplet_slope", "lyricinfo", "lyric_id", "lyr_opt_place", "using",
  "opt_place", "ph_opt_place", "staff_list", "staff_item", "staff_range",
  "more_lyric_ids", "$@8", "$@9", "verse_spec", "verselist", "verse_item",
  "verse_range", "alloc_lyr_grpsyl", "lyricdata", "lyr_tlist",
  "lyrics_timelist", "lyr_time_item", "lyr_tm", "lyrtuplet", "opt_space",
  "lyr_verse", "verse_string", "os_directive", "$@10", "scorefeed_options",
  "scorefeed_item", "temp_margin", "margin_override", "temp_scoresep",
  "opt_equals", "opt_semi", "directive", "barinfo", "precbartype",
  "barline", "bartype", "emptymeas_input", "bar_items", "bar_opt",
  "ending_info", "chk_dup_reh", "rehearsal_mark", "location", "alloc_loc",
  "plus_or_minus", "xcoord", "ycoord", "coord_setup", "expression",
  "direction", "floatnum", "opt_decimal_part", "numstr", "variable",
  "line", "line_alloc", "linetype", "opt_line_str", "curve", "curve_alloc",
  "curve_tail", "loc_list", "bulgelist", "bulge_value", "curve_loc",
  "stuff_info", "stuff_header", "midi", "midi_staff", "stuff_id",
  "stuff_type", "opt_size", "opt_modifier", "opt_dist", "stuff_dist",
  "opt_exclam", "opt_align", "stufflist", "stuff_item", "beat_offset",
  "gracebackup", "steps_offset", "opt_string", "opt_stuff_string",
  "til_clause", "til_val", "til_suffix", "til_offset", "roll_cmd",
  "opt_roll_dir", "roll_extent", "roll_start", "roll_end",
  "roll_offsetlist", "printcmd", "postscript", "opt_file", "ps_opt_loc",
  "export_list", "export_var_list", "export_item", "aliased_var", "alias",
  "export_var", "alias_or_export_var", "printtype", "justifytype",
  "opt_loc", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462
};
# endif

#define YYPACT_NINF -1025

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1025)))

#define YYTABLE_NINF -815

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    1409,   -16,    47, -1025,    51,   391,   415,   152,   505,   575,
   -1025,   588,   595,   600,   606, -1025,   614,   618,   623, -1025,
   -1025,   624, -1025,   626,   489,   627, -1025,   361, -1025,   628,
   -1025, -1025,   171, -1025, -1025, -1025,   630, -1025,   631, -1025,
     632, -1025, -1025,   633,   635, -1025,   639,   640,   642,   643,
     644,   646,   489,    12, -1025, -1025, -1025,   489, -1025, -1025,
     647,   648,   124,   649, -1025,   650,   651, -1025,   406,   654,
     656,   657,   489,   659,   662,   663,   664,   666,  1603,   667,
     668,   669, -1025,   671,   673,  1211, -1025,   312, -1025, -1025,
   -1025, -1025, -1025, -1025,    55, -1025, -1025,   185, -1025, -1025,
   -1025, -1025, -1025,   185,   675, -1025,   341,   572, -1025,   608,
     370, -1025, -1025,   634,    16, -1025,   312,   638, -1025, -1025,
     364, -1025, -1025,   708,    91,   655, -1025, -1025, -1025,   348,
     398, -1025, -1025,   251,   489,   676, -1025,   702, -1025, -1025,
     489,   713,   328,   616,   229,   689,   171,   702,   687,    28,
     435,   625,   489, -1025,   555,   120, -1025,   532, -1025,   312,
      41,   489,   702,   109,   489,    90,   431, -1025, -1025,   611,
      43,   625, -1025, -1025,   171,   625, -1025, -1025,   702,   251,
     489,   625,   251, -1025,   -14,   702,   171,   489, -1025,   339,
     625,   509, -1025,    18,   568,   564, -1025, -1025, -1025, -1025,
   -1025, -1025, -1025, -1025, -1025, -1025, -1025, -1025, -1025, -1025,
   -1025, -1025, -1025, -1025, -1025, -1025, -1025, -1025, -1025, -1025,
   -1025, -1025, -1025, -1025, -1025, -1025, -1025, -1025, -1025, -1025,
   -1025, -1025, -1025, -1025, -1025, -1025, -1025, -1025, -1025, -1025,
   -1025, -1025,   328, -1025,    98, -1025,   171,   328, -1025, -1025,
   -1025, -1025, -1025,   358, -1025,   658,   636,   358, -1025, -1025,
   -1025, -1025,   437,   703, -1025,   703,   489,   387, -1025, -1025,
     724, -1025,   733,   688, -1025,   171,   752, -1025,    39, -1025,
     679, -1025,   540, -1025, -1025,   680,   655,   750,   251, -1025,
     752, -1025,   171,   674, -1025, -1025, -1025, -1025,   566, -1025,
     489,   661,   736,   744, -1025,   625, -1025,   137, -1025,   751,
     171, -1025,   625,   707, -1025, -1025, -1025, -1025, -1025, -1025,
   -1025, -1025, -1025,   152,   251, -1025, -1025, -1025, -1025, -1025,
   -1025,   117, -1025,   117,   625, -1025,   171,   760, -1025,    84,
     761, -1025,   171, -1025, -1025, -1025, -1025,   171, -1025,   251,
     670, -1025, -1025, -1025,   625, -1025, -1025, -1025, -1025,   678,
   -1025,   169, -1025, -1025,   370, -1025,   677,   171,   171,   238,
   -1025, -1025, -1025, -1025,   171,   763,   610, -1025,     1,   767,
     251,   768, -1025, -1025,   770,   171,   536,   234, -1025,   771,
     772,   625, -1025, -1025, -1025, -1025, -1025, -1025, -1025, -1025,
     722, -1025,   442,   678,   153, -1025, -1025,   597, -1025, -1025,
   -1025,   235, -1025,   171, -1025, -1025, -1025, -1025,   171,    11,
   -1025, -1025, -1025, -1025,   251,   652, -1025,   358, -1025, -1025,
   -1025, -1025, -1025, -1025, -1025, -1025, -1025,   265, -1025, -1025,
     717,   748,   717, -1025, -1025,   171, -1025, -1025,   718, -1025,
     368,   752, -1025,   171,   171,   554, -1025, -1025, -1025, -1025,
     489,   449, -1025,   759,   217,   764,   702, -1025, -1025, -1025,
   -1025,   725,   725,   794,   361, -1025, -1025, -1025,   727,   251,
   -1025,   741,   681, -1025,   361, -1025,   449,   762,   625, -1025,
   -1025,   661,   251, -1025,   787,   795,   814,   171, -1025,   702,
   -1025, -1025, -1025, -1025, -1025, -1025, -1025, -1025, -1025, -1025,
     620,   620, -1025,   171,   233,   171,   171, -1025,   171,   682,
   -1025, -1025, -1025, -1025, -1025,   470,   171,   625, -1025, -1025,
   -1025,   787, -1025,   798, -1025, -1025,   581,   800, -1025, -1025,
   -1025,   251,   171, -1025,   778,   778, -1025, -1025, -1025,   702,
   -1025, -1025,   251, -1025,   251, -1025,   752, -1025,   802, -1025,
   -1025,   636, -1025, -1025, -1025, -1025,   702,   489,    56, -1025,
     793, -1025,   509, -1025, -1025, -1025, -1025,   171, -1025, -1025,
   -1025, -1025, -1025,    27,   752, -1025,    39, -1025, -1025, -1025,
     810,   251, -1025,   437,   437,   171,   489, -1025, -1025,   489,
   -1025,   -84,   444, -1025,   593,   718, -1025, -1025,   171, -1025,
   -1025, -1025,   171,   171, -1025,   625, -1025, -1025, -1025, -1025,
   -1025, -1025, -1025, -1025, -1025, -1025, -1025,   796,   489,   171,
     171,   171,   251,   703, -1025,   660,   665,   692,   120,   797,
     806, -1025, -1025,   204,   484, -1025,   120,   819,   332, -1025,
     796,   803,   820, -1025, -1025,   801, -1025,   804, -1025,   489,
   -1025, -1025, -1025,   171, -1025,   729, -1025, -1025,   823, -1025,
   -1025, -1025, -1025, -1025,   780,   339, -1025,   188,   307, -1025,
     700, -1025, -1025, -1025, -1025,   731,   509, -1025, -1025, -1025,
     773,   171,   409,   779,   781, -1025,   409,   706,   251,   171,
   -1025,   204,   702,   251, -1025,   839, -1025,   171,   -38, -1025,
     117, -1025,   418,   680, -1025,    77,   678,   683,   684,   848,
   -1025, -1025,   171, -1025, -1025, -1025, -1025, -1025,   732,   312,
     370,   221, -1025, -1025, -1025,    31, -1025,   843,   241,   339,
   -1025, -1025,   718, -1025,   752, -1025,   845,   171,   625, -1025,
   -1025, -1025, -1025,   748,   725,   725, -1025,    54,   280,   171,
     251, -1025,    10,   704,    54,   332,   792,   799,   332,   332,
     251,   220, -1025,   842,   512,   449,   449,   625, -1025,   171,
   -1025,   702,   191, -1025,   805,   493,   326,   188, -1025, -1025,
   -1025, -1025,   120, -1025,   489, -1025, -1025,    52, -1025, -1025,
   -1025, -1025, -1025,   728, -1025,   264, -1025,   251, -1025,   702,
   -1025, -1025,   542, -1025,   711, -1025, -1025,   867, -1025, -1025,
   -1025, -1025, -1025, -1025, -1025, -1025, -1025, -1025, -1025, -1025,
   -1025,   786,   370,   788,   841,   844,   846,   847,   492, -1025,
     754,   672,    72, -1025, -1025,   382, -1025,    23, -1025,   -17,
   -1025, -1025,   655,    25,   691,   277, -1025,   851,   753,   765,
     489,   251,   743,   882,   756,   220,   332,   332, -1025,    69,
   -1025,   332,   332,   512, -1025, -1025, -1025, -1025, -1025, -1025,
   -1025, -1025, -1025, -1025,   875, -1025,   171, -1025, -1025, -1025,
     871,   769,   878, -1025, -1025, -1025,   120,   761,   879,   625,
   -1025, -1025, -1025, -1025, -1025, -1025,   881, -1025, -1025,   252,
   -1025,     7,   525, -1025,   625, -1025,   885,   171, -1025,   328,
   -1025,    31, -1025, -1025, -1025,   449,   702, -1025,   249,   489,
     251,   171, -1025, -1025,   774,   755, -1025, -1025, -1025, -1025,
   -1025, -1025, -1025,   171,   712, -1025, -1025, -1025, -1025,   702,
      30,    30,   757,   883, -1025, -1025,   807,   382,   449,   334,
     489, -1025, -1025,    30,   489, -1025, -1025,   302, -1025, -1025,
   -1025, -1025, -1025, -1025,   834,   636, -1025, -1025, -1025, -1025,
   -1025, -1025, -1025, -1025, -1025,   694,   790,   214,   702,   725,
   -1025,   703,   790,   251,   864, -1025, -1025, -1025, -1025,   422,
     563, -1025, -1025,   171, -1025, -1025,    93,    79, -1025,   821,
   -1025, -1025,   702,   892,   171, -1025,   489,   171,   761,   489,
     776,   702, -1025, -1025, -1025, -1025, -1025,   889,   808,   255,
   -1025, -1025, -1025,   707, -1025, -1025, -1025, -1025, -1025, -1025,
     171,   289,   325, -1025,   251,   625, -1025, -1025,   218,   886,
     672, -1025,   775, -1025,   251,   740, -1025,   740, -1025,   301,
     616, -1025, -1025, -1025,   252,   625,   740,   625, -1025,   252,
     782,   636, -1025, -1025,   783,   374,   382,   187,   388,   625,
   -1025,   711,    81,   100, -1025,   171, -1025, -1025, -1025,   625,
     868,   251,   898, -1025,   749, -1025,   717, -1025,   864, -1025,
   -1025, -1025,   296,   741, -1025, -1025, -1025,   332, -1025,   153,
   -1025, -1025,   342, -1025, -1025, -1025, -1025, -1025, -1025, -1025,
   -1025,   204,   193,   793, -1025, -1025, -1025, -1025, -1025, -1025,
   -1025,   625,    75, -1025, -1025, -1025,   893, -1025, -1025,   811,
   -1025,   734, -1025, -1025, -1025, -1025, -1025, -1025, -1025,    30,
   -1025, -1025, -1025, -1025,   789,   791,   252,   489,   395, -1025,
   -1025,   489, -1025, -1025, -1025, -1025,   636,   489, -1025,   500,
   -1025, -1025,   702,   725,   489, -1025,   251,   741, -1025, -1025,
     121, -1025, -1025,   758,   251, -1025, -1025,    26,   218, -1025,
   -1025,   900,   866, -1025,   171,   740,   252,   489,   809, -1025,
     187,   489,   473,    81, -1025,   812, -1025, -1025, -1025, -1025,
     892, -1025, -1025,   625,   727, -1025, -1025,   255, -1025,   171,
     251, -1025, -1025,   672, -1025, -1025, -1025, -1025,   489, -1025,
     815, -1025, -1025, -1025, -1025,   784,   741,   204, -1025,   917,
   -1025, -1025,   813, -1025,   489,   702,   816, -1025,   818,   251,
   -1025, -1025,   251, -1025, -1025, -1025, -1025
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,     0,    43,     0,     0,     0,   123,     0,     0,
      55,     0,     0,     0,     0,   303,     0,     0,     0,    41,
      59,     0,   821,     0,     0,     0,   728,   611,   750,     0,
     745,   298,     0,    40,   753,    14,     0,   754,     0,   196,
       0,   311,   752,     0,   802,   819,     0,     0,     0,     0,
       0,     0,     0,   789,   751,   656,   655,     0,    38,   653,
       0,     0,     0,     0,    38,     0,     0,   359,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    38,     0,     0,     0,     2,   668,    16,    18,
      38,    19,    22,    11,     0,    23,    17,     0,    10,    20,
      21,    24,     5,     0,     0,     6,     0,     0,     7,     0,
      46,   357,     8,     0,     0,   364,   668,     0,   679,   651,
     673,   652,   670,     0,     0,   755,   748,   671,   657,   822,
     822,   820,    15,     0,     0,     0,   164,   493,   124,    39,
     246,     0,     0,   613,     0,     0,     0,   493,     0,     0,
       0,    54,   775,   612,   608,     0,   607,     0,    64,   668,
      70,   775,   493,     0,     0,   228,     0,   151,   133,     0,
       0,    57,   791,   790,     0,    56,    37,   658,   493,     0,
     775,    60,     0,    27,     0,   493,     0,     0,   174,   144,
      61,     0,   101,     0,     0,     0,   321,   343,   319,   342,
     354,   348,   344,   327,   353,   322,   320,   352,   323,   338,
     351,   329,   312,   349,   336,   318,   330,   340,   356,   334,
     345,   328,   325,   333,   314,   355,   324,   315,   347,   335,
     317,   339,   316,   341,   350,   326,   337,   332,   346,   331,
     313,   100,     0,   273,     0,    29,     0,     0,     1,     3,
     669,     4,    25,     0,   543,     0,    48,     0,    68,    67,
      12,    66,     0,   302,   749,   302,     0,     0,   361,   371,
     384,    62,     0,   367,   368,     0,   366,   375,   378,   381,
       0,     9,   650,   732,   726,   727,   755,     0,     0,   747,
     746,   744,     0,   757,   698,   823,   806,   824,   807,   805,
       0,     0,   718,     0,    42,    44,    96,   165,   494,     0,
       0,    95,   247,   125,   255,   256,   110,   614,    90,   285,
     284,   106,    93,   123,     0,    92,   267,   468,   467,    75,
     268,     0,    86,   544,   776,   116,     0,     0,   616,   619,
     622,   615,     0,   127,   128,    99,   363,     0,   113,     0,
       0,   290,   292,   108,   117,   217,   216,   220,   223,   229,
     213,     0,   221,    89,   230,   269,   271,     0,   152,   134,
     107,   194,   195,    84,   793,     0,   795,    26,   654,   261,
       0,   258,   257,   114,   263,     0,   243,   226,    91,     0,
       0,   112,   177,   487,   478,   488,   479,   145,   103,   489,
       0,    88,   211,   210,   486,   287,   286,     0,   115,   111,
      87,   235,    77,   275,   121,   122,   120,    98,     0,   130,
      97,   700,   699,    47,     0,    52,    45,     0,    49,   206,
     205,   204,   201,   202,   203,   208,   207,    85,   197,   200,
     304,   300,   304,   358,    58,     0,   383,   380,   394,   369,
       0,   373,   377,     0,     0,   388,    63,   379,    13,   691,
       0,     0,   684,     0,     0,     0,   493,   692,   681,   680,
     683,     0,     0,     0,   611,   676,   672,   677,   771,   741,
     767,   773,     0,   758,   611,   703,     0,   803,   800,   723,
     720,   721,     0,   172,   157,    82,     0,   171,   166,   493,
      65,   126,    94,    71,    72,   561,   564,   562,   563,   560,
     288,   288,   545,   609,   634,     0,     0,   618,     0,   606,
     129,    69,    78,   291,   214,     0,     0,   231,   272,    76,
     270,   157,    81,   153,   154,   140,   146,   135,   137,   136,
     794,     0,     0,   792,   666,   666,   659,   660,   661,   493,
     105,   260,     0,   104,     0,    74,    37,    31,    33,   245,
     244,     0,   241,   240,   227,   239,   493,     0,    83,   175,
     480,   143,     0,   209,   225,   102,   293,     0,   237,   236,
     238,   234,   274,   277,    37,    34,     0,   132,   131,    79,
       0,     0,    50,     0,     0,     0,     0,   301,   299,     0,
     385,     0,   394,   390,   416,   395,   396,   372,     0,   370,
     376,   382,     0,     0,   386,   690,   591,   581,   583,   587,
     584,   585,   586,   588,   589,   582,   682,     0,     0,     0,
       0,     0,     0,   302,   740,     0,     0,     0,     0,   675,
       0,   770,   768,     0,   777,   756,     0,     0,     0,   724,
     815,   817,   808,   809,   812,     0,   811,   816,   804,     0,
     719,   722,    73,     0,   173,   170,   169,   168,     0,   289,
     232,   233,   610,   597,   634,   474,   605,     0,   634,   638,
       0,   642,   621,   620,   617,   625,     0,   219,   222,   218,
     159,     0,   486,   150,   149,    80,   486,     0,   788,   796,
     667,   434,   493,     0,   259,   265,    28,     0,     0,   248,
     251,   119,     0,   727,   490,   484,   212,   294,   280,   282,
     276,    30,     0,    36,    51,    53,   199,   198,     0,   668,
     306,   668,   399,   400,   401,     0,   391,   416,   514,   474,
     409,   392,   394,   397,   374,   389,   388,     0,   687,   685,
     686,   688,   492,   300,     0,     0,   674,   759,   365,     0,
       0,   779,   778,   781,   759,     0,     0,     0,     0,     0,
       0,   701,   710,     0,     0,     0,     0,   801,   158,     0,
     171,   493,   634,   475,   644,     0,     0,   635,   646,   639,
     640,   623,     0,   215,     0,   156,   155,     0,   147,   148,
     139,   138,   798,     0,   797,     0,   435,     0,   262,   493,
     264,    32,   243,   249,   253,   252,   360,     0,   179,   485,
     481,   142,   483,   295,   109,   281,   279,   283,   278,    35,
     305,     0,   307,     0,     0,     0,     0,     0,     0,   402,
       0,   417,   436,   496,   508,     0,   495,   511,   408,   394,
     387,   590,   755,     0,   729,     0,   743,     0,     0,     0,
       0,     0,     0,   765,     0,   702,     0,     0,   707,     0,
     712,     0,     0,     0,   713,   716,   717,   714,   715,   818,
     810,   813,   816,   167,     0,   598,     0,   645,   641,   628,
     632,     0,   627,   629,   648,   647,     0,   626,   161,   163,
     141,   799,   664,   662,   663,   665,     0,   242,   254,   548,
     180,   181,     0,   296,   308,   309,     0,     0,   273,     0,
     398,     0,   416,   463,   465,     0,   493,   464,   434,     0,
       0,     0,   447,   466,     0,   418,   419,   423,   425,   424,
     491,   422,   470,     0,   476,   471,   473,   444,   472,   493,
     450,   450,     0,   437,   438,   440,     0,   497,     0,     0,
       0,   573,   500,   450,     0,   498,   507,   574,   521,   526,
     523,   522,   517,   518,     0,     0,   524,   525,   520,   527,
     513,   510,   514,   508,   516,   541,   599,     0,   493,     0,
     731,   302,   599,     0,   763,   760,   678,   772,   774,     0,
     771,   782,   769,     0,   742,   697,     0,     0,   704,   705,
     706,   711,   493,   601,     0,   631,     0,     0,   624,     0,
       0,   493,   568,   570,   565,   250,   549,   566,   567,     0,
     182,   178,   489,   125,   405,   407,   406,   403,   410,   580,
       0,   432,   431,   427,     0,   428,   429,   430,     0,   412,
       0,   442,     0,   469,     0,   452,   451,   452,   393,   727,
     613,   509,   502,   504,   548,   505,   452,   506,   575,   548,
       0,   576,   577,   519,     0,     0,   515,   551,   548,   542,
     529,   253,     0,   546,   600,     0,   696,   694,   695,   693,
     759,     0,   734,   737,   733,   735,   304,   725,   763,   764,
     761,   780,   771,   773,   783,   766,   708,     0,   118,   486,
     643,   633,     0,   630,   162,   160,   266,   569,   571,   184,
     185,   186,     0,   482,   404,   426,   433,   460,   459,   462,
     461,   458,   448,   454,   456,   457,     0,   414,   420,     0,
     441,     0,   445,   446,   439,   443,   503,   501,   579,   450,
     578,   528,   512,   532,     0,     0,     0,   541,   548,   555,
     558,     0,   556,   557,   554,   552,   551,   541,   547,   593,
     689,   739,   493,     0,     0,   762,     0,   773,   785,   784,
       0,   602,   649,     0,     0,   190,   188,     0,     0,   449,
     421,     0,   411,   477,     0,   452,   548,   541,     0,   536,
       0,   541,     0,   550,   540,     0,   538,   596,   594,   595,
     601,   738,   736,   730,   771,   786,   709,     0,   187,     0,
       0,   455,   413,   417,   453,   572,   530,   531,   541,   535,
       0,   533,   559,   553,   539,   603,   773,   186,   189,   176,
     191,   193,     0,   537,   541,   493,     0,   787,     0,     0,
     415,   534,     0,   592,   183,   192,   604
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1025, -1025,   862, -1025, -1025, -1025, -1025, -1025,   242, -1025,
     228,  -138,   526, -1025, -1025, -1025, -1025, -1025, -1025, -1025,
   -1025, -1025, -1025,  -206, -1025, -1025, -1025, -1025, -1025, -1025,
   -1025,  -146,  -341,    59,  -175, -1025,   849, -1025, -1025, -1025,
     685,   -82, -1025, -1025, -1025, -1025,   262,   261, -1025,  -187,
   -1025, -1025, -1025, -1025, -1025,   267,   430, -1025, -1025,   -56,
   -1025, -1025,   304,  -626,  -493, -1025, -1025,   399, -1025, -1025,
   -1025, -1025,  -251,  -267, -1025, -1025,  -277, -1025, -1025, -1025,
      80, -1025, -1025, -1025, -1025,  -169, -1025,   287, -1025,   450,
   -1025, -1025, -1025, -1025, -1025, -1025, -1025,   165, -1025, -1025,
     270, -1025,  -102,  -233, -1025, -1025, -1025, -1025, -1025, -1025,
   -1025, -1025, -1025,    62, -1025, -1025, -1025, -1025, -1025, -1025,
   -1025,   471, -1025, -1025, -1025, -1025, -1025,  -258,   230,    15,
    -431, -1025, -1025, -1025, -1025,     0,   715,   226, -1025, -1025,
   -1025, -1025,   716, -1025, -1025, -1025,  -101,   -64,   533, -1025,
    -351,   534, -1025,  -368,   246,   253,  -567, -1025, -1025,   389,
   -1025, -1025,    76, -1025, -1025, -1025, -1025,  -691,  -230, -1025,
     -54, -1025,    70, -1025, -1025,   -60, -1025, -1025,  -915, -1001,
   -1025,  -188, -1025, -1025, -1025,  -148, -1025,   266, -1025,    89,
   -1025, -1025, -1025, -1025, -1025,   -29, -1025,   730,  -141, -1025,
   -1025, -1025, -1025,   159,    32, -1025, -1025, -1025,    24, -1025,
      34,  -603,   -86, -1025, -1025,  -923,  -629, -1025, -1025,  -193,
    -308,  -941, -1025, -1025, -1025, -1025, -1025, -1025,   -58, -1025,
    -443,  -455, -1025, -1025,   407,   168,    22,  -192, -1025, -1025,
   -1025, -1025, -1025,   130,   -40,  -606,   503, -1025, -1025, -1025,
   -1025, -1025, -1025,     5, -1025, -1025, -1025, -1025,   349,  -615,
   -1025, -1025, -1025, -1025,   237, -1025, -1025, -1025, -1025, -1025,
   -1025, -1025,   480,   -99, -1025, -1025, -1025, -1025, -1025, -1025,
   -1025, -1025, -1025, -1025, -1025,  -117, -1025,  -459, -1025, -1025,
   -1025,  -739,   154,    14, -1025,   535,  -448, -1025, -1025,  -282,
   -1025, -1025, -1025, -1025, -1025, -1025,  -144,  -734, -1025, -1025,
   -1025, -1025, -1025, -1025,  -270, -1025,  -737, -1025,   -69, -1025,
   -1025,   551, -1025,  -957, -1024,   196, -1025, -1025, -1025, -1025,
   -1025, -1025, -1025, -1025, -1025, -1025, -1025, -1025, -1025, -1025,
   -1025, -1025, -1025,   257, -1025, -1025,   258,   259, -1025,   901,
     903
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    85,    86,    87,    88,   385,   418,   556,   557,   584,
     585,   377,   176,    89,    90,    91,    92,   134,   304,    93,
      94,   255,   256,   423,    95,    96,    97,    98,    99,   100,
     101,   270,   455,   302,   309,   102,   260,   103,   404,   417,
     139,   502,   345,   589,   369,   536,   537,   538,   692,   539,
     398,   695,   368,   532,   533,   534,   664,   795,  1020,   898,
     307,   495,   496,   497,   498,   392,   568,   569,  1122,   817,
     911,  1031,  1121,  1183,  1187,  1239,  1240,   373,   104,   437,
     438,   439,   401,   402,   572,   359,   686,   360,   361,   362,
     573,   565,   363,   332,   410,   581,   388,   562,   311,   708,
     709,   814,   909,   316,   381,   553,   379,   550,   555,   810,
     329,   366,   529,   412,   413,   582,   720,   826,   828,   321,
     407,   670,   353,   577,   824,   105,   106,   440,   598,   441,
     596,   729,   108,   109,   241,  1079,   111,   112,   113,   114,
     272,   273,   274,   275,   609,   450,   276,   453,   277,   448,
     278,   279,   446,   457,   614,   602,   603,   604,   605,   606,
     735,   838,   839,   738,   739,  1137,  1192,   740,   934,   935,
     936,  1043,   805,   952,   953,   954,  1048,  1190,  1055,  1142,
    1132,  1133,  1134,  1135,   937,  1056,   955,   784,  1053,   399,
     715,   820,   912,   821,   400,   570,   939,   940,   310,   842,
     843,   844,   845,  1061,   957,   846,   981,   982,   847,   983,
     984,  1080,   985,   511,  1167,  1025,  1081,  1082,  1203,  1165,
     510,  1026,  1027,  1028,   966,   967,  1070,  1071,  1072,   941,
     649,   627,   741,  1210,   674,   886,  1085,  1110,  1246,   115,
     154,   155,   337,   156,   318,   340,   341,   517,   519,   896,
     792,   891,   892,   893,  1015,   675,   676,   677,   678,   679,
     680,   681,   888,   787,   788,   116,   177,   378,   546,   547,
     903,   548,   701,   251,   117,   118,   287,   476,   477,   639,
     282,   469,   470,   633,  1090,   634,   485,   424,   647,   864,
     648,   771,   879,   772,   660,   490,   773,   119,   472,   120,
     992,   121,   471,   990,  1094,  1092,  1093,   635,   122,   123,
     124,   291,   125,   126,   293,   484,   856,   995,  1100,  1004,
     479,   480,   481,   641,   644,   335,   763,   862,  1001,  1104,
    1178,   127,   174,   375,   376,   543,   698,   128,   129,   659,
     298,   487,   652,   653,   654,   655,   656,   657,   130,   131,
     299
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     110,   330,   397,   473,   667,   630,   324,   442,   257,   411,
     389,   599,   297,   297,   420,   107,   474,   280,   626,   347,
     853,   349,   403,   290,   151,   512,   865,   863,   374,   868,
     869,   650,   757,   540,   558,   736,  1057,   380,   651,   780,
     764,   968,   326,  1103,  1083,   583,   841,   988,  1066,   969,
     718,   428,   171,   172,   371,  1219,  1143,   175,   834,   405,
     346,   544,   181,   789,   333,  1147,   253,   586,   454,   327,
     732,   327,   190,   970,  -177,   601,   308,   871,   942,  1179,
     367,   696,   733,   518,   943,   110,   971,   871,   132,   254,
     587,   159,   269,   944,  1159,  1029,   158,   515,   860,   133,
     107,   871,   289,   135,  1188,   972,   973,   974,  1107,   812,
     267,   975,   421,  -551,   855,   945,   946,   734,  1160,   516,
     355,   350,   885,   947,   356,   948,   158,  1006,  1007,   871,
     505,   338,  1009,  1010,   305,   493,  1155,  -551,   588,   266,
     312,  1146,   835,  -177,   976,  1177,  1148,   303,  -170,   158,
     254,  -493,   334,  1215,   506,  1157,  1161,   819,   545,    26,
     977,   334,  1162,   386,   354,   364,  1163,   789,   872,   574,
     427,   978,   672,   271,   451,  -551,   180,   414,   872,   415,
     334,  -551,   254,   271,   760,  -551,   897,   391,  1166,   393,
     513,   357,   872,   382,  1225,   351,   384,  -727,   507,   900,
     158,   158,   508,  1189,  1185,   323,   422,   173,  1220,   331,
     989,   372,  1247,   406,   339,  1198,  1008,   575,   723,   979,
     872,   592,  1022,   328,   358,   328,   719,   980,   871,   836,
     158,  1038,   352,   271,  1195,  1201,   949,   950,   837,   421,
    1106,  1164,   806,   387,   745,   390,   578,   158,   396,   319,
     358,   951,   421,  1127,   394,  1095,   822,  1236,  1128,  1230,
    -551,    67,    68,   158,   785,   493,   673,   425,  1216,   629,
     138,   425,   746,  1226,   393,  1119,   563,   509,   593,   320,
     902,   158,   736,  1129,  1041,  1030,   883,  1022,   395,   258,
    1018,   301,  1086,  -499,   594,    67,    68,   158,   525,   600,
     488,   416,   478,   158,   301,   419,  -499,   942,   673,  -636,
    -499,  1087,   993,   943,   254,   564,  1023,   301,  -486,   872,
     650,   650,   944,  1088,   668,   632,   535,   651,   651,  -700,
     885,   526,  -499,   422,   271,   766,   767,   456,   504,   394,
     768,   579,   580,   259,   945,   946,   422,   616,   158,  1120,
     266,   482,   947,  1170,   948,   636,   558,   348,   804,    67,
      68,   158,   158,   522,   527,  -699,   494,  1130,  1180,   500,
      27,   586,   301,   395,   158,   393,   383,  -499,  1042,   250,
      32,  1023,   673,  -637,   640,    67,    68,   158,    26,    67,
      68,   711,   968,   421,   551,   271,   699,   283,   301,  -700,
     969,   520,   815,   716,  -636,  -636,   521,   314,   703,   315,
    1068,   617,   618,   619,   620,   621,   622,   623,   706,  -486,
     769,   624,  -499,  1022,   970,  1176,   530,   531,   396,   254,
    1022,   818,  -499,   456,   958,  -699,   294,   971,   590,  1212,
     394,   425,   158,   136,   271,   393,   721,   959,  1154,   158,
     284,   960,   285,   295,  1168,   266,   972,   973,   974,   625,
     615,   254,   975,   396,   616,   949,   950,   137,   158,   806,
     250,   266,   456,   961,   395,   710,  1156,   271,  -637,  -637,
     951,   296,  1039,  1200,   894,   429,   294,   422,   783,   153,
     286,   444,   707,   478,   186,   976,  1063,   535,   158,   266,
    1182,   254,  1152,   295,   271,   158,   662,   744,   607,   801,
     394,   977,   271,   271,   770,  1062,   266,  1023,   962,   158,
     722,   314,   978,   315,  1023,   263,   608,   430,   617,   618,
     619,   620,   621,   622,   623,   431,   601,  1205,   624,   355,
     432,    67,    68,   356,   395,   158,  -224,   266,  -362,   433,
     365,   266,   783,   434,  1199,   697,   494,   140,   254,   435,
     956,   807,   254,   963,  1206,   816,   704,   712,   705,  1101,
     979,   687,   456,   964,   682,   683,   625,   339,   436,  1207,
     158,  1208,   987,   612,   358,   689,   342,   459,   460,   613,
     183,   874,   461,   875,  1227,   876,   730,   877,  1231,   731,
    -224,   271,   266,   158,   638,   725,   884,   462,   245,  1209,
     357,   343,  1232,   344,   646,   559,   252,   560,   463,   158,
     889,   559,   710,   560,   561,  1243,   394,   141,   748,  1186,
     831,   358,   833,   264,   906,   158,   717,   464,   854,   878,
     142,  1251,   920,  1102,   762,   456,   752,   143,   753,   465,
     921,   640,   144,   761,   728,    67,    68,   466,   145,   777,
      67,    68,  1184,   693,   694,  1174,   146,   271,   673,   737,
     147,   456,   456,   726,   727,   148,   149,   786,   150,   152,
     157,   467,   160,   161,   162,   163,  1036,   164,   749,   750,
     751,   165,   166,   938,   167,   168,   169,   339,   170,   178,
     179,   182,   184,   185,   923,   339,   187,  -551,   188,   189,
     924,   191,   803,   327,   192,   193,   194,   808,   195,   242,
     243,   244,   778,   246,   925,   247,  1238,   262,   265,  1022,
     832,  -551,   926,  1096,   396,   927,   288,   308,   268,   313,
     928,   929,   281,   292,   317,   358,   322,    22,   325,   930,
     531,   396,   336,   370,   266,   396,   408,   409,   456,   445,
      15,   447,   426,   254,   269,   452,   271,    26,   475,  -551,
     486,   489,   483,   492,   859,  -551,   491,   956,  1184,  -551,
     499,   271,  1077,   458,   870,  1040,   501,   786,   514,   466,
     518,   541,   528,   523,   899,   542,   549,   552,   396,   554,
     566,   567,   571,   576,   158,   595,   851,   524,  1054,   597,
     601,   628,   637,   294,   591,   640,   631,   643,   858,   904,
     658,   905,   663,  1023,   665,   666,   669,   691,   645,   696,
     700,   454,   914,   714,   724,   931,   747,  1108,   494,   756,
     685,   759,   758,   774,   890,   754,  1116,  1091,   765,   775,
     755,   339,   781,   776,  -551,   673,  -814,   493,   790,   791,
     999,   794,   798,   799,   802,    67,    68,   328,   809,   994,
     823,   827,  1078,  1064,   612,  1000,   932,   933,   840,   830,
     866,  1069,   873,   825,   861,   910,   901,   867,   887,   908,
     913,  1003,   915,   916,   922,   991,   917,   996,   918,   919,
     997,  1002,   938,  1005,  1012,   998,  1014,  1017,  1019,  1016,
    1021,  1033,  1059,  1050,  1049,  1058,  1052,  1073,  1084,  1099,
     872,  1109,  1181,  1115,  1117,  1141,  1136,  1172,   855,  1045,
    1151,  1149,  1060,  1191,  1173,  1194,  1196,  1118,  1197,  1193,
    1222,  1139,  1223,  1217,  1046,  1013,  1249,   249,  1245,   811,
     829,  1124,   261,  1250,   797,   339,  1228,   800,   796,  1234,
    1065,   690,  1244,  1114,  1067,  1254,  1237,   713,  1024,   779,
    1248,   396,  1255,   793,  1253,   688,  1034,   907,   813,  1158,
    1035,   443,   671,   852,   857,  1069,   610,  1089,   611,   449,
    1047,  1153,   850,  1242,   743,   849,  1138,  1037,  1044,  1144,
    1221,  1032,  1051,  1123,   965,   848,  1075,  1098,   503,  1074,
    1233,   742,   468,  1150,  1097,  1076,  1112,   986,  1235,   899,
    1145,   684,  1113,   782,   895,   702,   661,  1011,  1211,  1175,
     642,  1091,   880,   300,   881,   882,   306,     0,     0,     0,
       0,     0,     0,     0,  1024,     0,     0,     0,  1131,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1126,     0,
       0,     0,  1105,     0,     0,     0,     0,     0,  1140,     0,
       0,     0,     0,  1111,     0,   938,   890,     0,     0,     0,
    1204,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1125,
       0,     0,     0,     0,  1252,  1171,     0,     0,     0,     0,
       0,     0,     0,     0,  1229,     0,     0,     0,     0,     0,
       0,     0,     0,  1024,     0,     0,     0,     0,  1024,     0,
       0,     0,     0,     0,     0,     0,  1024,  1024,     0,     0,
       0,     0,     0,     0,  1169,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1202,     0,     0,     0,     0,     0,     0,   396,     0,
       0,     0,     0,     0,  1213,     0,     0,     0,     0,     0,
       0,   494,     0,     0,     0,     0,     0,     0,  1131,     0,
    1214,     0,     0,     0,     0,     0,     0,     0,  1218,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   248,     1,     0,     0,  1024,     2,  1024,     3,     0,
       0,     4,     0,     0,     0,     0,     0,     0,     5,  -727,
       6,     7,     0,     0,  1241,     0,     8,     0,     9,     0,
       0,     0,    10,    11,  -727,     0,     0,     0,     0,     0,
      12,     0,     0,  1224,     0,  1024,     0,     0,     0,  1024,
      13,     0,     0,  1241,     0,     0,  1256,    14,    15,     0,
      16,    17,  -302,    18,     0,    19,     0,    20,   494,     0,
       0,    21,    22,    23,    24,    25,     0,  -365,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  -727,    26,  -727,
       0,    27,    28,     0,    29,     0,    30,    31,     0,     0,
       0,    32,     0,    33,    34,    35,     0,     0,     0,     0,
       0,  -365,    36,    37,    38,    39,     0,     0,    40,     0,
       0,  -310,    41,    42,     0,    43,     0,  -727,     0,     0,
       0,    44,    45,    46,     0,    47,     0,     0,    48,    49,
       0,     0,     0,     0,    50,    51,    52,    53,     0,     0,
      54,     0,    55,    56,    57,    58,    59,    60,    61,     0,
      62,     0,    63,     0,     0,     0,     0,    64,    65,     0,
       0,    66,    67,    68,    69,    70,    71,    72,     0,     0,
       0,     0,     0,    73,    74,  -297,     0,    75,     0,     0,
      76,     0,     0,    77,     0,    78,     0,    79,     0,    80,
       1,    81,    82,    83,     2,     0,     3,     0,    84,     4,
       0,     0,     0,     0,     0,     0,     5,  -727,     6,     7,
       0,     0,     0,     0,     8,     0,     9,     0,     0,     0,
      10,    11,  -727,     0,     0,     0,     0,     0,    12,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    13,     0,
       0,     0,     0,     0,     0,    14,    15,     0,    16,    17,
    -302,    18,     0,    19,     0,    20,     0,     0,     0,    21,
      22,    23,    24,    25,     0,  -365,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -727,    26,  -727,     0,    27,
      28,     0,    29,     0,    30,    31,     0,     0,     0,    32,
       0,    33,    34,    35,     0,     0,     0,     0,     0,  -365,
      36,    37,    38,    39,     0,     0,    40,     0,     0,  -310,
      41,    42,     0,    43,     0,  -727,     0,     0,     0,    44,
      45,    46,     0,    47,     0,     0,    48,    49,     0,     0,
       0,     0,    50,    51,    52,    53,     0,     0,    54,     0,
      55,    56,    57,    58,    59,    60,    61,     0,    62,     0,
      63,     0,     0,     0,     0,    64,    65,     0,     0,    66,
      67,    68,    69,    70,    71,    72,     0,     0,     0,     0,
       0,    73,    74,  -297,     0,    75,     0,     0,    76,     0,
       0,    77,     0,    78,     0,    79,     0,    80,   196,    81,
      82,    83,     0,   197,     0,     0,    84,     0,     0,     0,
     198,     0,     0,     0,     0,     0,     0,     0,   199,     0,
     200,     0,     0,     0,     0,   201,     0,     0,     0,     0,
       0,     0,   202,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   203,     0,     0,     0,     0,     0,     0,   204,
       0,     0,   205,   206,     0,   207,     0,     0,     0,     0,
       0,     0,     0,   208,     0,   209,     0,   210,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   211,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   212,     0,   213,   214,     0,     0,
     215,     0,     0,     0,     0,     0,     0,   216,     0,     0,
       0,     0,     0,     0,     0,   217,     0,   218,     0,     0,
     219,   220,     0,     0,     0,     0,   221,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   223,
     224,     0,   225,     0,   226,     0,     0,     0,     0,     0,
     227,     0,     0,     0,     0,     0,   228,   229,   230,     0,
       0,     0,     0,     0,     0,   231,   232,     0,     0,   233,
       0,     0,   234,     0,     0,   235,     0,     0,     0,   236,
       0,   237,     0,   238,     0,   239,     0,     0,     0,     0,
     240
};

static const yytype_int16 yycheck[] =
{
       0,   149,   189,   285,   497,   464,   147,   265,    94,   242,
     185,   442,   129,   130,   247,     0,   286,   116,   461,   160,
     754,   162,   191,   124,    24,   333,   765,   764,   174,   768,
     769,   486,   638,   374,   385,   602,   951,   178,   486,   665,
     646,    18,    14,  1000,   985,   413,   737,    22,   963,    26,
      23,   257,    52,    41,    11,    29,  1057,    57,    27,    41,
     159,    60,    62,   678,   150,  1066,    11,   418,    29,    41,
     154,    41,    72,    50,    18,    92,    35,     8,     6,  1103,
     166,    29,   166,    29,    12,    85,    63,     8,   104,   127,
      79,    32,    76,    21,    13,    88,   110,    13,    88,    52,
      85,     8,    11,    52,    29,    82,    83,    84,    29,   147,
     110,    88,    35,    13,    60,    43,    44,   201,    37,    35,
      30,    12,   139,    51,    34,    53,   110,   866,   867,     8,
      13,    11,   871,   872,   134,   128,  1077,    37,   127,   129,
     140,  1064,   111,    87,   121,  1102,  1069,   133,    11,   110,
     127,   110,   152,  1177,    37,  1078,    75,    80,   157,    87,
     137,   161,    81,   177,   164,   165,    85,   782,    99,   402,
     256,   148,   513,   114,   275,    75,    52,    79,    99,    81,
     180,    81,   127,   124,   643,    85,   792,   187,    88,    36,
     336,   101,    99,   179,  1195,    86,   182,   125,    81,   147,
     110,   110,    85,   128,    11,   146,   129,   195,   182,   150,
     185,   168,  1236,   195,   155,  1156,   147,   404,   586,   196,
      99,   427,    35,   195,   165,   195,   199,   204,     8,   198,
     110,   922,   123,   174,  1149,  1158,   164,   165,   207,    35,
     147,   160,   701,   184,   612,   186,    11,   110,   189,    20,
     191,   179,    35,    35,   101,   989,   715,  1214,    40,  1200,
     160,   171,   172,   110,    76,   128,    75,   253,   147,    52,
     118,   257,   613,  1196,    36,    20,    42,   160,    13,    50,
      16,   110,   849,    65,    35,   911,   779,    35,   135,   104,
     896,    40,    78,    52,    29,   171,   172,   110,   129,   445,
     300,   203,   288,   110,    40,   246,    65,     6,    75,    76,
      69,    97,    35,    12,   127,    81,   129,    40,    80,    99,
     775,   776,    21,   109,   499,   466,    88,   775,   776,    40,
     139,   162,    91,   129,   275,     3,     4,   278,   324,   101,
       8,   106,   107,   158,    43,    44,   129,    15,   110,    94,
     129,   292,    51,  1090,    53,   472,   707,   161,   699,   171,
     172,   110,   110,   349,   364,    40,   307,   149,  1107,   310,
      90,   722,    40,   135,   110,    36,   180,   136,   129,   158,
     100,   129,    75,    76,    88,   171,   172,   110,    87,   171,
     172,   566,    18,    35,   380,   336,   542,    33,    40,   110,
      26,   342,   710,   572,   171,   172,   347,    79,   549,    81,
     108,    79,    80,    81,    82,    83,    84,    85,   556,    80,
      88,    89,   181,    35,    50,   129,   367,   368,   369,   127,
      35,   713,   191,   374,    52,   110,    88,    63,   424,  1173,
     101,   427,   110,    52,   385,    36,   584,    65,  1077,   110,
      86,    69,    88,   105,  1083,   129,    82,    83,    84,   127,
     460,   127,    88,   404,    15,   164,   165,    52,   110,   928,
     158,   129,   413,    91,   135,   561,    88,   418,   171,   172,
     179,   133,   925,    88,   158,    48,    88,   129,   675,   128,
     126,   104,   556,   479,    88,   121,   162,    88,   110,   129,
     158,   127,   128,   105,   445,   110,   492,   608,   140,   696,
     101,   137,   453,   454,   182,   958,   129,   129,   136,   110,
     584,    79,   148,    81,   129,   184,   158,    90,    79,    80,
      81,    82,    83,    84,    85,    98,    92,  1166,    89,    30,
     103,   171,   172,    34,   135,   110,   104,   129,   104,   112,
     119,   129,   739,   116,  1157,   541,   497,    52,   127,   122,
     842,   702,   127,   181,  1167,   147,   552,   567,   554,   147,
     196,   101,   513,   191,   515,   516,   127,   518,   141,    79,
     110,    81,   852,    29,   525,   526,    54,    47,    48,    35,
      64,    79,    52,    81,  1197,    83,   596,    85,  1201,   599,
     158,   542,   129,   110,   474,   591,   781,    67,    82,   109,
     101,    79,   139,    81,   484,    79,    90,    81,    78,   110,
     127,    79,   708,    81,    88,  1228,   101,    52,   628,  1122,
     729,   572,   731,    61,   809,   110,   577,    97,   755,   127,
      52,  1244,   150,    80,   644,   586,   632,    52,   633,   109,
     158,    88,    52,   169,   595,   171,   172,   117,    52,   659,
     171,   172,  1121,    82,    83,  1096,    52,   608,    75,    76,
      52,   612,   613,   593,   594,    52,    52,   677,    52,    52,
      52,   141,    52,    52,    52,    52,   919,    52,   629,   630,
     631,    52,    52,   841,    52,    52,    52,   638,    52,    52,
      52,    52,    52,    52,    32,   646,    52,    13,    52,    52,
      38,    52,   698,    41,    52,    52,    52,   703,    52,    52,
      52,    52,   663,    52,    52,    52,  1219,    52,   120,    35,
     730,    37,    60,   991,   675,    63,    28,    35,   104,    26,
      68,    69,   104,    88,   128,   686,    57,    71,    61,    77,
     691,   692,   197,   142,   129,   696,   188,   193,   699,    35,
      57,    28,   104,   127,    76,    13,   707,    87,    18,    75,
     204,   110,    98,    29,   760,    81,    40,  1059,  1237,    85,
      29,   722,    88,   104,   770,   926,    79,   787,    28,   117,
      29,    28,   115,   123,   794,   185,    29,    29,   739,    29,
      29,    29,    80,   206,   110,    88,   747,   129,   949,    61,
      92,    52,    18,    88,   162,    88,    52,    76,   759,   805,
      58,   807,    35,   129,    29,    11,   206,    29,   147,    29,
      52,    29,   832,    40,    24,   163,    40,  1012,   779,   147,
     158,    35,    45,    40,   785,   185,  1021,   988,    29,    29,
     185,   792,    29,    52,   160,    75,    52,   128,   158,   128,
     860,    88,    83,    82,   158,   171,   172,   195,    29,   855,
     187,    23,   178,   959,    29,   861,   204,   205,    35,   147,
      88,   967,    40,   199,   180,    18,   158,    88,    83,   178,
     104,     9,   104,    52,   140,   204,    52,    46,    52,    52,
     147,   158,  1050,   147,    29,   140,    35,    29,    29,   140,
      29,    26,    29,   158,   140,   158,   204,    83,   128,    55,
      99,    29,  1109,   147,    35,   185,    40,    29,    60,   929,
     147,   149,   125,    40,   185,   201,   147,   129,   147,   128,
      40,   166,    76,   185,   930,   886,    29,    85,   164,   707,
     722,  1033,   103,   140,   692,   896,   147,   696,   691,   147,
     960,   531,   147,  1019,   964,   147,  1217,   568,   909,   665,
    1237,   912,  1249,   686,   158,   525,   917,   812,   708,  1081,
     918,   266,   511,   753,   758,  1071,   453,   987,   454,   273,
     931,  1077,   746,  1223,   605,   742,  1050,   921,   928,  1059,
    1188,   912,   943,  1032,   845,   739,   982,   993,   323,   975,
    1203,   604,   282,  1071,   992,   983,  1016,   849,  1210,  1019,
    1060,   518,  1017,   674,   787,   545,   491,   873,  1172,  1098,
     479,  1172,   775,   130,   776,   776,   135,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   985,    -1,    -1,    -1,  1048,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1044,    -1,
      -1,    -1,  1003,    -1,    -1,    -1,    -1,    -1,  1054,    -1,
      -1,    -1,    -1,  1014,    -1,  1223,  1017,    -1,    -1,    -1,
    1166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1040,
      -1,    -1,    -1,    -1,  1245,  1091,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1200,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1064,    -1,    -1,    -1,    -1,  1069,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1077,  1078,    -1,    -1,
      -1,    -1,    -1,    -1,  1085,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1161,    -1,    -1,    -1,    -1,    -1,    -1,  1109,    -1,
      -1,    -1,    -1,    -1,  1174,    -1,    -1,    -1,    -1,    -1,
      -1,  1122,    -1,    -1,    -1,    -1,    -1,    -1,  1188,    -1,
    1176,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1184,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     0,     1,    -1,    -1,  1156,     5,  1158,     7,    -1,
      -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,
      19,    20,    -1,    -1,  1220,    -1,    25,    -1,    27,    -1,
      -1,    -1,    31,    32,    33,    -1,    -1,    -1,    -1,    -1,
      39,    -1,    -1,  1194,    -1,  1196,    -1,    -1,    -1,  1200,
      49,    -1,    -1,  1249,    -1,    -1,  1252,    56,    57,    -1,
      59,    60,    61,    62,    -1,    64,    -1,    66,  1219,    -1,
      -1,    70,    71,    72,    73,    74,    -1,    76,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    86,    87,    88,
      -1,    90,    91,    -1,    93,    -1,    95,    96,    -1,    -1,
      -1,   100,    -1,   102,   103,   104,    -1,    -1,    -1,    -1,
      -1,   110,   111,   112,   113,   114,    -1,    -1,   117,    -1,
      -1,   120,   121,   122,    -1,   124,    -1,   126,    -1,    -1,
      -1,   130,   131,   132,    -1,   134,    -1,    -1,   137,   138,
      -1,    -1,    -1,    -1,   143,   144,   145,   146,    -1,    -1,
     149,    -1,   151,   152,   153,   154,   155,   156,   157,    -1,
     159,    -1,   161,    -1,    -1,    -1,    -1,   166,   167,    -1,
      -1,   170,   171,   172,   173,   174,   175,   176,    -1,    -1,
      -1,    -1,    -1,   182,   183,   184,    -1,   186,    -1,    -1,
     189,    -1,    -1,   192,    -1,   194,    -1,   196,    -1,   198,
       1,   200,   201,   202,     5,    -1,     7,    -1,   207,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    27,    -1,    -1,    -1,
      31,    32,    33,    -1,    -1,    -1,    -1,    -1,    39,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,    -1,
      -1,    -1,    -1,    -1,    -1,    56,    57,    -1,    59,    60,
      61,    62,    -1,    64,    -1,    66,    -1,    -1,    -1,    70,
      71,    72,    73,    74,    -1,    76,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    86,    87,    88,    -1,    90,
      91,    -1,    93,    -1,    95,    96,    -1,    -1,    -1,   100,
      -1,   102,   103,   104,    -1,    -1,    -1,    -1,    -1,   110,
     111,   112,   113,   114,    -1,    -1,   117,    -1,    -1,   120,
     121,   122,    -1,   124,    -1,   126,    -1,    -1,    -1,   130,
     131,   132,    -1,   134,    -1,    -1,   137,   138,    -1,    -1,
      -1,    -1,   143,   144,   145,   146,    -1,    -1,   149,    -1,
     151,   152,   153,   154,   155,   156,   157,    -1,   159,    -1,
     161,    -1,    -1,    -1,    -1,   166,   167,    -1,    -1,   170,
     171,   172,   173,   174,   175,   176,    -1,    -1,    -1,    -1,
      -1,   182,   183,   184,    -1,   186,    -1,    -1,   189,    -1,
      -1,   192,    -1,   194,    -1,   196,    -1,   198,     5,   200,
     201,   202,    -1,    10,    -1,    -1,   207,    -1,    -1,    -1,
      17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    25,    -1,
      27,    -1,    -1,    -1,    -1,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    59,    60,    -1,    62,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    70,    -1,    72,    -1,    74,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,    -1,   113,   114,    -1,    -1,
     117,    -1,    -1,    -1,    -1,    -1,    -1,   124,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   132,    -1,   134,    -1,    -1,
     137,   138,    -1,    -1,    -1,    -1,   143,   144,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   156,
     157,    -1,   159,    -1,   161,    -1,    -1,    -1,    -1,    -1,
     167,    -1,    -1,    -1,    -1,    -1,   173,   174,   175,    -1,
      -1,    -1,    -1,    -1,    -1,   182,   183,    -1,    -1,   186,
      -1,    -1,   189,    -1,    -1,   192,    -1,    -1,    -1,   196,
      -1,   198,    -1,   200,    -1,   202,    -1,    -1,    -1,    -1,
     207
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     1,     5,     7,    10,    17,    19,    20,    25,    27,
      31,    32,    39,    49,    56,    57,    59,    60,    62,    64,
      66,    70,    71,    72,    73,    74,    87,    90,    91,    93,
      95,    96,   100,   102,   103,   104,   111,   112,   113,   114,
     117,   121,   122,   124,   130,   131,   132,   134,   137,   138,
     143,   144,   145,   146,   149,   151,   152,   153,   154,   155,
     156,   157,   159,   161,   166,   167,   170,   171,   172,   173,
     174,   175,   176,   182,   183,   186,   189,   192,   194,   196,
     198,   200,   201,   202,   207,   209,   210,   211,   212,   221,
     222,   223,   224,   227,   228,   232,   233,   234,   235,   236,
     237,   238,   243,   245,   286,   333,   334,   337,   340,   341,
     343,   344,   345,   346,   347,   447,   473,   482,   483,   505,
     507,   509,   516,   517,   518,   520,   521,   539,   545,   546,
     556,   557,   104,    52,   225,    52,    52,    52,   118,   248,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,   343,    52,   128,   448,   449,   451,    52,   110,   241,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,   343,    41,   195,   540,   343,   220,   474,    52,    52,
      52,   343,    52,   220,    52,    52,    88,    52,    52,    52,
     343,    52,    52,    52,    52,    52,     5,    10,    17,    25,
      27,    32,    39,    49,    56,    59,    60,    62,    70,    72,
      74,    93,   111,   113,   114,   117,   124,   132,   134,   137,
     138,   143,   144,   156,   157,   159,   161,   167,   173,   174,
     175,   182,   183,   186,   189,   192,   196,   198,   200,   202,
     207,   342,    52,    52,    52,   220,    52,    52,     0,   210,
     158,   481,   220,    11,   127,   229,   230,   420,   104,   158,
     244,   244,    52,   184,    61,   120,   129,   343,   104,    76,
     239,   241,   348,   349,   350,   351,   354,   356,   358,   359,
     481,   104,   488,    33,    86,    88,   126,   484,    28,    11,
     354,   519,    88,   522,    88,   105,   133,   493,   548,   558,
     558,    40,   241,   501,   226,   343,   557,   268,    35,   242,
     406,   306,   343,    26,    79,    81,   311,   128,   452,    20,
      50,   327,    57,   241,   406,    61,    14,    41,   195,   318,
     393,   241,   301,   420,   343,   533,   197,   450,    11,   241,
     453,   454,    54,    79,    81,   250,   481,   406,   533,   406,
      12,    86,   123,   330,   343,    30,    34,   101,   241,   293,
     295,   296,   297,   300,   343,   119,   319,   420,   260,   252,
     142,    11,   168,   285,   239,   541,   542,   219,   475,   314,
     406,   312,   501,   533,   501,   213,   177,   241,   304,   242,
     241,   343,   273,    36,   101,   135,   241,   257,   258,   397,
     402,   290,   291,   293,   246,    41,   195,   328,   188,   193,
     302,   311,   321,   322,    79,    81,   203,   247,   214,   241,
     311,    35,   129,   231,   495,   501,   104,   420,   231,    48,
      90,    98,   103,   112,   116,   122,   141,   287,   288,   289,
     335,   337,   335,   344,   104,    35,   360,    28,   357,   350,
     353,   354,    13,   355,    29,   240,   241,   361,   104,    47,
      48,    52,    67,    78,    97,   109,   117,   141,   405,   489,
     490,   510,   506,   507,   522,    18,   485,   486,   501,   528,
     529,   530,   241,    98,   523,   494,   204,   549,   343,   110,
     503,    40,    29,   128,   241,   269,   270,   271,   272,    29,
     241,    79,   249,   248,   501,    13,    37,    81,    85,   160,
     428,   421,   428,   239,    28,    13,    35,   455,    29,   456,
     241,   241,   501,   123,   129,   129,   162,   343,   115,   320,
     241,   241,   261,   262,   263,    88,   253,   254,   255,   257,
     240,    28,   185,   543,    60,   157,   476,   477,   479,    29,
     315,   501,    29,   313,    29,   316,   215,   216,   358,    79,
      81,    88,   305,    42,    81,   299,    29,    29,   274,   275,
     403,    80,   292,   298,   311,   257,   206,   331,    11,   106,
     107,   303,   323,   361,   217,   218,   358,    79,   127,   251,
     501,   162,   231,    13,    29,    88,   338,    61,   336,   338,
     239,    92,   363,   364,   365,   366,   367,   140,   158,   352,
     356,   359,    29,    35,   362,   343,    15,    79,    80,    81,
      82,    83,    84,    85,    89,   127,   438,   439,    52,    52,
     495,    52,   406,   491,   493,   515,   493,    18,   451,   487,
      88,   531,   529,    76,   532,   147,   451,   496,   498,   438,
     439,   504,   550,   551,   552,   553,   554,   555,    58,   547,
     502,   503,   501,    35,   264,    29,    11,   272,   242,   206,
     329,   329,   240,    75,   442,   463,   464,   465,   466,   467,
     468,   469,   241,   241,   454,   158,   294,   101,   297,   241,
     264,    29,   256,    82,    83,   259,    29,   501,   544,   239,
      52,   480,   480,   406,   501,   501,   219,   355,   307,   308,
     420,   242,   343,   275,    40,   398,   293,   241,    23,   199,
     324,   219,   355,   361,    24,   501,   288,   288,   241,   339,
     343,   343,   154,   166,   201,   368,   364,    76,   371,   372,
     375,   440,   442,   367,   354,   361,   240,    40,   343,   241,
     241,   241,   501,   337,   185,   185,   147,   453,    45,    35,
     495,   169,   343,   534,   453,    29,     3,     4,     8,    88,
     182,   499,   501,   504,    40,    29,    52,   343,   241,   270,
     271,    29,   466,   257,   395,    76,   343,   471,   472,   467,
     158,   128,   458,   295,    88,   265,   263,   254,    83,    82,
     255,   257,   158,   501,   240,   380,   495,   406,   501,    29,
     317,   216,   147,   308,   309,   428,   147,   277,   507,    80,
     399,   401,   495,   187,   332,   199,   325,    23,   326,   218,
     147,   481,   343,   481,    27,   111,   198,   207,   369,   370,
      35,   375,   407,   408,   409,   410,   413,   416,   395,   363,
     362,   241,   336,   515,   493,    60,   524,   345,   241,   501,
      88,   180,   535,   524,   497,   499,    88,    88,   499,   499,
     501,     8,    99,    40,    79,    81,    83,    85,   127,   500,
     551,   554,   555,   272,   242,   139,   443,    83,   470,   127,
     241,   459,   460,   461,   158,   472,   457,   453,   267,   343,
     147,   158,    16,   478,   501,   501,   242,   305,   178,   310,
      18,   278,   400,   104,   343,   104,    52,    52,    52,    52,
     150,   158,   140,    32,    38,    52,    60,    63,    68,    69,
      77,   163,   204,   205,   376,   377,   378,   392,   393,   404,
     405,   437,     6,    12,    21,    43,    44,    51,    53,   164,
     165,   179,   381,   382,   383,   394,   507,   412,    52,    65,
      69,    91,   136,   181,   191,   411,   432,   433,    18,    26,
      50,    63,    82,    83,    84,    88,   121,   137,   148,   196,
     204,   414,   415,   417,   418,   420,   443,   522,    22,   185,
     511,   204,   508,    35,   501,   525,    46,   147,   140,   343,
     501,   536,   158,     9,   527,   147,   499,   499,   147,   499,
     499,   500,    29,   241,    35,   462,   140,    29,   453,    29,
     266,    29,    35,   129,   241,   423,   429,   430,   431,    88,
     271,   279,   397,    26,   241,   321,   311,   370,   375,   438,
     406,    35,   129,   379,   380,   343,   501,   241,   384,   140,
     158,   241,   204,   396,   406,   386,   393,   386,   158,    29,
     125,   411,   438,   162,   420,   343,   386,   343,   108,   420,
     434,   435,   436,    83,   418,   416,   412,    88,   178,   343,
     419,   424,   425,   429,   128,   444,    78,    97,   109,   343,
     492,   406,   513,   514,   512,   515,   335,   444,   501,    55,
     526,   147,    80,   531,   537,   241,   147,    29,   242,    29,
     445,   241,   343,   461,   267,   147,   242,    35,   129,    20,
      94,   280,   276,   403,   249,   241,   501,    35,    40,    65,
     149,   343,   388,   389,   390,   391,    40,   373,   378,   166,
     501,   185,   387,   387,   383,   452,   423,   387,   423,   149,
     436,   147,   128,   420,   424,   429,    88,   423,   310,    13,
      37,    75,    81,    85,   160,   427,    88,   422,   424,   241,
     524,   501,    29,   185,   338,   526,   129,   531,   538,   532,
     499,   257,   158,   281,   495,    11,   272,   282,    29,   128,
     385,    40,   374,   128,   201,   386,   147,   147,   429,   419,
      88,   423,   343,   426,   420,   424,   419,    79,    81,   109,
     441,   514,   515,   343,   501,   532,   147,   185,   501,    29,
     182,   389,    40,    76,   241,   387,   423,   419,   147,   420,
     429,   419,   139,   427,   147,   445,   531,   280,   272,   283,
     284,   501,   376,   419,   147,   164,   446,   532,   281,    29,
     140,   419,   406,   158,   147,   284,   501
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   208,   209,   209,   210,   210,   210,   210,   210,   210,
     210,   210,   210,   210,   210,   210,   211,   211,   211,   211,
     211,   211,   211,   211,   211,   211,   212,   213,   212,   214,
     212,   215,   215,   216,   217,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   229,   230,
     230,   231,   231,   231,   232,   233,   234,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   244,   245,
     245,   245,   245,   245,   245,   245,   245,   245,   245,   245,
     245,   245,   245,   245,   245,   245,   245,   245,   245,   245,
     245,   245,   245,   245,   245,   245,   245,   245,   245,   245,
     245,   246,   245,   245,   245,   245,   245,   245,   245,   245,
     245,   245,   245,   245,   245,   245,   245,   245,   245,   245,
     247,   247,   247,   248,   248,   249,   249,   250,   250,   250,
     251,   251,   251,   252,   253,   253,   254,   254,   254,   254,
     256,   255,   257,   257,   258,   258,   259,   259,   259,   259,
     259,   260,   261,   261,   262,   262,   263,   264,   264,   265,
     265,   266,   266,   267,   268,   269,   269,   269,   269,   269,
     270,   270,   271,   272,   273,   274,   274,   275,   276,   277,
     278,   279,   279,   279,   280,   280,   281,   281,   282,   282,
     282,   283,   283,   284,   285,   285,   286,   287,   287,   287,
     288,   289,   289,   289,   289,   289,   289,   289,   289,   290,
     291,   292,   291,   293,   294,   293,   295,   295,   295,   295,
     295,   296,   296,   297,   298,   298,   299,   299,   300,   300,
     300,   300,   301,   301,   302,   303,   303,   303,   303,   304,
     304,   304,   304,   305,   305,   305,   306,   306,   307,   307,
     308,   309,   309,   310,   310,   311,   311,   312,   313,   313,
     314,   315,   315,   316,   316,   317,   317,   318,   318,   319,
     319,   320,   320,   322,   321,   323,   323,   324,   324,   324,
     325,   325,   326,   326,   327,   327,   328,   328,   329,   329,
     330,   330,   330,   331,   332,   332,   333,   334,   334,   335,
     336,   336,   337,   337,   338,   338,   339,   339,   339,   340,
     341,   341,   342,   342,   342,   342,   342,   342,   342,   342,
     342,   342,   342,   342,   342,   342,   342,   342,   342,   342,
     342,   342,   342,   342,   342,   342,   342,   342,   342,   342,
     342,   342,   342,   342,   342,   342,   342,   342,   342,   342,
     342,   342,   342,   342,   342,   342,   342,   343,   343,   344,
     344,   345,   346,   346,   346,   347,   348,   348,   349,   349,
     350,   351,   352,   353,   353,   354,   354,   355,   356,   356,
     357,   358,   358,   359,   360,   360,   361,   361,   362,   362,
     363,   363,   364,   364,   365,   365,   366,   366,   367,   368,
     368,   368,   369,   369,   370,   370,   370,   370,   371,   372,
     372,   372,   373,   373,   374,   374,   375,   376,   376,   377,
     377,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,   379,   379,   379,   380,   380,   381,   381,   382,   382,
     383,   383,   383,   383,   383,   383,   383,   384,   385,   385,
     386,   386,   387,   387,   388,   388,   389,   390,   390,   391,
     391,   391,   391,   392,   392,   392,   392,   393,   393,   394,
     394,   394,   394,   394,   395,   395,   396,   396,   397,   397,
     398,   398,   399,   400,   401,   401,   402,   402,   402,   403,
     403,   404,   405,   406,   406,   407,   407,   408,   409,   410,
     411,   411,   411,   411,   411,   411,   411,   411,   412,   412,
     413,   414,   414,   415,   416,   416,   417,   417,   417,   417,
     417,   417,   417,   417,   417,   417,   417,   417,   417,   418,
     418,   418,   418,   418,   418,   418,   418,   418,   418,   418,
     418,   419,   419,   420,   421,   421,   422,   422,   423,   423,
     424,   425,   426,   426,   427,   427,   427,   427,   427,   427,
     428,   428,   428,   428,   428,   429,   429,   429,   430,   430,
     431,   431,   432,   433,   434,   434,   434,   435,   435,   436,
     437,   438,   438,   438,   438,   438,   438,   438,   438,   438,
     438,   439,   440,   441,   441,   441,   441,   442,   443,   444,
     444,   445,   445,   446,   446,   447,   448,   449,   450,   450,
     450,   451,   451,   452,   452,   453,   453,   453,   454,   455,
     455,   455,   456,   457,   456,   458,   456,   459,   459,   460,
     460,   461,   462,   462,   463,   464,   465,   465,   466,   466,
     467,   468,   468,   469,   470,   470,   471,   471,   472,   472,
     473,   473,   473,   474,   473,   473,   473,   473,   475,   475,
     476,   476,   477,   478,   478,   479,   480,   480,   481,   481,
     482,   482,   483,   484,   484,   485,   486,   487,   487,   488,
     488,   489,   489,   489,   489,   489,   489,   489,   489,   489,
     490,   490,   491,   492,   492,   492,   492,   493,   494,   495,
     495,   496,   497,   498,   499,   499,   499,   499,   499,   499,
     499,   499,   499,   500,   500,   500,   500,   500,   501,   501,
     501,   502,   502,   503,   504,   505,   506,   507,   507,   508,
     508,   509,   510,   511,   511,   512,   512,   513,   513,   514,
     515,   516,   517,   517,   517,   518,   519,   519,   520,   521,
     521,   521,   521,   521,   521,   522,   522,   523,   523,   524,
     524,   525,   525,   526,   526,   527,   527,   528,   528,   529,
     530,   531,   531,   532,   532,   533,   533,   534,   534,   534,
     534,   535,   535,   536,   537,   537,   538,   538,   539,   540,
     540,   540,   541,   542,   542,   543,   543,   543,   544,   544,
     545,   545,   546,   547,   547,   548,   548,   549,   549,   550,
     550,   551,   551,   552,   553,   554,   554,   555,   555,   556,
     556,   557,   558,   558,   558
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     2,     1,     1,     1,     1,     2,
       1,     1,     2,     3,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     3,     0,     5,     0,
       5,     1,     3,     1,     1,     3,     2,     0,     0,     2,
       1,     1,     3,     0,     1,     3,     1,     2,     1,     2,
       3,     3,     1,     3,     2,     1,     2,     2,     3,     1,
       2,     2,     1,     1,     1,     2,     2,     1,     1,     4,
       2,     4,     4,     5,     4,     3,     4,     3,     4,     4,
       5,     4,     4,     4,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     4,     3,     3,     3,     3,     3,
       2,     0,     4,     3,     4,     4,     3,     3,     3,     6,
       3,     3,     3,     3,     3,     3,     3,     3,     9,     5,
       1,     1,     1,     0,     1,     0,     1,     1,     1,     2,
       0,     1,     1,     0,     0,     1,     1,     1,     3,     3,
       0,     4,     4,     2,     0,     1,     0,     2,     2,     1,
       1,     0,     0,     1,     1,     3,     3,     0,     2,     0,
       4,     0,     2,     1,     0,     0,     1,     4,     2,     2,
       0,     1,     1,     2,     0,     1,     9,     0,     0,     1,
       1,     0,     1,     7,     1,     1,     0,     2,     1,     3,
       1,     1,     3,     1,     1,     1,     1,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     0,     3,     1,     0,     4,     1,     1,     3,     3,
       1,     1,     3,     1,     0,     1,     0,     1,     0,     1,
       1,     2,     3,     3,     2,     0,     1,     1,     1,     2,
       2,     2,     5,     0,     1,     1,     0,     1,     1,     2,
       4,     0,     1,     0,     1,     1,     1,     1,     0,     2,
       2,     0,     3,     0,     3,     0,     4,     1,     1,     1,
       2,     0,     1,     0,     2,     0,     2,     0,     2,     2,
       0,     1,     0,     1,     1,     1,     1,     1,     0,     1,
       1,     2,     1,     1,     0,     1,     7,     0,     1,     2,
       0,     1,     0,     1,     0,     3,     1,     2,     3,     7,
       0,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       6,     2,     4,     3,     1,     0,     1,     1,     1,     2,
       3,     1,     1,     1,     3,     1,     3,     1,     1,     2,
       1,     1,     3,     2,     0,     2,     2,     4,     0,     2,
       1,     2,     2,     5,     0,     1,     1,     2,     4,     1,
       1,     1,     1,     3,     4,     3,     3,     3,     2,     1,
       4,     6,     0,     3,     0,     4,     0,     0,     1,     1,
       3,     4,     1,     1,     1,     1,     3,     2,     2,     2,
       2,     1,     1,     2,     0,     1,     0,     1,     1,     3,
       1,     3,     2,     3,     1,     3,     3,     0,     0,     1,
       0,     1,     0,     3,     1,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     0,     1,     0,     3,     1,     1,
       0,     2,     4,     0,     0,     1,     0,     1,     1,     0,
       2,     1,     3,     0,     1,     1,     1,     2,     2,     0,
       1,     3,     2,     3,     2,     2,     2,     1,     0,     2,
       2,     0,     3,     1,     0,     3,     1,     1,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     2,
       5,     5,     3,     5,     7,     5,     4,     6,     4,     5,
       4,     0,     1,     1,     0,     1,     0,     1,     0,     1,
       3,     0,     0,     2,     1,     1,     1,     1,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     2,     5,     1,     0,     1,     1,     1,     2,     2,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     9,     0,     1,     1,     1,     1,     1,     0,
       1,     0,     2,     0,     3,     5,     3,     1,     0,     2,
       3,     0,     1,     0,     1,     1,     1,     3,     2,     0,
       2,     2,     0,     0,     5,     0,     4,     1,     1,     1,
       3,     2,     0,     2,     0,     2,     0,     1,     1,     2,
       2,     3,     1,     5,     0,     1,     1,     2,     2,     5,
       2,     1,     1,     0,     3,     1,     1,     1,     0,     2,
       1,     1,     4,     1,     1,     4,     0,     1,     0,     1,
       1,     1,     3,     0,     4,     2,     1,     0,     4,     0,
       2,     1,     2,     1,     1,     3,     3,     3,     3,     7,
       2,     1,     0,     1,     1,     1,     1,     6,     0,     1,
       1,     2,     1,     0,     3,     3,     3,     2,     4,     6,
       1,     3,     2,     1,     1,     1,     1,     1,     1,     3,
       2,     0,     1,     1,     1,     8,     0,     0,     1,     0,
       4,     7,     0,     2,     2,     1,     3,     1,     3,     2,
       1,     3,     7,     6,     2,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     1,     0,     3,     0,     1,     0,
       2,     2,     3,     0,     1,     0,     2,     1,     2,     5,
       2,     0,     4,     0,     4,     0,     1,     0,     1,     1,
       4,     0,     2,     2,     2,     2,     2,     4,     5,     0,
       1,     1,     2,     1,     2,     0,     2,     3,     2,     3,
       3,     5,     1,     0,     1,     1,     1,     0,     2,     1,
       3,     1,     1,     3,     1,     1,     1,     1,     3,     1,
       1,     1,     0,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 14:
#line 635 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* for blank lines -- nothing to do */
	}
#line 2847 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 641 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* to keep going after stumbling on an input error */
		Getting_tup_dur = NO;
		Good_till_canceled = NO;
		Defining_multiple = NO;
		Doing_vcombine = NO;
		Curr_grpsyl_p = (struct GRPSYL *) 0;
		Last_grpsyl_p = (struct GRPSYL *) 0;
		Prev_grpsyl_p = (struct GRPSYL *) 0;
	}
#line 2862 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 653 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* fill in context field of the SSV struct */
		Currstruct_p->u.ssv_p->context = (short) Context;
	}
#line 2871 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 660 "src/mup/gram.y" /* yacc.c:1646  */
    {}
#line 2877 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 664 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Curr_family = Score.fontfamily;
	}
#line 2885 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 19:
#line 670 "src/mup/gram.y" /* yacc.c:1646  */
    {}
#line 2891 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 674 "src/mup/gram.y" /* yacc.c:1646  */
    {}
#line 2897 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 678 "src/mup/gram.y" /* yacc.c:1646  */
    {}
#line 2903 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 682 "src/mup/gram.y" /* yacc.c:1646  */
    {}
#line 2909 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 686 "src/mup/gram.y" /* yacc.c:1646  */
    {}
#line 2915 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 690 "src/mup/gram.y" /* yacc.c:1646  */
    {}
#line 2921 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 694 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* have lots of separate structs in music context, so
		 * mark that we have no current struct */
		Currstruct_p = (struct MAINLL *) 0;

		/* make sure at least 1 staff is visible. Not good to
		 * check when user sets visible, because it would be
		 * nice to first set everything invisible and later
		 * turn one on. So if we wait till now to check,
		 * user doesn't have to switch back and forth from
		 * score to staff to get 1 voice visible. */
		check_at_least1visible();
	}
#line 2939 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 709 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Context = C_SCORE;
		Curr_font = svpath(0, FONT)->font;
		Curr_family = svpath(0, FONTFAMILY)->fontfamily;
		Curr_size = svpath(0, SIZE)->size;
	}
#line 2950 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 717 "src/mup/gram.y" /* yacc.c:1646  */
    { begin_range(PL_UNKNOWN); }
#line 2956 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 718 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Make sure all the staffs are in range */
		chk_ssv_ranges(C_STAFF);

		/* Set current SSV's staff to the first one on the list.
		 * If there is more than one, we will clone the SSV later.
		 * Note that it is possible that the staff number the user
		 * specified is actually illegal, but we will use it anyway,
		 * because it keeps the code simpler to pretend all is well,
		 * and ssv.c code will ignore such illegal SSVs anyway.
		 */
		if (Svrangelist_p != 0 && Svrangelist_p->stafflist_p != 0) {
			Currstruct_p->u.ssv_p->staffno
					= Svrangelist_p->stafflist_p->begin;
		}
		Context = C_STAFF;
	}
#line 2978 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 737 "src/mup/gram.y" /* yacc.c:1646  */
    { begin_range(PL_UNKNOWN); }
#line 2984 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 738 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Make sure all the staffs and voices are in range */
		chk_ssv_ranges(C_VOICE);

		/* Set current SSV's staff/voice to the first one on the list.
		 * If there are more than, we will clone the SSV later */
		if (Svrangelist_p != 0 && Svrangelist_p->stafflist_p != 0) {
			Currstruct_p->u.ssv_p->staffno
					= Svrangelist_p->stafflist_p->begin;
		}
		if (Svrangelist_p != 0 && Svrangelist_p->vnolist_p != 0) {
			Currstruct_p->u.ssv_p->voiceno
					= Svrangelist_p->vnolist_p->begin;
		}
		Context = C_VOICE;
	}
#line 3005 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 762 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_to_sv_list();
	}
#line 3013 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 772 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_to_sv_list();
	}
#line 3021 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 777 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* allocate an SSV struct */
		Currstruct_p = newMAINLLstruct(S_SSV, yylineno);
	}
#line 3030 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 783 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* entering new context, if we have a current struct,
		 * we were in a different context, so add its info to the list */
		end_prev_context();
	}
#line 3040 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 790 "src/mup/gram.y" /* yacc.c:1646  */
    {
		struct FEED *feed_p;		/* where to attach blocks */
		int calloced;			/* YES if dynamically alloced */

		end_prev_context();
		Context = (yyvsp[-1].intval);
		calloced = NO;

		switch ((yyvsp[-1].intval)) {
		case C_HEADER:
			switch ((yyvsp[0].intval)) {
			case PGSIDE_NOT_SET:
				chkdup_headfoot(GOT_HEADER, "header", &Header);
				break;
			case PGSIDE_LEFT:
				chkdup_headfoot(GOT_LHEADER,
					"header leftpage", &Leftheader);
				break;
			case PGSIDE_RIGHT:
				chkdup_headfoot(GOT_RHEADER,
					"header rightpage", &Rightheader);
				break;
			}
			break;

		case C_HEAD2:
			switch ((yyvsp[0].intval)) {
			case PGSIDE_NOT_SET:
				chkdup_headfoot(GOT_HEADER2,
					"header2", &Header2);
				break;
			case PGSIDE_LEFT:
				chkdup_headfoot(GOT_LHEADER2,
					"header2 leftpage", &Leftheader2);
				break;
			case PGSIDE_RIGHT:
				chkdup_headfoot(GOT_RHEADER2,
					"header2 rightpage", &Rightheader2);
				break;
			}
			break;
		case C_FOOTER:
			switch ((yyvsp[0].intval)) {
			case PGSIDE_NOT_SET:
				chkdup_headfoot(GOT_FOOTER,
					"footer", &Footer); 
				break;
			case PGSIDE_LEFT:
				chkdup_headfoot(GOT_LFOOTER,
					"footer leftpage", &Leftfooter);
				break;
			case PGSIDE_RIGHT:
				chkdup_headfoot(GOT_RFOOTER,
					"footer rightpage", &Rightfooter);
				break;
			}
			break;
		case C_FOOT2:
			switch ((yyvsp[0].intval)) {
			case PGSIDE_NOT_SET:
				chkdup_headfoot(GOT_FOOTER2,
					"footer2", &Footer2);
				break;
			case PGSIDE_LEFT:
				chkdup_headfoot(GOT_LFOOTER2,
					"footer2 leftpage", &Leftfooter2);
				break;
			case PGSIDE_RIGHT:
				chkdup_headfoot(GOT_RFOOTER2,
					"footer2 rightpage", &Rightfooter2);
				break;
			}
			break;
		case C_TOP:
		case C_TOP2:
		case C_BOT:
		case C_BOT2:
		case C_BLOCK:
			CALLOC(BLOCKHEAD, Currblock_p, 1);
			calloced = YES;
			break;
		default:
			pfatal("Unknown block-type context");
			/*NOTREACHED*/
			break;
		}
		set_win_coord(Currblock_p->c);
		/* Remember where to start attaching "print" commands */
		Next_print_link_p_p = &(Currblock_p->printdata_p);

		/* The dynamically allocated blocks
		 * (not the static head/foot blocks)
		 * need extra processing to populate
		 * the main list properly with FEEDs.
		 */
		if (calloced == YES) {
			if (Mainlltc_p == 0 || Mainlltc_p->str != S_FEED) {
				/* User had not specified a feed
				 * right before this block, so we need
				 * to add one for them implicitly.
				 * Create a new FEED and add it
				 * to the end of the main list.
				 */
				insertMAINLL(newMAINLLstruct(S_FEED, yylineno),
							Mainlltc_p);
			}
			feed_p = Mainlltc_p->u.feed_p;

			/* Normally, top/top2/bot/bot2 result in a pagefeed.
			 * But we have a special case for backward
			 * compatibility and for flexibility.
			 * User can get a separate
			 * "title" page if they really want to,
			 * by using an explicit newpage at the beginning.
			 * But in the normal case, they'd want to declare
			 * top/bot that will go on the first page without
			 * that causing a newpage. So if there hasn't been
			 * any music or block yet, we won't set newpage=YES
			 * for top/top2/bot/bot2, but otherwise we will.
			 */
			if (Context & (C_TOP|C_TOP2|C_BOT|C_BOT2)) {
				struct MAINLL *m_p;
				for (m_p = Mainlltc_p->prev; m_p != 0;
							m_p = m_p->prev) {
					if (m_p->str == S_BAR ||
							m_p->str == S_BLOCKHEAD) {
						/* There was music or block,
						 * so this is not
						 * at very beginning,
						 * so no special case:
						 * there will be new page.
						 */
						feed_p->pagefeed = YES;
						break;
					}
				}
			}

			/* Now check for redefined blocks and
			 * attach the BLOCKHEAD onto the FEED or the
			 * main list, as appropriate.
			 */
			switch (Context) {
			case C_TOP:
				switch ((yyvsp[0].intval)) {
				case PGSIDE_NOT_SET:
					chkdup_topbot( &(feed_p->top_p),
							"top" );
					break;
				case PGSIDE_LEFT:
					chkdup_topbot( &(feed_p->lefttop_p),
							"top leftpage" );
					break;
				case PGSIDE_RIGHT:
					chkdup_topbot( &(feed_p->righttop_p),
							"top rightpage" );
					break;
				}
				break;
			case C_TOP2:
				switch ((yyvsp[0].intval)) {
				case PGSIDE_NOT_SET:
					chkdup_topbot( &(feed_p->top2_p),
							"top2" );
					break;
				case PGSIDE_LEFT:
					chkdup_topbot( &(feed_p->lefttop2_p),
							"top2 leftpage" );
					break;
				case PGSIDE_RIGHT:
					chkdup_topbot( &(feed_p->righttop2_p),
							"top2 rightpage" );
					break;
				}
				break;
			case C_BOT:
				switch ((yyvsp[0].intval)) {
				case PGSIDE_NOT_SET:
					chkdup_topbot( &(feed_p->bot_p),
							"bot" );
					break;
				case PGSIDE_LEFT:
					chkdup_topbot( &(feed_p->leftbot_p),
							"bot leftpage" );
					break;
				case PGSIDE_RIGHT:
					chkdup_topbot( &(feed_p->rightbot_p),
							"bot rightpage" );
					break;
				}
				break;
			case C_BOT2:
				switch ((yyvsp[0].intval)) {
				case PGSIDE_NOT_SET:
					chkdup_topbot( &(feed_p->bot2_p),
							"bot2" );
					break;
				case PGSIDE_LEFT:
					chkdup_topbot( &(feed_p->leftbot2_p),
							"bot2 leftpage" );
					break;
				case PGSIDE_RIGHT:
					chkdup_topbot( &(feed_p->rightbot2_p),
							"bot2 rightpage" );
					break;
				}
				break;
			case C_BLOCK:
				if (Doing_samescore == YES) {
					l_yyerror(Curr_filename, yylineno,
						"cannot have a block inside a samescore zone");
				}
				insertMAINLL(newMAINLLstruct(S_BLOCKHEAD, yylineno),
						Mainlltc_p);
				Mainlltc_p->u.blockhead_p = Currblock_p;
				Currblock_p->samepage = Doing_samepage;
				if ((yyvsp[0].intval) != PGSIDE_NOT_SET) {
					l_warning(Curr_filename, yylineno,
						"leftpage/rightpage cannot be used on blocks; ignoring");
				}
				/* These blocks count like "music" for purposes
				 * of things that can only be set
				 * before any "music"
				 */
				Got_some_data = YES;
				break;
			case C_HEADER:
			case C_HEAD2:
			case C_FOOTER:
			case C_FOOT2:
				/* These are static, not in main list,
				 * so nothing needs to be done with them.
				 */
				break;
			default:
				pfatal("unexpected context (0x%x) for block", Context);
				/*NOTREACHED*/
				break;
			}

			/* We need a feed after a block.
			 * Use -1 as lineno to mark it as internally generated.
			 * That way if user puts their own explicit feed
			 * next in the input, we can know we can
			 * discard this internally generated one.
			 */
			if (Context & C_BLOCK) {
				insertMAINLL(newMAINLLstruct(S_FEED, -1), Mainlltc_p);
			}
		}
	}
#line 3296 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 1043 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Context = C_MUSIC;
	}
#line 3304 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 1048 "src/mup/gram.y" /* yacc.c:1646  */
    {
		end_prev_context();
		Context = C_GRIDS;
	}
#line 3313 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 1054 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 3320 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 1058 "src/mup/gram.y" /* yacc.c:1646  */
    {
		end_prev_context();
		Context = C_ACCIDENTALS;
	}
#line 3329 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 1064 "src/mup/gram.y" /* yacc.c:1646  */
    {
		struct ACCIDENTALS *acc_name_map_p;

		/* Make sure not already in list */
		for (acc_name_map_p = Acc_contexts_list_p; acc_name_map_p != 0;
					acc_name_map_p = acc_name_map_p->next) {
			if (strcmp(acc_name_map_p->name, (yyvsp[0].stringval)) == 0) {
				l_warning(Curr_filename, yylineno,
				"accidental context name %s re-defined; using last", (yyvsp[0].stringval));
				/* We'll free the table, since that is
				 * potentially big, and is easy to do.
				 * We'll leave the ACCIDENTALS struct itself,
				 * because it doesn't seem worth the trouble
				 * to keep track of the "prev" to free up a
				 * little memory in a rare error case.
				 * And we'll leave the name, so future loops
				 * though the list can strcmp it, even though
				 * it will never really be used. We will put
				 * the replacement at the head of the list,
				 * so we'll always see that copy first and
				 * never bother to come down to this one.
				 */
				if (acc_name_map_p->info != 0) {
					FREE(acc_name_map_p->info);
					acc_name_map_p->info = 0;
					acc_name_map_p->size = 0;
				}
				/* If redefined multiple times, don't
				 * bother giving multiple errors. */
				break;
			}
		}

		MALLOC(ACCIDENTALS, acc_name_map_p, 1);
		acc_name_map_p->name = strdup((yyvsp[0].stringval) + 2);
		MALLOC(ACCINFO, acc_name_map_p->info, ITEMS);
		acc_name_map_p->size = 0;
		acc_name_map_p->next = Acc_contexts_list_p;
		Acc_contexts_list_p = acc_name_map_p;
	}
#line 3374 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 1106 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Context != C_ACCIDENTALS) {
			yyerror("something like looks like an accidentals entry when not in accidentals context");
		}
	}
#line 3384 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 1114 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Context == C_ACCIDENTALS) {
			new_acc_entry((yyvsp[0].stringval) + 2);
		}
	}
#line 3394 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 1122 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* A single value to use for all notes a-g */
		int i;
		for (i = 0; i < 7; i++) {
			add_acc_offset('a' + i, (yyvsp[0].floatval));
		}
	}
#line 3406 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 1136 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_acc_offset((yyvsp[-1].intval), (yyvsp[0].floatval));
	}
#line 3414 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 1142 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_acc_offset((yyvsp[-1].intval), (yyvsp[0].floatval));
	}
#line 3422 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 1148 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.floatval) = (float) cents2value( (double) ((yyvsp[-2].intval) * (yyvsp[-1].floatval)));
	}
#line 3430 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 1154 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.floatval) = (yyvsp[0].floatval);
	}
#line 3438 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 1160 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].floatval) == 0.0) {
			yyerror("denominator cannot be zero");
		}
		else {
			(yyval.floatval) = (yyvsp[-2].floatval) / (yyvsp[0].floatval);
		}
	}
#line 3451 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 1170 "src/mup/gram.y" /* yacc.c:1646  */
    {
		end_prev_context();
		Context = C_KEYMAP;
		new_keymap((yyvsp[0].stringval) + 2);
	}
#line 3461 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 1179 "src/mup/gram.y" /* yacc.c:1646  */
    {
		end_prev_context();
		Context = C_CONTROL;
		Saw_restoreparms = NO;
		Prev_control_parms = SR_SAVE;	/* really means "not restore"
						 * but didn't seem worth
						 * having separate state
						 * for that. */

	}
#line 3476 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 1192 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (contextcheck(C_CONTROL, "saveparms") == YES) {
			/* Associate the user's name with the current place
			 * in the main list */
			add_saveparms((yyvsp[0].stringval) + 2);
			if (Prev_control_parms != SR_WARN) {
				Prev_control_parms = SR_SAVE;
			}
		}
	}
#line 3491 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 1205 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (contextcheck(C_CONTROL, "restoreparms") == YES) {
			if (do_restoreparms((yyvsp[0].stringval) + 2) == YES) {
				if (Saw_restoreparms == YES) {
					if (Prev_control_parms == SR_RESTORE) {
						l_warning(Curr_filename, yylineno,
						"consecutive instances of 'restoreparms' in the same control context; only the last is effective");
					}
					else if (Prev_control_parms != SR_WARN) {
						l_warning(Curr_filename, yylineno,
						"multiple instances of 'restorparms is of dubious usefulness");
					}
					Prev_control_parms = SR_WARN;
				}
				if (Prev_control_parms != SR_WARN) {
					Prev_control_parms = SR_RESTORE;
				}
			}
		}
	}
#line 3516 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 1228 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Context == C_GRIDS) {
			add_grid((yyvsp[-2].stringval), (yyvsp[-1].stringval));
		}
		else if (Context == C_HEADSHAPES) {
			/* skip past the font/size bytes */
			add_shape((yyvsp[-2].stringval) + 2, (yyvsp[-1].stringval) + 2);
		}
		else if (Context == C_SHAPES) {
			add_shape_map_entry((yyvsp[-2].stringval) + 2, (yyvsp[-1].stringval) + 2);
		}
		else if (Context == C_KEYMAP) {
			add_to_keymap((yyvsp[-2].stringval), (yyvsp[-1].stringval));
		}
		else {
			l_warning(Curr_filename, yylineno - 1,
				"unexpected pair of text strings (possibly intended to be in grids, headshapes, shapes, or keymap context, or missing + for concatenation?)");
		}
	}
#line 3540 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 1250 "src/mup/gram.y" /* yacc.c:1646  */
    {
		end_prev_context();
		Context = C_HEADSHAPES;
	}
#line 3549 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 1258 "src/mup/gram.y" /* yacc.c:1646  */
    {
		end_prev_context();
		Context = C_SHAPES;
		init_new_shape_map((yyvsp[0].stringval) + 2);
	}
#line 3559 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 1267 "src/mup/gram.y" /* yacc.c:1646  */
    {
		end_prev_context();
		Context = C_SYMBOL;
		/* The +2 to skip font/size */
		Curr_usym_p = alloc_usym((yyvsp[0].stringval) + 2);
	}
#line 3570 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 1279 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[0].intval);
		/* later on we check for being within current range */
	}
#line 3579 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 1285 "src/mup/gram.y" /* yacc.c:1646  */
    {
		errno = 0;
		(yyval.intval) = strtol(yytext, 0, 10);
		if (errno == ERANGE) {
			l_yyerror(Curr_filename, yylineno,
				"Number %s is beyond the range of numbers that can be handled", yytext);
		}
	}
#line 3592 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 1295 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[-1].intval) * (yyvsp[0].intval);
	}
#line 3600 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 1310 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Only a few things are allowed to have a negative number.
		 * Other code assumes that that restriction is enforced here,
		 * so we only honor the minus if it is legal. */
		if ((yyvsp[-1].intval) == -1) {
			if ((yyvsp[-3].intval) != SYLPOSITION) {
				yyerror("negative value not allowed");
			}
			else {
				assign_int((yyvsp[-3].intval), -((yyvsp[0].intval)), Currstruct_p);
			}
		}
		else {
			assign_int((yyvsp[-3].intval), (yyvsp[0].intval), Currstruct_p);
		}
	}
#line 3621 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 1329 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* only restcombine and gridfret can be set to empty */
		if ((yyvsp[-1].intval) == RESTCOMBINE) {
			assign_int((yyvsp[-1].intval), NORESTCOMBINE, Currstruct_p);
		}
		else if ((yyvsp[-1].intval) == GRIDFRET) {
			assign_int((yyvsp[-1].intval), NOGRIDFRET, Currstruct_p);
		}
		else {
			yyerror("parameter value required");
		}
	}
#line 3638 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 1344 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_firstpage((yyvsp[-1].intval), (yyvsp[0].intval), Currstruct_p);
	}
#line 3646 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 1350 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].intval) == -1) {
			if ((yyvsp[-3].intval) != STAFFPAD) {
				yyerror("negative value not allowed");
			}
			else {
				assign_float((yyvsp[-3].intval), -((yyvsp[0].floatval)), Currstruct_p);
			}
		}
		else {
			assign_float((yyvsp[-3].intval), (yyvsp[0].floatval), Currstruct_p);
		}
	}
#line 3664 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 1366 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_2floats((yyvsp[-4].intval), (yyvsp[-2].floatval), (yyvsp[0].floatval), Currstruct_p);
	}
#line 3672 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 1372 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_float((yyvsp[-3].intval), (yyvsp[-1].floatval), Currstruct_p);
	}
#line 3680 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 1378 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_direction((yyvsp[-2].intval), (yyvsp[0].intval), Currstruct_p);
	}
#line 3688 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 1384 "src/mup/gram.y" /* yacc.c:1646  */
    {
		double multiplier;
		multiplier = (Score.units == INCHES ? 1.0 : CMPERINCH);
		assign_float( ((yyvsp[0].intval) == 0 ? PAGEWIDTH : PAGEHEIGHT),
			(double) Paper_sizes[(yyvsp[-1].intval)].width * multiplier / (double) PPI,
			Currstruct_p);
		assign_float( ((yyvsp[0].intval) == 0 ? PAGEHEIGHT : PAGEWIDTH),
			(double) Paper_sizes[(yyvsp[-1].intval)].height * multiplier / (double) PPI,
			Currstruct_p);
	}
#line 3703 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 1397 "src/mup/gram.y" /* yacc.c:1646  */
    { }
#line 3709 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 1401 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* specified in stepsizes, stored in inches */
		assign_float(PAD, (yyvsp[-1].intval) * (yyvsp[0].floatval) * STEPSIZE, Currstruct_p);
	}
#line 3718 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 1408 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_vscheme ((yyvsp[-1].intval), (yyvsp[0].intval), Currstruct_p);
	}
#line 3726 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 1414 "src/mup/gram.y" /* yacc.c:1646  */
    {
		set_beamlist(Currstruct_p);
		if (Currstruct_p != 0 && Currstruct_p->u.ssv_p != 0) {
			Currstruct_p->u.ssv_p->beamrests = ((yyvsp[0].intval) & 0x1);
			Currstruct_p->u.ssv_p->beamspaces = (((yyvsp[0].intval) >> 1) & 0x1);
		}
	}
#line 3738 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 1424 "src/mup/gram.y" /* yacc.c:1646  */
    {
		set_staffset((yyvsp[-3].intval), Currstruct_p);
	}
#line 3746 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 1430 "src/mup/gram.y" /* yacc.c:1646  */
    {
		set_barstlist(Currstruct_p, 0);
	}
#line 3754 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 1436 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Put them in time order */
		if (Currstruct_p != 0) {
			qsort((char *)(Currstruct_p->u.ssv_p->subbarlist),
				Currstruct_p->u.ssv_p->nsubbar,
				sizeof(struct SUBBAR_INSTANCE),
				comp_subbar);
		}
	}
#line 3768 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 1448 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (contextcheck(C_SCORE|C_STAFF, "repeatdots") == YES
					&& Currstruct_p != 0) {
			Currstruct_p->u.ssv_p->repeatdots = (yyvsp[0].intval);
			Currstruct_p->u.ssv_p->used[REPEATDOTS] = YES;
		}
	}
#line 3780 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 1458 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0) {
			chk_order(Currstruct_p->u.ssv_p, Order_place);
		}
	}
#line 3790 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 1469 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_int((yyvsp[-2].intval), (yyvsp[0].intval), Currstruct_p);
	}
#line 3798 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 1475 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* all the work for this is done in timesig */
	}
#line 3806 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 1484 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (contextcheck(C_SCORE|C_STAFF|C_VOICE, "defaultphraseside") == YES
					&& Currstruct_p != 0) {
			Currstruct_p->u.ssv_p->defaultphraseside = (yyvsp[0].intval);
			Currstruct_p->u.ssv_p->used[DEFAULTPHRASESIDE] = YES;
		}
	}
#line 3818 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 1494 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 3825 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 1499 "src/mup/gram.y" /* yacc.c:1646  */
    {
		set_font((yyvsp[-2].intval), (yyvsp[0].intval), Currstruct_p);
	}
#line 3833 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 1505 "src/mup/gram.y" /* yacc.c:1646  */
    {
		set_font((yyvsp[-2].intval), (yyvsp[0].intval), Currstruct_p);
	}
#line 3841 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 1511 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (contextcheck(C_SCORE|C_STAFF,"clef parameter") == YES) {
			used_check(Currstruct_p, CLEF, "clef");
			if (Context == C_STAFF && has_tab_staff()) {
				/* We used to be able to make this just a
				 * warning, but now that is hard, because
				 * we'd want to let it assign for any
				 * non-tab, but it is hard to know at this
				 * point which SSVs will be tab and which					 * non-tab, because we may not have created
				 * them all yet. We cannot let the tab ones
				 * get assigned, because later code would
				 * get confused by clef not being TABCLEF.
				 * While we could figure this all out with
				 * enough code, it really is a user error,
				 * so not worth bending over backwards
				 * to try to keep it just a warning.
				 */
				l_yyerror(Curr_filename, yylineno,
					"can't set clef on tab staff");
			}
			if (Currstruct_p != 0) {
				Currstruct_p->u.ssv_p->clef = (yyvsp[-1].intval);
				Currstruct_p->u.ssv_p->forceprintclef = (yyvsp[0].intval);
				Currstruct_p->u.ssv_p->used[CLEF] = YES;
				asgnssv(Currstruct_p->u.ssv_p);
			}
		}
	}
#line 3874 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 1542 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (contextcheck(C_SCORE | C_STAFF, "chordtranslation parameter") == YES
						&& (Currstruct_p != 0) ) {
			if (Currstruct_p->u.ssv_p->used[(yyvsp[-2].intval)] == YES) {
				warning("setting chordtranslation parameter overrides previous setting");
			}
			Currstruct_p->u.ssv_p->chordtranslation = (yyvsp[0].intval);
			Currstruct_p->u.ssv_p->used[CHORDTRANSLATION] = YES;
		}
	}
#line 3889 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 1555 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_int((yyvsp[-2].intval), (yyvsp[0].intval), Currstruct_p);
	}
#line 3897 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 1561 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_int((yyvsp[-2].intval), (yyvsp[0].intval), Currstruct_p);
	}
#line 3905 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 1570 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_int((yyvsp[-2].intval), (yyvsp[0].intval), Currstruct_p);
	}
#line 3913 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 1576 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (contextcheck(C_STAFF|C_VOICE, "unset") == YES
					&& Currstruct_p != 0) {
			if ((yyvsp[0].intval) < 0 || (yyvsp[0].intval) >= NUMFLDS) {
				pfatal("invalid parameter index %d on line %d", (yyvsp[0].intval), yylineno);
			}
			if (Currstruct_p->u.ssv_p->used[(yyvsp[0].intval)] == YES) {
				warning("unsetting parameter overrides previous setting");
			}
			/* Note that if user tries to unset something that
			 * can't be set in the current context, we silently
			 * ignore that. We figure that since it's already unset,
			 * it doesn't hurt anything to unset it again,
			 * and it's easier to not bother to check.
			 */

			Currstruct_p->u.ssv_p->used[(yyvsp[0].intval)] = UNSET;

			/* special case: scoresep controls two fields */
			if ((yyvsp[0].intval) == MINSCSEP) {
				Currstruct_p->u.ssv_p->used[MAXSCSEP] = UNSET;
			}

			/* Assign, just in case there are new interactions */
			asgnssv(Currstruct_p->u.ssv_p);
		}
	}
#line 3945 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 1605 "src/mup/gram.y" /* yacc.c:1646  */
    { Doing_timeunit = YES; }
#line 3951 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 1606 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ( contextcheck(C_SSV, "timeunit parameter") == YES ) {
			used_check(Currstruct_p, TIMEUNIT, "timeunit");
			if (Currstruct_p != 0) {
				Currstruct_p->u.ssv_p->timeunit = (yyvsp[0].ratval);
				Currstruct_p->u.ssv_p->timelist_p = Extra_time_p;
				Currstruct_p->u.ssv_p->used[TIMEUNIT] = YES;
			}
			Extra_time_p = 0;
			Doing_timeunit = NO;
		}
	}
#line 3968 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 1621 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ( contextcheck(C_SSV, "swingunit parameter") == YES ) {
			used_check(Currstruct_p, SWINGUNIT, "swingunit");
			if (Currstruct_p != 0) {
				Currstruct_p->u.ssv_p->swingunit = (yyvsp[0].ratval);
				Currstruct_p->u.ssv_p->used[SWINGUNIT] = YES;
			}
		}
	}
#line 3982 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 1633 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 3989 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 1638 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 3996 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 1643 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ( contextcheck(C_SCORE, "endingstyle parameter") == YES
					&& Currstruct_p != 0 ) {
			used_check(Currstruct_p, ENDINGSTYLE, "endingstyle");
			Currstruct_p->u.ssv_p->endingstyle = (yyvsp[0].intval);
			Currstruct_p->u.ssv_p->used[ENDINGSTYLE] = YES;
		}
	}
#line 4009 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 1654 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0) {
			if ((yyvsp[-2].intval) == REHSTYLE) {
				if (contextcheck(C_SCORE | C_STAFF, "rehstyle parameter") == YES ) {
					used_check(Currstruct_p, REHSTYLE, "rehstyle");
					Currstruct_p->u.ssv_p->rehstyle = (yyvsp[0].intval);
					Currstruct_p->u.ssv_p->used[REHSTYLE] = YES;
				}
			}
			else if ((yyvsp[-2].intval) == MEASNUMSTYLE) {
				if (contextcheck(C_SCORE, "measnumstyle parameter") == YES) {
					used_check(Currstruct_p, MEASNUMSTYLE, "measnumstyle");
					Currstruct_p->u.ssv_p->measnumstyle = (yyvsp[0].intval);
					Currstruct_p->u.ssv_p->used[MEASNUMSTYLE] = YES;
				}
			}
		}
	}
#line 4032 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 1675 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (contextcheck(C_SCORE | C_STAFF, "pedstyle parameter") == YES
					&& Currstruct_p != 0) {
			used_check(Currstruct_p, PEDSTYLE, "pedstyle");
			Currstruct_p->u.ssv_p->pedstyle = (yyvsp[0].intval);
			Currstruct_p->u.ssv_p->used[PEDSTYLE] = YES;
			/* Since Ped_stop is a predefined string that
			 * doesn't go through fix_string(), we wouldn't
			 * realize that font ZD1 was used until printing
			 * phase after we ought to have emitted the
			 * encoding vector code, which is too late,
			 * so mark it here. If the user sets the
			 * parameter to pedstar but then never actually uses
			 * a star, this will just cause a few extraenous
			 * but otherwise harmless lines of output. It is
			 * less important the ZI gets marked as used,
			 * since we don't change its encoding vector,
			 * so don't need to emit special code, but might as
			 * well mark that here as well. */
			if ((yyvsp[0].intval) != P_LINE) {
				Fontinfo[font_index(FONT_ZD1)].was_used = YES;
				Fontinfo[font_index(FONT_ZI)].was_used = YES;
			}
		}
	}
#line 4062 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 1703 "src/mup/gram.y" /* yacc.c:1646  */
    {
		char *trans_name;
		trans_name = ((yyvsp[-5].intval) == TRANSPOSITION ?
			"transpose" : "addtranspose");
		if (contextcheck(C_SCORE|C_STAFF, trans_name) == YES) {
			if (Context == C_STAFF && has_tab_staff() == YES) {
				l_warning(Curr_filename, yylineno,
					"%s not allowed on tablature staff; ignoring",
					trans_name);
			}
			chk_interval((yyvsp[-2].intval), (yyvsp[-1].intval));
			if (Currstruct_p != 0) {
				used_check(Currstruct_p, (yyvsp[-5].intval), trans_name);
				if ((yyvsp[-5].intval) == TRANSPOSITION) {
					Currstruct_p->u.ssv_p->inttype = (yyvsp[-2].intval);
					Currstruct_p->u.ssv_p->intnum = (yyvsp[-3].intval) * (yyvsp[-1].intval);
					Currstruct_p->u.ssv_p->trans_usage = (yyvsp[0].intval);
				}
				else {
					Currstruct_p->u.ssv_p->addinttype = (yyvsp[-2].intval);
					Currstruct_p->u.ssv_p->addintnum = (yyvsp[-3].intval) * (yyvsp[-1].intval);
					Currstruct_p->u.ssv_p->addtrans_usage = (yyvsp[0].intval);
				}
				Currstruct_p->u.ssv_p->used[(yyvsp[-5].intval)] = YES;
				asgnssv(Currstruct_p->u.ssv_p);
			}
		}
	}
#line 4095 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 1734 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_int(CUE, (yyvsp[0].intval), Currstruct_p);
	}
#line 4103 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 1740 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_unit((yyvsp[0].intval), Currstruct_p);
	}
#line 4111 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 1746 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_string((yyvsp[-2].intval), (yyvsp[0].stringval), Currstruct_p);
	}
#line 4119 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 1752 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_string((yyvsp[-2].intval), (yyvsp[0].stringval), Currstruct_p);
	}
#line 4127 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 1758 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_string((yyvsp[-2].intval), (yyvsp[0].stringval), Currstruct_p);
	}
#line 4135 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 1764 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (contextcheck(C_SCORE, "tuning") == YES
				&& Currstruct_p != 0) {
			used_check(Currstruct_p, TUNING, "tuning");
			Currstruct_p->u.ssv_p->used[TUNING] = YES;
			Currstruct_p->u.ssv_p->tuning = (yyvsp[0].intval);
			Tuning_used = YES;
		}
	}
#line 4149 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 1776 "src/mup/gram.y" /* yacc.c:1646  */
    {
		set_keymap((yyvsp[-2].intval), (yyvsp[0].stringval), Currstruct_p);
	}
#line 4157 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 1782 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_usym_p == 0) {
			l_yyerror(Curr_filename, yylineno,
				"postscript= only valid in symbol context; maybe you meant without '=' ?");
		}
		else {
			if (Curr_usym_p->flags & US_POSTSCRIPT) {
				l_warning(Curr_filename, yylineno,
					"Multiple postscript definitions given for symbol '%s'; using last",
					Curr_usym_p->name);
				FREE(Curr_usym_p->postscript);
			}
			Curr_usym_p->postscript = (yyvsp[0].stringval);
			Curr_usym_p->flags |= US_POSTSCRIPT;
		}
	}
#line 4178 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 1801 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_usym_p == 0) {
			l_yyerror(Curr_filename, yylineno,
				"bbox= only valid in symbol context");
		}
		else {
			if (Curr_usym_p->flags & US_BBOX) {
				l_warning(Curr_filename, yylineno,
					"Multiple bbox definitions given for symbol %s; using last",
					Curr_usym_p->name);
			}
			Curr_usym_p->llx = (yyvsp[-6].intval);
			Curr_usym_p->lly = (yyvsp[-4].intval);
			Curr_usym_p->urx = (yyvsp[-2].intval);
			Curr_usym_p->ury = (yyvsp[0].intval);
			Curr_usym_p->flags |= US_BBOX;
		}
	}
#line 4201 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1822 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_usym_p == 0) {
			l_yyerror(Curr_filename, yylineno,
				"stemoffset= only valid in symbol context");
		}
		else {
			if (Curr_usym_p->flags & US_STEMOFFSET) {
				l_warning(Curr_filename, yylineno,
					"Multiple stemoffset definitions given for %s; last used",
					Curr_usym_p->name);
			}
			Curr_usym_p->upstem_y = (yyvsp[-2].intval);
			Curr_usym_p->downstem_y = (yyvsp[0].intval);
			Curr_usym_p->flags |= US_STEMOFFSET;
		}
	}
#line 4222 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1842 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* whereused is not allowed on voice, just score and staff */
		if (contextcheck(C_SCORE|C_STAFF, "visible=whereused") == YES) {
			assign_int(VISIBLE, YES, Currstruct_p);
			if (Currstruct_p != 0 && Currstruct_p->u.ssv_p != 0) {
				Currstruct_p->u.ssv_p->hidesilent = YES;
			}
		}
	}
#line 4236 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 1854 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* only valid letter is y */
		if (*yytext != 'y') {
			yyerror("visible value must be y, n, or whereused");
		}
		else if (contextcheck(C_SSV, "visible parameter")
								== YES) {
			assign_int(VISIBLE, YES, Currstruct_p);
			if (Currstruct_p != 0 && Currstruct_p->u.ssv_p != 0) {
				Currstruct_p->u.ssv_p->hidesilent = NO;
			}
		}
	}
#line 4254 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 1870 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (contextcheck(C_SSV, "visible parameter") == YES) {
			assign_int(VISIBLE, NO, Currstruct_p);
			if (Currstruct_p != 0 && Currstruct_p->u.ssv_p != 0) {
				Currstruct_p->u.ssv_p->hidesilent = NO;
			}
		}
	}
#line 4267 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 1880 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = PGSIDE_NOT_SET;
	}
#line 4275 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1886 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 4283 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 1891 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = NO;
	}
#line 4291 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1897 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* only valid letter is y */
		if (*yytext == 'y') {
			(yyval.intval) = YES;
		}
		else {
			/* Our yyerror will end up making this into a
			 * nice error message that gives the offending token */
			yyerror("syntax error");
			(yyval.intval) = NO;
		}
	}
#line 4308 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1912 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* only valid letter is y */
		if (*yytext != 'y') {
			yyerror("measnum value must be y, n, or every N");
			(yyval.intval) = MN_NONE;
		}
		else {
			(yyval.intval) = MN_SCORE;
		}
	}
#line 4323 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1925 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = MN_NONE;
	}
#line 4331 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1931 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) < MINEVERYMEASNUM || (yyvsp[0].intval) > MAXEVERYMEASNUM) {
			/* We have to do range check here rather than let
			 * assign_int() do it, because internally we use
			 * additional values, and it would be confusing to
			 * the user to include those internal values in the
			 * valid range. */
			l_yyerror(Curr_filename, yylineno,
				"for measnum=every N, N must be between %d and %d",
				MINEVERYMEASNUM, MAXEVERYMEASNUM);
			(yyval.intval) = MN_NONE;
		}
		else {
			(yyval.intval) = (yyvsp[0].intval);
		}
	}
#line 4352 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1950 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* none specified */
		(yyval.intval) = V_1;
	}
#line 4361 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1957 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* only valid value here is 'f'  */
		if (*yytext == 'f') {
			(yyval.intval) = V_2FREESTEM;
		}
		else {
			yyerror("invalid voice qualifier: must be f or o");
			(yyval.intval) = V_1;
		}
	}
#line 4376 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1970 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* only valid value here is 'o' */
		if (*yytext == 'o') {
			(yyval.intval) = V_2OPSTEM;
		}
		else {
			yyerror("invalid voice qualifier: must be f or o");
			(yyval.intval) = (int) V_1;
		}
	}
#line 4391 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1982 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* NULL token for allocating a new beamlist */
		new_beamlist();
	}
#line 4400 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1996 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_beamlist((yyvsp[0].ratval));
	}
#line 4408 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 2005 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_beamlist((yyvsp[0].ratval));
	}
#line 4416 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 2014 "src/mup/gram.y" /* yacc.c:1646  */
    { begin_subbeam(); }
#line 4422 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 2015 "src/mup/gram.y" /* yacc.c:1646  */
    {
		end_subbeam();
	}
#line 4430 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 2020 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.ratval) = calcfulltime((yyvsp[-3].ratval), (yyvsp[-2].intval));

		/* If filling in a GRPSYL struct,
		 * need to fill in dots and basictime.
		 * Could also be here due to beamstyle
		 * or timeunit or location time offset,
		 * in which case the Curr_grpsyl_p will be NULL,
		 * or while getting tuplet duration. */
		if (Curr_grpsyl_p != (struct GRPSYL *) 0
						&& Getting_tup_dur == NO) {
			Curr_grpsyl_p->dots = (yyvsp[-2].intval);
			Curr_grpsyl_p->basictime = reconstruct_basictime((yyval.ratval));
		}
		else {
			struct TIMELIST *timelist_p;	/* walk thru list */
			struct TIMELIST *next_p;/* save next to delete curr */
			RATIONAL totaltime;	/* sum of extra times */

			/* Start with first time value (which was calculated
			 * above and is now in $$), then add on the added
			 * times, if any. */
			totaltime = (yyval.ratval);
			for (timelist_p = Extra_time_p; timelist_p != 0;
						timelist_p = next_p) {
				next_p = timelist_p->next;
				totaltime = radd(totaltime, timelist_p->fulltime);
				if (Doing_timeunit == NO) {
					/* For things like swingunit
					 * or tuplet time, we just need the
					 * resulting time, not the individual
					 * time units and arithmetic. */
					FREE(timelist_p);
				}
			}
			if (Extra_time_p != 0 && LE(totaltime, Zero)) {
				yyerror("Time values must add up to more than zero");
			}
			/* Current timelist is finished; can't append any
			 * more items to it. */
			Curr_timelist_p = 0;
			if (Doing_timeunit == YES) {
				/* For timeunit, we return the initial
				 * timeunit, but also preserve
				 * Extra_time_p for putting in SSV.
				 */
				(yyval.ratval) = calcfulltime((yyvsp[-3].ratval), (yyvsp[-2].intval));
			}
			else {
				/* the list has been freed above */
				Extra_time_p = 0;
				(yyval.ratval) = totaltime;
			}
		}
	}
#line 4490 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 2078 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.ratval).n = (svpath(1, TIME))->time.n;
		(yyval.ratval).d = (svpath(1, TIME))->time.d;
		if (Curr_grpsyl_p != (struct GRPSYL *) 0
					&& Getting_tup_dur == NO) {
			/* use whole note symbol as default */
			Curr_grpsyl_p->basictime = 1;
			Curr_grpsyl_p->is_meas = YES;
			Meas_rpt_type = (yyvsp[-1].intval);
			User_meas_time = NO;
		}
		else {
			yyerror("'m' is not valid here");
		}
	}
#line 4510 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 2096 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.ratval) = Zero;
	}
#line 4518 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 2106 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = NO;
	}
#line 4526 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 2112 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (YES | (YES << 1));
	}
#line 4534 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 2118 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = ((YES << 1) | YES);
	}
#line 4542 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 2124 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (YES << 1);
	}
#line 4550 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 2130 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = YES;
	}
#line 4558 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 2135 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* null token for the purpose of allocating a new rangelist
		 * to be filled in with user data */
		new_staffset();
	}
#line 4568 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 2156 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* save information about this range in the list */
		/* if only a single number, not a range, rangetail will be
		 * 0, so use num as both beginning and end of range */
		add_staffset( (yyvsp[-2].intval), ((yyvsp[-1].intval) > 0 ? (yyvsp[-1].intval) : (yyvsp[-2].intval)), String1, String2);
	}
#line 4579 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 2164 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* no end of range, so return 0 as flag that there was only 1 number */
		(yyval.intval) = 0;
	}
#line 4588 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 2171 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* make sure isn't 0, because that it illegal and would be used
		 * later as though there were no range. Other error checking
		 * on this number will be done later. */
		if ((yyvsp[0].intval) == 0) {
			yyerror("second number of range may not be zero");
		}
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 4602 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 2182 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* no labels */
		String1 = String2 = (char *) 0;
	}
#line 4611 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 2189 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* save label */
		String1 = (yyvsp[-2].stringval);
	}
#line 4620 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 2195 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* no second label */
		String2 = (char *) 0;
	}
#line 4629 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 2202 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* save label2 for later use */
		String2 = (yyvsp[0].stringval);
	}
#line 4638 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 2211 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* NULL token for allocating space for a bar style list */
		new_barstlist();
		Bar_between = NO;
	}
#line 4648 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 2231 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_barst(1, MAXSTAFFS, Bar_between, YES);
	}
#line 4656 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 2237 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 4663 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 2246 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) != PL_BETWEEN) {
			yyerror("barstyle range place can only be between");
		}
		else {
			Bar_between = YES;
		}
	}
#line 4676 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 2258 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* if only 1 number, not range, rangetail will be 0, so use
		 * same number for beginning and end */
		add_barst((yyvsp[-1].intval), ((yyvsp[0].intval) == 0 ? (yyvsp[-1].intval) : (yyvsp[0].intval)), Bar_between, NO);
	}
#line 4686 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 2265 "src/mup/gram.y" /* yacc.c:1646  */
    {
		used_check(Currstruct_p, SUBBARSTYLE, "subbarstyle");
		Bar_between = NO;
	}
#line 4695 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 2271 "src/mup/gram.y" /* yacc.c:1646  */
    {
		set_barstlist(Currstruct_p, Subbar_app_p);
	}
#line 4703 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 2277 "src/mup/gram.y" /* yacc.c:1646  */
    {
		set_barstlist(Currstruct_p, Subbar_app_p);
	}
#line 4711 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 2282 "src/mup/gram.y" /* yacc.c:1646  */
    {
		MALLOC(SUBBAR_APPEARANCE, Subbar_app_p, 1);
	}
#line 4719 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 2287 "src/mup/gram.y" /* yacc.c:1646  */
    {
		new_barstlist();
	}
#line 4727 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 2293 "src/mup/gram.y" /* yacc.c:1646  */
    {
		switch ((yyvsp[0].intval)) {
		case L_NORMAL:
		case L_DASHED:
		case L_DOTTED:
			break;
		default:
			l_yyerror(Curr_filename, yylineno,
				"subbar linetype, if specified, can only be dashed or dotted");
			break;
		}

		Subbar_app_p->linetype = (yyvsp[0].intval);
	}
#line 4746 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 2310 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) != SINGLEBAR && (yyvsp[0].intval) != DOUBLEBAR) {
			l_yyerror(Curr_filename, yylineno,
				"subbar type can only be bar or dblbar");
		}
		Subbar_app_p->bartype = (yyvsp[0].intval);
	}
#line 4758 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 2319 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Subbar_app_p->upper_ref_line = LR_TOP;
		Subbar_app_p->upper_offset = 0.0;
		Subbar_app_p->lower_ref_line = LR_BOTTOM;
		Subbar_app_p->lower_offset = 0.0;
	}
#line 4769 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 2331 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Subbar_app_p->upper_ref_line = (yyvsp[-5].intval);
		Subbar_app_p->upper_offset = (yyvsp[-4].floatval);
		Subbar_app_p->lower_ref_line = (yyvsp[-2].intval);
		Subbar_app_p->lower_offset = (yyvsp[-1].floatval);
	}
#line 4780 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 2340 "src/mup/gram.y" /* yacc.c:1646  */
    {
		switch ((yyvsp[0].intval)) {
		case C_TOP:
			(yyval.intval) = LR_TOP;
			break;
		case C_BOT:
			(yyval.intval) = LR_BOTTOM;
			break;
		default:
			/* our yyerror will turn this into more helpful msg */
			yyerror("syntax error");
			/* return some valid value */
			(yyval.intval) = LR_MIDDLE;
			break;
		}
	}
#line 4801 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 2359 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = LR_MIDDLE;
	}
#line 4809 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 2364 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.floatval) = 0.0;
	}
#line 4817 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 2370 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.floatval) = (yyvsp[-1].intval) * (yyvsp[0].floatval);
	}
#line 4825 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 2382 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_barst(1, MAXSTAFFS, Bar_between, YES);
	}
#line 4833 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 2395 "src/mup/gram.y" /* yacc.c:1646  */
    {
		struct SSV *ssv_p;
		int n;		/* to loop for checking for duplicates */

		if (Currstruct_p != 0) {
			ssv_p = Currstruct_p->u.ssv_p;
			if (ssv_p->nsubbar == 0) {
				MALLOC(SUBBAR_INSTANCE, ssv_p->subbarlist, 1);
			}
			else {
				REALLOC(SUBBAR_INSTANCE, ssv_p->subbarlist,
							ssv_p->nsubbar+1);
			}

			if ((yyvsp[0].floatval) <= 1.0 || (yyvsp[0].floatval) >= (double) Score.timenum + 1.0) {
				l_yyerror(Curr_filename, yylineno,
					"subbar time must be greater than 1.0 and less than %.3f",
							Score.timenum + 1.0);
			}
			for (n = 0; n < ssv_p->nsubbar; n++) {
				if (ssv_p->subbarlist[n].count == (yyvsp[0].floatval)) {
					l_warning(Curr_filename, yylineno,
						"time %f specified more than once for same subbar instance", (yyvsp[0].floatval));
				}
			}
			ssv_p->subbarlist[ssv_p->nsubbar].count = (yyvsp[0].floatval);
			ssv_p->subbarlist[ssv_p->nsubbar].appearance_p = Subbar_app_p;
			(ssv_p->nsubbar)++;
		}
	}
#line 4868 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 2428 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = RD_ALL;
	}
#line 4876 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 2434 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = RD_STANDARD;
	}
#line 4884 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 2439 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Order_place = (yyvsp[0].intval);
		Order_prio = 1;
		if (Currstruct_p != 0) {
			switch ((yyvsp[0].intval)) {
			case PL_ABOVE:
				Currstruct_p->u.ssv_p->used[ABOVEORDER] = YES;
				break;
			case PL_BELOW:
				Currstruct_p->u.ssv_p->used[BELOWORDER] = YES;
				break;
			case PL_BETWEEN:
				Currstruct_p->u.ssv_p->used[BETWEENORDER] = YES;
				break;
			}
		}
	}
#line 4906 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 2459 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0) {
			Currstruct_p->u.ssv_p->markorder[Order_place][(yyvsp[0].intval)] = Order_prio;
		}
	}
#line 4916 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 2467 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0) {
			Currstruct_p->u.ssv_p->markorder[Order_place][(yyvsp[0].intval)] = ++Order_prio;
		}
	}
#line 4926 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 2475 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0) {
			Currstruct_p->u.ssv_p->markorder[Order_place][(yyvsp[0].intval)] = Order_prio;
		}
	}
#line 4936 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 2482 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0) {
			if (Currstruct_p->u.ssv_p->markorder[Order_place][(yyvsp[0].intval)] != 0) {
				l_yyerror(Curr_filename, yylineno,
					"order item %s specified more than once", (yyvsp[0].intval));
			}
		}
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 4950 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 2494 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = MK_MUSSYM;
	}
#line 4958 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 2500 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = MK_OCTAVE;
	}
#line 4966 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 2506 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = MK_OTHERTEXT;
	}
#line 4974 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 2512 "src/mup/gram.y" /* yacc.c:1646  */
    {
		switch ((yyvsp[0].intval)) {
		case TM_CHORD:
			(yyval.intval) = MK_CHORD;
			break;
		case TM_DYN:
			(yyval.intval) = MK_DYN;
			break;
		default:
			yyerror("invalid text modifier in order list");
			/* set to something valid, since $$ will be used
			 * as an array subscript. */
			(yyval.intval) = MK_CHORD;
			break;
		}
	}
#line 4995 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 2531 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = MK_LYRICS;
	}
#line 5003 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 2537 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = MK_ENDING;
	}
#line 5011 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 2543 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = MK_REHEARSAL;
	}
#line 5019 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 2549 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = MK_PEDAL;
	}
#line 5027 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 2555 "src/mup/gram.y" /* yacc.c:1646  */
    {
		tsig_item(TSR_END);
		if (Currstruct_p != 0 && Currstruct_p->u.ssv_p != 0) {
			MALLOCA(char, Currstruct_p->u.ssv_p->timerep, Tsig_offset);
			strcpy(Currstruct_p->u.ssv_p->timerep, Timerep);
			assign_timesig(Currstruct_p, (yyvsp[0].intval), &Next_alt_timesig);
			Tsig_visibility = (yyvsp[0].intval);
			/* If there are alternating time signatures,
			 * need to save pointer to this list */
			if (Next_alt_timesig != 0) {
				Alt_timesig_list = Currstruct_p->u.ssv_p->timerep;
			}
			else {
				Alt_timesig_list = 0;
			}
		}
		/* Reset for next time signature usage, if any */
		Tsig_offset = 0;
	}
#line 5051 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 2579 "src/mup/gram.y" /* yacc.c:1646  */
    { tsig_item(TSR_ALTERNATING); }
#line 5057 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 2580 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* this is for alternating time signature */
	}
#line 5065 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 2586 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 5072 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 2590 "src/mup/gram.y" /* yacc.c:1646  */
    { tsig_item(TSR_ADD); }
#line 5078 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 2591 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* This would be for things like 2/4 + 3/8 */
	}
#line 5086 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 2597 "src/mup/gram.y" /* yacc.c:1646  */
    {
		tsig_item(TSR_CUT);
	}
#line 5094 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 2603 "src/mup/gram.y" /* yacc.c:1646  */
    {
		tsig_item(TSR_COMMON);
	}
#line 5102 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 2609 "src/mup/gram.y" /* yacc.c:1646  */
    {
		tsig_item(TSR_SLASH);
		if ((yyvsp[0].intval) < MINDENOMINATOR) {
			l_yyerror(Curr_filename, yylineno,
				"time signature denominator cannot be less than %d",
				MINDENOMINATOR);
			(yyvsp[0].intval) = MINDENOMINATOR;
		}
		else if ((yyvsp[0].intval) > MAXDENOMINATOR) {
			l_yyerror(Curr_filename, yylineno,
				"time signature denominator cannot be greater than %d",
				MAXDENOMINATOR);
			(yyvsp[0].intval) = MAXDENOMINATOR;
		}
		else if (power_of2check((yyvsp[0].intval), "time signature denominator") == NO) {
			(yyvsp[0].intval) = 1 << drmo((yyvsp[0].intval));
		}

		tsig_item((yyvsp[0].intval));
	}
#line 5127 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 2632 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* this is something like 3+1/4 where the 1/4 get interpreted
		 * by lexer as quadwhole, but it's really 1 for numerator
		 * and 4 for denominator. 
		 */
		tsig_item(1);
		tsig_item(TSR_SLASH);
		tsig_item((yyvsp[0].intval));
	}
#line 5141 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 2644 "src/mup/gram.y" /* yacc.c:1646  */
    {
		tsig_item(1);
		tsig_item(TSR_SLASH);
		tsig_item((yyvsp[0].intval));
	}
#line 5151 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 2658 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) < MINNUMERATOR) {
			l_yyerror(Curr_filename, yylineno,
				"time signature numerator cannot be less than %d",
				MINNUMERATOR);
			(yyvsp[0].intval) = MINNUMERATOR;
		}
		else if ((yyvsp[0].intval) > MAXNUMERATOR) {
			l_yyerror(Curr_filename, yylineno,
				"time signature numerator cannot be greater than %d",
				MAXNUMERATOR);
			(yyvsp[0].intval) = MAXNUMERATOR;
		}
		tsig_item((yyvsp[0].intval));
	}
#line 5171 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 2676 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = PTS_ONCE;
	}
#line 5179 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 2682 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = ((yyvsp[0].intval) == YES ? PTS_ALWAYS : PTS_NEVER);
	}
#line 5187 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 2687 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = NO;
	}
#line 5195 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 2693 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* 'n' is used in various places to mean do NOT
		 * print something that would normally be printed,
		 * so YES means we do want to inhibit the normal printing. */
		(yyval.intval) = YES;
	}
#line 5206 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 2701 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0 && Currstruct_p->u.ssv_p != 0) {
			Currstruct_p->u.ssv_p->prtime_str1 = 0;
			Currstruct_p->u.ssv_p->prtime_str2 = 0;
			Currstruct_p->u.ssv_p->prtime_is_arbitrary = NO;
			Currstruct_p->u.ssv_p->used[PRINTEDTIME] = YES;
		}
	}
#line 5219 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 2712 "src/mup/gram.y" /* yacc.c:1646  */
    {
		tsig_item(TSR_END);
		if (Currstruct_p != 0 && Currstruct_p->u.ssv_p != 0) {
			MALLOCA(char, Currstruct_p->u.ssv_p->prtime_str1, Tsig_offset);
			strcpy(Currstruct_p->u.ssv_p->prtime_str1, Timerep);
			Currstruct_p->u.ssv_p->prtime_str2 = 0;
			Currstruct_p->u.ssv_p->prtime_is_arbitrary = NO;
			Currstruct_p->u.ssv_p->used[PRINTEDTIME] = YES;
		}
		/* Reset for next time signature usage, if any */
		Tsig_offset = 0;
	}
#line 5236 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 2727 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0 && Currstruct_p->u.ssv_p != 0) {
			Currstruct_p->u.ssv_p->prtime_str1 = (yyvsp[0].stringval);
			Currstruct_p->u.ssv_p->prtime_str2 = 0;
			Currstruct_p->u.ssv_p->prtime_is_arbitrary = YES;
			Currstruct_p->u.ssv_p->used[PRINTEDTIME] = YES;

		}
	}
#line 5250 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 2739 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0 && Currstruct_p->u.ssv_p != 0) {
			Currstruct_p->u.ssv_p->prtime_str1 = (yyvsp[-1].stringval);
			Currstruct_p->u.ssv_p->prtime_str2 = (yyvsp[0].stringval);
			Currstruct_p->u.ssv_p->prtime_is_arbitrary = YES;
			Currstruct_p->u.ssv_p->used[PRINTEDTIME] = YES;
		}
	}
#line 5263 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 2749 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ( ((yyvsp[-1].intval) != '#') && ((yyvsp[-1].intval) != '&') ) {
			yyerror("key signature must include # or &");
		}
		else {
			assign_key((yyvsp[-2].intval), (yyvsp[-1].intval), (yyvsp[0].intval), Currstruct_p);
		}
	}
#line 5276 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 2760 "src/mup/gram.y" /* yacc.c:1646  */
    {
		int sharps;

		/* Get number of sharps for the pitch letter */
		sharps = strchr(Circle, (yyvsp[-2].intval)) - Circle - 1;

		/* adjust for sharp/flat */
		if ((yyvsp[-1].intval) == '#') {
			sharps += 7;
		}
		else if ((yyvsp[-1].intval) == '&') {
			sharps -= 7;
		}
		else if ((yyvsp[-1].intval) != 0) {
			yyerror("key letter can only be followed by # or &");
			/* set to some ridiculous value, so will fail below */
			sharps = 999;
		}

		/* Adjust if needed for minor */
		if ((yyvsp[0].intval) == YES) {
			sharps -= 3;
		}

		/* disallow illegal keys, like f& */
		if (abs(sharps) > 7) {
			/* print error unless already printed one above */
			if (sharps < 100) {
				yyerror("invalid key--too many sharps or flats");
			}
		}
		else {
			assign_key(abs(sharps), (sharps >= 0 ? '#' : '&'),
							(yyvsp[0].intval), Currstruct_p);
		}
	}
#line 5317 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 2799 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].intval) == NO) {
			if ((yyvsp[0].intval) != -1) {
				l_warning(Curr_filename, yylineno,
					"can't use useaccs qualifier with n; ignoring the qualifier");
			}
			(yyval.intval) = UA_N;
		}
		else {
			if ((yyvsp[0].intval) == -1) {
				(yyvsp[0].intval) = UA_Y_NONE;
			}
			(yyval.intval) = (yyvsp[0].intval);
		}
	}
#line 5337 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 2817 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Empty means UA_Y_NONE when used with 'y', but we need
		 * to distinguish temporarily, in case user erroneously
		 * tries to use std with 'n' */
		(yyval.intval) = -1;
	}
#line 5348 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 2826 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 5356 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 2832 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = UA_Y_ALL;
	}
#line 5364 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 2838 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = UA_Y_NONNAT;
	}
#line 5372 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 2845 "src/mup/gram.y" /* yacc.c:1646  */
    {
		asgn_stafflines((yyvsp[-1].intval), (yyvsp[0].intval) == YES ? SS_NOTHING : SS_NORMAL, Currstruct_p);
	}
#line 5380 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 2851 "src/mup/gram.y" /* yacc.c:1646  */
    {
		asgn_stafflines((yyvsp[-1].intval), SS_DRUM, Currstruct_p);
	}
#line 5388 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 2857 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* use default tablature */
		if (Currstruct_p != 0) {
			Currstruct_p->u.ssv_p->strinfo = Guitar;
			asgn_stafflines(DEFTABLINES, (yyvsp[0].intval), Currstruct_p);
		}
	}
#line 5400 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 2867 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* user-specified tablature */
		asgn_stafflines((yyvsp[-2].intval), (yyvsp[0].intval), Currstruct_p);
	}
#line 5409 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 2873 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = PTC_FIRST;
	}
#line 5417 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 2879 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = PTC_NEVER;
	}
#line 5425 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 2885 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* only valid letter is y */
		if (*yytext != 'y') {
			yyerror("flag value must be y or n");
		}
		(yyval.intval) = PTC_ALWAYS;
	}
#line 5437 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 2894 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = CT_NONE;
	}
#line 5445 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 2900 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (strcmp((yyvsp[0].stringval) + 2, "German") == 0) {
			(yyval.intval) = CT_GERMAN;
		}
		else {
			parse_doremi_string((yyvsp[0].stringval) + 2);
			(yyval.intval) = CT_DOREMI;
		}
	}
#line 5459 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 2912 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = 1;
	}
#line 5467 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 2918 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* count up the number of strings */
		(yyval.intval) = (yyvsp[-1].intval) + 1;
	}
#line 5476 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 2924 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* save info about this tablature string */
		if (Currstruct_p != 0) {
			add_tab_string_info((yyvsp[-3].intval), (yyvsp[-2].intval), (yyvsp[-1].intval), (yyvsp[0].intval), Currstruct_p->u.ssv_p);
		}
	}
#line 5487 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 2932 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = 0;
	}
#line 5495 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 2938 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) != '&' && (yyvsp[0].intval) != '#') {
			yyerror("accidental on string can only be & or #");
		}
	}
#line 5505 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 2945 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* no ticks */
		(yyval.intval) = 0;
	}
#line 5514 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 2952 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* limit number of ticks. Has to match the number of bits
		 * used by TMP_NTICKS in grpsyl.c */
		if ((yyvsp[0].intval) > MAXTICKS) {
			l_yyerror(Curr_filename, yylineno,
				"too many ' marks (%d max)", MAXTICKS);
			(yyvsp[0].intval) = MAXTICKS;
		}
	}
#line 5528 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 2963 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* only valid letter is y */
		if (*yytext != 'y') {
			yyerror("flag value must be y or n");
		}
		(yyval.intval) = YES;
	}
#line 5540 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 2973 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = NO;
	}
#line 5548 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 2978 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p == 0) {
			l_warning(Curr_filename, yylineno,
				"wrong context for setting scoresep; ignoring");
		}
		else {
			/* Assign the value of minimum vertical space
			 * between scores. */
			assign_float(MINSCSEP, (yyvsp[0].floatval), Currstruct_p);
		}
	}
#line 5564 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 2991 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0) {
			/* if user set minimum greater than default maximum,
			 * adjust maximum to equal the minimum
			 * they specified. */
			if (Currstruct_p->u.ssv_p->minscsep
					> Currstruct_p->u.ssv_p->maxscsep) {
				Currstruct_p->u.ssv_p->maxscsep
					= Currstruct_p->u.ssv_p->minscsep;
			}
			else {
				/* fill in default */
				assign_float(MAXSCSEP, DEFMAXSCSEP, Currstruct_p);
			}
		}
	}
#line 5585 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 3010 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0) {
			if (Currstruct_p->u.ssv_p->minscsep > (yyvsp[0].floatval)) {
				yyerror("scoresep maximum smaller than minimum");
			}
			assign_float(MAXSCSEP, (yyvsp[0].floatval), Currstruct_p);
		}
	}
#line 5598 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 3020 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p == 0) {
			l_warning(Curr_filename, yylineno,
				"wrong context for setting scorepad; ignoring");
		}
		else {
			/* Assign the value of minimum vertical space
			 * between scores. */
			assign_float(MINSCPAD, (yyvsp[-1].intval) * (yyvsp[0].floatval), Currstruct_p);
		}
	}
#line 5614 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 3034 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0) {
			/* If user set minimum greater than default maximum,
			 * adjust maximum to equal the minimum
			 * they specified. */
			if (Currstruct_p->u.ssv_p->minscpad
					> Currstruct_p->u.ssv_p->maxscpad) {
				Currstruct_p->u.ssv_p->maxscpad
					= Currstruct_p->u.ssv_p->minscpad;
			}
			else {
				/* fill in default */
				assign_float(MAXSCPAD, DEFMAXSCPAD, Currstruct_p);
			}
		}
	}
#line 5635 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 3053 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0) {
			if (Currstruct_p->u.ssv_p->minscpad > (yyvsp[-1].intval) * (yyvsp[0].floatval)) {
				yyerror("scorepad maximum smaller than minimum");
			}
			assign_float(MAXSCPAD, (yyvsp[-1].intval) * (yyvsp[0].floatval), Currstruct_p);
		}
	}
#line 5648 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 3064 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 5655 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 3069 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_float(MAXPROSHORT, (yyvsp[-1].floatval), Currstruct_p);
	}
#line 5663 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 3074 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 5670 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 3079 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].intval) > (yyvsp[0].intval)) {
			l_warning(Curr_filename, yylineno,
				"distance to begin shortening protruding stems cannot be greater than ending distance; making them equal");
			(yyvsp[0].intval) = (yyvsp[-2].intval);
		}
		assign_int(BEGPROSHORT, (yyvsp[-2].intval), Currstruct_p);
		assign_int(ENDPROSHORT, (yyvsp[0].intval), Currstruct_p);
	}
#line 5684 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 3091 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = UNKNOWN;
	}
#line 5692 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 3097 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 5700 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 3106 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].intval) == (int) 'a' && (yyvsp[0].intval) >= 3 && (yyvsp[0].intval) <= 6) {
			switch ((yyvsp[0].intval)) {
			case 3:
				(yyval.intval) = PS_A3;
				break;
			case 4:
				(yyval.intval) = PS_A4;
				break;
			case 5:
				(yyval.intval) = PS_A5;
				break;
			case 6:
				(yyval.intval) = PS_A6;
				break;
			default:
				pfatal("impossible pagesize");
				break;
			}
		}
		else {
			yyerror("unsupported pagesize");
		}
	}
#line 5729 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 3134 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = 0;
	}
#line 5737 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 3140 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = ((yyvsp[0].intval) == O_PORTRAIT ? 0 : 1);
	}
#line 5745 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 3146 "src/mup/gram.y" /* yacc.c:1646  */
    { VCrange_p = 0; Doing_vcombine = YES; }
#line 5751 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 3146 "src/mup/gram.y" /* yacc.c:1646  */
    { Doing_vcombine = NO; }
#line 5757 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 3151 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_vcombine(VC_NOOVERLAP, NO, Currstruct_p, Curr_tssv_p);
	}
#line 5765 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 3157 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Defining_multiple = NO;
	}
#line 5773 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 3163 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_vcombine(VC_NOOVERLAP, NO, Currstruct_p, Curr_tssv_p);
	}
#line 5781 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 3169 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_vcombine((yyvsp[-1].intval), (yyvsp[0].intval), Currstruct_p, Curr_tssv_p);
	}
#line 5789 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 3175 "src/mup/gram.y" /* yacc.c:1646  */
    {
		assign_vcombine((yyvsp[0].intval), YES, Currstruct_p, Curr_tssv_p);
	}
#line 5797 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 3182 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = VC_NOOVERLAP;
	}
#line 5805 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 3188 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 5813 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 3195 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = NO;
	}
#line 5821 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 3201 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = YES;
	}
#line 5829 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 3208 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 5837 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 3214 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) != C_TOP) {
			l_yyerror(Curr_filename, yylineno,
					"%s not valid here", yytext);
		}
		(yyval.intval) = ENDING_TOP;
	}
#line 5849 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 3223 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = 1;
	}
#line 5857 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 3229 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = -1;
	}
#line 5865 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 3234 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = NO;
	}
#line 5873 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 3240 "src/mup/gram.y" /* yacc.c:1646  */
    {
		switch ((yyvsp[0].intval)) {
		case MINOR:
			(yyval.intval) = YES;
			break;
		case MAJOR:
			(yyval.intval) = NO;
			break;
		default:
			(yyval.intval) = NO;
			yyerror("must be major or minor");
			break;
		}
	}
#line 5892 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 3256 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = P_LINE;
	}
#line 5900 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 3262 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = P_ALTPEDSTAR;
	}
#line 5908 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 3268 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = P_PEDSTAR;
	}
#line 5916 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 3276 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = TR_BOTH;
	}
#line 5924 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 3282 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 5932 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 3287 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 5939 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 3291 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Mirrored = NO;
	}
#line 5947 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 3297 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Mirrored = YES;
	}
#line 5955 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 3302 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) == FONT_UNKNOWN) {
			(yyvsp[0].intval) = Curr_font;
		}
		if ((yyvsp[-1].intval) == FAMILY_DFLT) {
			/* user didn't specify a family. Use the current
			 * family, unless we don't have one yet, in which
			 * case look it up */
			if (Curr_family == FAMILY_DFLT) {
				Curr_family = Score.fontfamily;
			}
			Titlefont =  Curr_family + (yyvsp[0].intval);
		}
		else {
			Titlefont = (yyvsp[-1].intval) + (yyvsp[0].intval);
		}
	}
#line 5977 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 3321 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = FONT_UNKNOWN;
	}
#line 5985 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 3327 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 5993 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 3332 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = FAMILY_DFLT;
	}
#line 6001 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 3337 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 6009 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 3342 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Titlesize = Curr_size;
	}
#line 6017 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 3348 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Titlesize = (yyvsp[-1].intval);
	}
#line 6025 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 3354 "src/mup/gram.y" /* yacc.c:1646  */
    {
		String1 = (yyvsp[0].stringval);
		Extra = extra_needed(Titlefont, Titlesize, &String1);
		(void) proc_printcmd(J_CENTER, (struct INPCOORD *) 0, String1,
			Titlefont, Titlesize, YES, NO, PU_NORMAL, NO, 0, Extra);
	}
#line 6036 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 3363 "src/mup/gram.y" /* yacc.c:1646  */
    {
		double tmp_extra;
		struct PRINTDATA *print1_p;
		struct PRINTDATA *print2_p;

		/* If one is taller than the default for the font/size,
		 * figure out how much more to add on. */
		String1 = (yyvsp[-1].stringval);
		Extra = extra_needed(Titlefont, Titlesize, &String1);
		String2 = (yyvsp[0].stringval);
		tmp_extra = extra_needed(Titlefont, Titlesize, &String2);
		Extra = MAX(Extra, tmp_extra);

		print1_p = proc_printcmd(J_LEFT, (struct INPCOORD *) 0, String1,
				Titlefont, Titlesize, YES, NO, PU_NORMAL,
				NO, 0, Extra);
		print2_p = proc_printcmd(J_RIGHT, (struct INPCOORD *) 0, String2,
				Titlefont, Titlesize, NO, NO, PU_NORMAL,
				NO, 0, (double) 0.0);
		mirror(print1_p, print2_p);
	}
#line 6062 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 3387 "src/mup/gram.y" /* yacc.c:1646  */
    {
		double tmp_extra;
		char *string3;
		struct PRINTDATA *print1_p;
		struct PRINTDATA *print2_p;

		String1 = (yyvsp[-2].stringval);
		Extra = extra_needed(Titlefont, Titlesize, &String1);
		String2 = (yyvsp[-1].stringval);
		tmp_extra = extra_needed(Titlefont, Titlesize, &String2);
		Extra = MAX(Extra, tmp_extra);
		string3 = (yyvsp[0].stringval);
		tmp_extra = extra_needed(Titlefont, Titlesize, &string3);
		Extra = MAX(Extra, tmp_extra);

		print1_p = proc_printcmd(J_LEFT, (struct INPCOORD *) 0, String1,
				Titlefont, Titlesize, YES, NO, PU_NORMAL,
				NO, 0, Extra);
		(void) proc_printcmd(J_CENTER, (struct INPCOORD *) 0, String2,
				Titlefont, Titlesize, NO, NO, PU_NORMAL,
				NO, 0, (double) 0.0);
		print2_p = proc_printcmd(J_RIGHT, (struct INPCOORD *) 0, string3,
				Titlefont, Titlesize, NO, NO, PU_NORMAL,
				NO, 0, (double) 0.0);
		mirror(print1_p, print2_p);
	}
#line 6093 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 3415 "src/mup/gram.y" /* yacc.c:1646  */
    {
		char *p;		/* pointer through the string */
		int backslash_count;	/* how many backslashes in a row */
		int font, size;		/* at end of \n-delimited segment */
		char *string_start;	/* where current segment begins */

		/* Convert unescaped input newlines to spaces.
		 * The +2 in the 'for' initialization is to skip font/size.
		 */
		backslash_count = 0;
		string_start = (yyvsp[-2].stringval);
		/* If we are running on a file using \r or \r\n for
		 * line separator, normalize to \n instead */
		for (p = string_start + 2; *p != 0; p++) {
			if (*p == '\r') {
				if ( *(p+1) != '\n') {
					/* \r by itself. Use \n instead */
					*p = '\n';
				}
				else {
					/* delete the \r */
					char *src, *dest;
					for (src = p + 1, dest = p;  ; src++, dest++) { 
						*dest = *src;
						if (*src == '\0') {
							break;
						}
					}
				}
			}
		}

		font = Titlefont;
		size = Titlesize;
		for (p = string_start + 2; *p != 0; p++) {
			/* Real newlines not preceded by an odd number
			 * of backslashes are converted to spaces. */
			if (*p == '\n' && (backslash_count & 0x1) == 0) {
				*p = ' ';
			}

			/* Count up number of consecutive backslashes.
			 * Also, if user explicitly uses \n, split into
			 * a new paragraph
			 */
			if (*p == '\\') {
				backslash_count++;
				if (((backslash_count & 0x1) == 1)
						&& ( *(p+1) == 'n') ) {
					/* Need to split.
					 * Terminate the current string
					 * where we are in it, and process it,
					 * then arrange to continue processing
					 * on the rest of the string.
					 */
					*p = '\0';
					(void) fix_string(string_start,
						font, size,
						Curr_filename, yylineno);
					String1 = map_print_str(strdup(string_start), Curr_filename, yylineno);
					(void) proc_printcmd((yyvsp[-6].intval), (struct INPCOORD*) 0,
						String1, font, size,
						YES, NO, PU_NORMAL, NO, 0, 0.0);

					/* The user could change font/size
					 * in mid-string with \f() and/or \s().
					 * so we have to determine what they
					 * are at the end of the current segment
					 * and use that for making the copy
					 * of the remainder of the string.
					 * The original copy of the remainder
					 * of the string gets "memory leaked,"
					 * but this is a rare case, so not
					 * worth worrying about.
					 */
					end_fontsize(String1, &font, &size);
					string_start = copy_string(p+2, font, size);
					p = string_start + 1;
					backslash_count = 0;
				}
			}
			else {
				backslash_count = 0;
			}
		}
		(void) fix_string(string_start, font, size,
					Curr_filename, yylineno);
		String1 = map_print_str(strdup(string_start), Curr_filename, yylineno);
		(void) proc_printcmd((yyvsp[-6].intval), (struct INPCOORD*) 0, String1,
				font, size, YES, NO, PU_NORMAL, NO, 0, 0.0);
	}
#line 6189 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 3509 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Use same paragraph time as last time (or default if
		 * this is the first paragraph ever in this song.) */
		(yyval.intval) = Curr_paratype;
	}
#line 6199 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 3517 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Curr_paratype = (yyvsp[0].intval);
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 6208 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 3659 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* make a copy */
		if (Curr_family == FAMILY_DFLT) {
			Curr_family = Score.fontfamily;
		}
		(yyval.stringval) = copy_string((yyvsp[0].stringval), Curr_family + Curr_font, Curr_size);
	}
#line 6220 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 3669 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* append new string part to existing string */
		MALLOCA(char, (yyval.stringval), strlen((yyvsp[-2].stringval)) + strlen((yyvsp[0].stringval)) + 1);
		sprintf((yyval.stringval), "%s%s", (yyvsp[-2].stringval), (yyvsp[0].stringval));
		FREE((yyvsp[-2].stringval));
	}
#line 6231 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 3679 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.stringval) = stripquotes(yytext);
	}
#line 6239 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 3685 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.stringval) = string_func((yyvsp[-3].intval), (yyvsp[-1].stringval) + 2);
	}
#line 6247 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 3691 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(void) contextcheck(C_MUSIC, "music information");
		tssv_line();
		/* reset flags for next voice */
		Defining_multiple = NO;
		Curr_grpsyl_p = (struct GRPSYL *) 0;
		Good_till_canceled = NO;
		free_extra_time();
		Prev_grpsyl_p = 0;
		Meas_rpt_type = MRT_NONE;
	}
#line 6263 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 3704 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Here's the deal: the staff/voice specification
		 * could be lists of staff ranges and/or voices.
		 * We need a separate copy of the groupinfo
		 * for each staff/voice. So as we parse the sv_spec,
		 * we remember which staffs and voices are specified,
		 * and keep a pointer to the first STAFF in the measure.
		 * Then after collecting the groupinfo,
		 * we make copies of the group info for each staff/voice given.
		 * It has to be copies rather than just a pointer to the
		 * same stuff, because the coordinates will be different
		 * for each staff/voice. */

		/* attach the groupinfo to each of the STAFF structs */
		link_groups();
	}
#line 6284 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 3723 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_multirest((yyvsp[-1].intval));
		/* If there are alternating time signatures, figure out
		 * which one should be in effect at the end of the multirest */
		if (Alt_timesig_list != 0) {
			int m;

			/* The Next_alt_timesig is already pointing to
			 * the value for after the first measure in the
			 * multirest, so have to subtract 1 here */
			for (m = 0; m < (yyvsp[-1].intval) - 1; m++) {
				if (Next_alt_timesig == 0) {
					/* Shouldn't really ever get here,
					 * since other code should do the
					 * wrap-around, but just in case... */
					Next_alt_timesig = Alt_timesig_list;
					continue;
				}
				do {
					Next_alt_timesig++;
					if (*Next_alt_timesig == TSR_END) {
						Next_alt_timesig = Alt_timesig_list;
						break;
					}
				} while (*Next_alt_timesig != TSR_ALTERNATING);
			}
			if (*Next_alt_timesig == TSR_ALTERNATING) {
				Next_alt_timesig++;
			}
		}
		Currstruct_p = (struct MAINLL *) 0;
	}
#line 6321 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 3758 "src/mup/gram.y" /* yacc.c:1646  */
    {
		free_staffrange();
	}
#line 6329 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 3763 "src/mup/gram.y" /* yacc.c:1646  */
    {
		begin_range(PL_UNKNOWN);
	}
#line 6337 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 3768 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Chord_at_a_time = NO;
	}
#line 6345 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 3774 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Chord_at_a_time = YES;
	}
#line 6353 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 3789 "src/mup/gram.y" /* yacc.c:1646  */
    {
		begin_map();
	}
#line 6361 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 3794 "src/mup/gram.y" /* yacc.c:1646  */
    {
		end_map();
	}
#line 6369 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 373:
#line 3799 "src/mup/gram.y" /* yacc.c:1646  */
    {
		map_item();
	}
#line 6377 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 374:
#line 3805 "src/mup/gram.y" /* yacc.c:1646  */
    {
		map_item();
		Defining_multiple = YES;
	}
#line 6386 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 3811 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* initialize grpsyl info */
		Curr_grpsyl_p = Last_grpsyl_p = (struct GRPSYL *) 0;
	}
#line 6395 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 377:
#line 3821 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* prepare for a new set of ranges */
		begin_range(Place);
		Defining_multiple = YES;
	}
#line 6405 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 378:
#line 3828 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* data is for staff with only one voice */
		save_vno_range(1, 1);
		add_to_sv_list();
	}
#line 6415 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 379:
#line 3836 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) == YES) {
			add_to_sv_list();
		}
	}
#line 6425 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 3845 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* set flag as to whether we are processing tab staff
		 * information or normal staff info */
		Doing_tab_staff = is_tab_range();
	}
#line 6435 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 382:
#line 3855 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* several staffs have the same note data */
		Defining_multiple = YES;
	}
#line 6444 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 3861 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* remember which staffs we are currently getting data for */
		/* if only a single number, not a range, staff_range will be
		 * 0, so use staffnum as high and low of range */
		save_staff_range((yyvsp[-1].intval), ((yyvsp[0].intval) == 0 ? (yyvsp[-1].intval) : (yyvsp[0].intval)));
	}
#line 6455 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 384:
#line 3869 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* empty - no range, just a single number */
		(yyval.intval) = 0;
	}
#line 6464 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 3876 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Defining_multiple = YES;
		(yyval.intval) = (yyvsp[0].intval);
		if ((yyvsp[0].intval) == 0) {
			yyerror("staff of 0 is illegal");
		}
	}
#line 6476 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 3886 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* note data applies to a single voice */
		if (rangecheck((yyvsp[-1].intval), MINVOICES, MAXVOICES, "voice") == YES) {
			if (Doing_vcombine == YES) {
				save_vcombine_range((yyvsp[-1].intval), (yyvsp[-1].intval));
			}
			else {
				save_vno_range((yyvsp[-1].intval), (yyvsp[-1].intval));
			}
			(yyval.intval) = YES;
		}
		else {
			(yyval.intval) = NO;
		}
	}
#line 6496 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 3904 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* note data applies to range of voices */
		if (rangecheck((yyvsp[-3].intval), MINVOICES, MAXVOICES, "voice") == YES &&
				rangecheck((yyvsp[-1].intval), MINVOICES, MAXVOICES, "voice") == YES) {
			if ((yyvsp[-1].intval) < (yyvsp[-3].intval)) {
				l_yyerror(Curr_filename, yylineno,
					"end of voice range is smaller than beginning");
				(yyval.intval) = NO;
			}
			else {
				if (Doing_vcombine == YES) {
					save_vcombine_range((yyvsp[-3].intval), (yyvsp[-1].intval));
				}
				else {
					save_vno_range((yyvsp[-3].intval), (yyvsp[-1].intval));
					Defining_multiple = YES;
				}
				(yyval.intval) = YES;
			}
		}
		else {
			(yyval.intval) = NO;
		}
	}
#line 6525 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 3934 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Doing_vcombine == NO) {
			Defining_multiple = YES;
		}
	}
#line 6535 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 3951 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Associate any TIMEDSSVs with this group */
		if (Curr_tssv_p != 0) {
			tssv_setgrpsyl(Curr_grpsyl_p);
			Curr_tssv_p = 0;
		}

		/* if no custom beaming indicated, fill in based on previous. */
		if ( Curr_grpsyl_p->beamloc == NOITEM) {
			setbeamloc(Curr_grpsyl_p, Last_grpsyl_p);
		}

		/* later we check that if there is an 'm', it is
		 * the only thing in the measure */

		link_notegroup(Curr_grpsyl_p, Last_grpsyl_p);
		Curr_marklist = 0;
		/* Save pointer to this group, in case there are additive
		 * times, and the next group gets its time value from this
		 * group. In that case, we need this group, not the last one
		 * of the added groups. */
		Prev_grpsyl_p = Curr_grpsyl_p;
		/* Add groups if there were additive time values. */
		if (Extra_time_p != 0) {
			Curr_grpsyl_p = expandgrp(Curr_grpsyl_p, Extra_time_p);
			/* If there was a custom beam ebm on something with
			 * additive time, we need make sure ENDITEM is on only
			 * the last of the expanded groups. */
			if (Curr_grpsyl_p != Prev_grpsyl_p
					&& Prev_grpsyl_p->beamloc == ENDITEM) {
				struct GRPSYL *g_p;
				for (g_p = Prev_grpsyl_p; g_p != Curr_grpsyl_p;
							g_p = g_p->next) {
					g_p->beamloc = INITEM;
				}
				Curr_grpsyl_p->beamloc = ENDITEM;
			}
			Last_grpsyl_p = Curr_grpsyl_p->prev;
		}
		Curr_timelist_p = 0;
	}
#line 6581 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 4009 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Chord_at_a_time == YES) {
			yyerror("mid-measure changes not allowed on chord-at-a-time input");
		}
	}
#line 6591 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 4018 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Curr_tssv_p = tssv_create(C_SCORE);
	}
#line 6599 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 4024 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Curr_tssv_p = tssv_create(C_STAFF);
	}
#line 6607 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 4030 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Curr_tssv_p = tssv_create(C_VOICE);
	}
#line 6615 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 4044 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p != 0 && Curr_grpsyl_p->grpsyl == GS_GROUP
				&& Curr_grpsyl_p->grpvalue == GV_ZERO) {
			yyerror("mid-measure clef change not allowed after grace note\n");
		}
		tssv_update(Curr_tssv_p, (yyvsp[-3].intval), (yyvsp[-1].intval));
		if (Curr_tssv_p != 0) {
			Curr_tssv_p->ssv.forceprintclef = (yyvsp[0].intval);
		}
	}
#line 6630 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 4057 "src/mup/gram.y" /* yacc.c:1646  */
    {
		switch ((yyvsp[-2].intval)) {

		case DEFOCT:
		case RELEASE:
			tssv_update(Curr_tssv_p, (yyvsp[-2].intval), (yyvsp[0].intval));
			break;

		default:
			l_warning(Curr_filename, yylineno,
				"parameter type cannot be changed mid-measure; ignoring");
			break;
		}
	}
#line 6649 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 4074 "src/mup/gram.y" /* yacc.c:1646  */
    {
		switch ((yyvsp[-2].intval)) {

		case ALIGNRESTS:
			tssv_update(Curr_tssv_p, (yyvsp[-2].intval), (yyvsp[0].intval));
			break;

		default:
			l_warning(Curr_filename, yylineno,
				"parameter type cannot be changed mid-measure; ignoring");
			break;
		}
	}
#line 6667 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 4090 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 6674 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 4099 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Good_till_canceled == NO) {
			/* use default attributes */
			Curr_grpsyl_p->grpvalue = GV_NORMAL;
			Curr_grpsyl_p->grpsize = GS_NORMAL;
			Curr_grpsyl_p->headshape = HS_UNKNOWN;
		}
		else {
			/* re-use previous style */
			copy_attributes(Curr_grpsyl_p, Last_grpsyl_p);
			Curr_grpsyl_p->with_was_gtc = YES;
		}
	}
#line 6692 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 4115 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Good_till_canceled = NO;
	}
#line 6700 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 4121 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 6707 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 4125 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Good_till_canceled = NO;
	}
#line 6715 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 4131 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Good_till_canceled = YES;
	}
#line 6723 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 4136 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 6730 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 4141 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Good_till_canceled == YES) {
			yyerror("can't use ... and more than one [] on same chord");
		}
	}
#line 6740 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 4148 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* NULL token to cause allocation of a GRPSYL struct */
		Last_grpsyl_p = Curr_grpsyl_p;
		Curr_grpsyl_p = newGRPSYL(GS_GROUP);
	}
#line 6750 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 4155 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* an empty marklist means we should use
		 * the same attributes as the last time */
		copy_attributes(Curr_grpsyl_p, Last_grpsyl_p);
	}
#line 6760 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 4172 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Curr_grpsyl_p->nwith = (short) Item_count;
		Curr_grpsyl_p->withlist = Curr_marklist;
		if ((yyvsp[0].intval) != PL_UNKNOWN) {
			int m;

			/* User specified a side, so remember that */
			for (m = Mark_start; m < Item_count; m++) {
				Curr_marklist[m].place = (yyvsp[0].intval);
			}
		}
	}
#line 6777 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 4196 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p->stemdir != UNKNOWN &&
					Curr_grpsyl_p->stemdir != (yyvsp[0].intval)) {
			l_warning(Curr_filename, yylineno,
				"both stem directions specified; using last instance");
		}
		if (Doing_tab_staff == YES) {
			l_warning(Curr_filename, yylineno,
				"stem direction specification is pointless on tab staff; ignoring");
		}
		else {
			Curr_grpsyl_p->stemdir = (yyvsp[0].intval);
		}
	}
#line 6796 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 4213 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].intval) != DIST) {
			l_warning(Curr_filename, yylineno,
				"unexpected parameter name; ignoring");
		}
		else {
			if (Curr_grpsyl_p->restdist != NORESTDIST &&
					Curr_grpsyl_p->restdist != (yyvsp[-1].intval) * (yyvsp[0].intval)) {
				l_warning(Curr_filename, yylineno,
						"more than one dist value specified; using last instance");
			}
			Curr_grpsyl_p->restdist = (yyvsp[-1].intval) * (yyvsp[0].intval);
		}
	}
#line 6815 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 4230 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p->ho_usage != HO_NONE &&
				Curr_grpsyl_p->ho_usage != (yyvsp[0].intval)) {
			l_warning(Curr_filename, yylineno,
				"More than one ho type specified; last instance used");
		}
		Curr_grpsyl_p->ho_usage = (yyvsp[0].intval);
	}
#line 6828 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 4241 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p != 0) {
			if (Curr_grpsyl_p->headshape != HS_UNKNOWN) {
				l_warning(Curr_filename, yylineno,
					"multiple head shapes specified, using last");
			}
			/* +2 to skip past extraneous font/size */
			if (Doing_tab_staff == YES && strcmp((yyvsp[0].stringval) + 2, "allx") != 0) {
				yyerror("allx is the only headshape allowed on tab staffs");
			}
			if ((Curr_grpsyl_p->headshape = get_shape_num((yyvsp[0].stringval) + 2))
					== HS_UNKNOWN) {
				l_yyerror(Curr_filename, yylineno,
					"'%s' is not a valid head shape name",
					ascii_str((yyvsp[0].stringval), YES, NO, TM_NONE));
			}
		}
		else {
			pfatal("Curr_grpsyl_p was null for setting hs");
		}
		/* We don't need the name anymore; we have its corresponding
		 * number that we use internally. */
		FREE((yyvsp[0].stringval));
	}
#line 6857 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 4268 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p->stemlen != STEMLEN_UNKNOWN &&
				fabs(Curr_grpsyl_p->stemlen - (yyvsp[0].floatval) * STEPSIZE) > 0.0001) {
			l_warning(Curr_filename, yylineno,
				"more than one len specified; using last instance");
		}
		Curr_grpsyl_p->stemlen = (yyvsp[0].floatval) * STEPSIZE;
	}
#line 6870 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 4279 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) <= 0) {
			yyerror("slash number must be > 0");
		}
		else if ((yyvsp[0].intval) > 8) {
			/* we decided 8 slashes would be at least 256th note
			 * or shorter, and 256th is the shortest note we
			 * support, 8 slashes is plenty */
			l_warning(Curr_filename, yylineno,
				"number of slashes only allowed to be <= 8; limiting to 8");
			(yyvsp[0].intval) = 8;
		}
		if (Curr_grpsyl_p->slash_alt > 0 &&
					Curr_grpsyl_p->slash_alt != (yyvsp[0].intval)) {
			l_warning(Curr_filename, yylineno,
				"more than one slash value specified; using last instance");
		}
		if (Curr_grpsyl_p->slash_alt < 0) {
			yyerror("only one slash/alt allowed per group");
		}
		Curr_grpsyl_p->slash_alt = (yyvsp[0].intval);
	}
#line 6897 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 4304 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = HO_RIGHT;
	}
#line 6905 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 4310 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = HO_LEFT;
	}
#line 6913 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 433:
#line 4316 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* We want to silently accept identical values specified
		 * more than once, so use fuzzy compare to deal with roundoff */
		if (Curr_grpsyl_p->ho_usage == HO_VALUE &&
				fabs(Curr_grpsyl_p->ho_value - (yyvsp[-1].intval) * (yyvsp[0].floatval)) > 0.0001) {
			l_warning(Curr_filename, yylineno,
				"More than one ho value specified; last instance used");
		}
		if ((yyvsp[-1].intval) == 0) {
			Curr_grpsyl_p->ho_value = (yyvsp[0].floatval);
		}
		else {
			Curr_grpsyl_p->ho_value = (yyvsp[-1].intval) * (yyvsp[0].floatval);
		}
		(yyval.intval) = HO_VALUE;
	}
#line 6934 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 4335 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = 0;
	}
#line 6942 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 4341 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 6950 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 4363 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyvsp[0].floatval) *= (yyvsp[-1].intval);
		if (fabs(Curr_grpsyl_p->beamslope - NOBEAMANGLE) > 0.01) {
			l_warning(Curr_filename, yylineno,
				"multiple slope values specified; using last one");
		}
		if (frangecheck((yyvsp[0].floatval), MINBEAMANGLE, MAXBEAMANGLE, "slope") == YES) {
			Curr_grpsyl_p->beamslope = (yyvsp[0].floatval);
		}
	}
#line 6965 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 4376 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) <= 0) {
			yyerror("alt number must be > 0");
		}
		if (Curr_grpsyl_p->slash_alt != 0) {
			yyerror("only one slash/alt allowed per group");
		}
		if (Doing_tab_staff == YES) {
			l_warning(Curr_filename, yylineno,
				"alt not allowed on tablature staff; ignoring");
		}
		else {
			/* Should at least keep small enough
			 * that 1 shifted left by this still fits
			 * in a 16-bit int. For a while we limited to 15,
			 * but for slashes, we limit to 8, and
			 * that seems like more than enough for here too. */
			if ((yyvsp[0].intval) > 8) {
				l_warning(Curr_filename, yylineno,
					"alt value too large; limiting to 8");
				(yyvsp[0].intval) = 8;
			}
			Curr_grpsyl_p->slash_alt = -(yyvsp[0].intval);
		}
	}
#line 6995 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 4404 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p->phcount < PH_COUNT) {
			if ((yyvsp[-2].intval) != L_NORMAL && (yyvsp[-2].intval) != L_DOTTED && (yyvsp[-2].intval) != L_DASHED) {
				l_warning(Curr_filename, yylineno,
					"phrase style modifier can only be dotted or dashed");
				(yyvsp[-2].intval) = L_NORMAL;
			}
			Curr_grpsyl_p->phplace[Curr_grpsyl_p->phcount] = (char) (yyvsp[0].intval);
			Curr_grpsyl_p->phlinetype[Curr_grpsyl_p->phcount] = (char) (yyvsp[-2].intval);
			Curr_grpsyl_p->phcount++;
		}
		else {
			l_yyerror(Curr_filename, yylineno,
				"too many ph marks on the same chord; limiting to %d", PH_COUNT);
		}
	}
#line 7016 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 4423 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p->ephcount < PH_COUNT) {
			Curr_grpsyl_p->ephcount++;
		}
		else {
			l_yyerror(Curr_filename, yylineno,
				"too many eph marks on the same chord; limiting to %d", PH_COUNT);
		}
	}
#line 7030 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 4434 "src/mup/gram.y" /* yacc.c:1646  */
    {
		int n;

		/* add a slur to each note in the chord. Don't know
		 * which pitch to slur to yet, just that it will be to
		 * the "matching" note in the next chord, so use
		 * special magic pitch of 'M' to convey this */
		for (n = 0; n < Curr_grpsyl_p->nnotes; n++) {
			add_slurto(Curr_grpsyl_p, 'M', USE_DFLT_OCTAVE, n, (yyvsp[-2].intval));
			set_slurdir(Curr_grpsyl_p, -1, (yyvsp[-1].intval), (yyvsp[0].intval));
		}
	}
#line 7047 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 4449 "src/mup/gram.y" /* yacc.c:1646  */
    {
		int n;

		Curr_grpsyl_p->tie = YES;
		for (n = 0; n < Curr_grpsyl_p->nnotes; n++) {
			Curr_grpsyl_p->notelist[n].tie = YES;
			Curr_grpsyl_p->notelist[n].tiestyle = (yyvsp[-2].intval);
			Curr_grpsyl_p->notelist[n].tiedir = (yyvsp[-1].intval);
			Curr_grpsyl_p->notelist[n].tied_to_voice = (yyvsp[0].intval);
		}
	}
#line 7063 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 4462 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_marklist == 0) {
			/* allocate space for a list of marks */
			MALLOC(WITH_ITEM, Curr_marklist, ITEMS);
			Item_count = 0;
			Max_items = ITEMS;
		}
		Mark_start = Item_count;
	}
#line 7077 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 4473 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = PL_UNKNOWN;
	}
#line 7085 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 4479 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 7093 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 4484 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = UNKNOWN;
	}
#line 7101 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 4490 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 7109 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 452:
#line 4496 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = NO_TO_VOICE;
	}
#line 7117 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 4502 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) >= MINVOICES && (yyvsp[0].intval) <= MAXVOICES) {
			/* Note that if the current staff doesn't have this
			 * to voice, that error will be caught later,
			 * by find_to_group() in tie.c */
			(yyval.intval) = (yyvsp[0].intval);
		}
		else {
			l_yyerror(Curr_filename, yylineno,
					"to voice must be between %d and %d",
					MINVOICES, MAXVOICES);
			(yyval.intval) = NO_TO_VOICE;
		}
	}
#line 7136 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 456:
#line 4525 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* if too many items, get some more space */
		if (Item_count >= Max_items) {
			Max_items += ITEMS;
			if ((Curr_marklist = (struct WITH_ITEM *) realloc(Curr_marklist,
						Max_items * sizeof(struct WITH_ITEM)))
						==  0) {
				l_no_mem(__FILE__, __LINE__);
			}
		}
		Curr_marklist[Item_count].string = (yyvsp[0].stringval);
		Curr_marklist[Item_count].place = PL_UNKNOWN;
		Item_count++;
	}
#line 7155 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 4541 "src/mup/gram.y" /* yacc.c:1646  */
    {
		MALLOCA(char, (yyval.stringval), strlen((yyvsp[0].stringval)) + 3);
		(yyval.stringval)[0] = FONT_TR;
		(yyval.stringval)[1] = DFLT_SIZE;
		sprintf((yyval.stringval) + 2, "%s", (yyvsp[0].stringval));
	}
#line 7166 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 4554 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.stringval) = (Curr_grpsyl_p->grpsize == GS_NORMAL
					? "\\(dot)" : "\\(smdot)");
	}
#line 7175 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 460:
#line 4561 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.stringval) = (Curr_grpsyl_p->grpsize == GS_NORMAL
					? "\\(leg)" : "\\(smleg)");
	}
#line 7184 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 4568 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.stringval) = (Curr_grpsyl_p->grpsize == GS_NORMAL
					? "\\(acc_gt)" : "\\(smacc_gt)");
	}
#line 7193 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 4575 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.stringval) = (Curr_grpsyl_p->grpsize == GS_NORMAL
					? "\\(acc_hat)" : "\\(smacc_hat)");
	}
#line 7202 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 463:
#line 4581 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p->grpvalue == GV_ZERO) {
			Curr_grpsyl_p->grpsize = GS_TINY;
		}
		else {
			Curr_grpsyl_p->grpvalue = GV_NORMAL;
			Curr_grpsyl_p->grpsize = GS_SMALL;
		}
	}
#line 7216 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 464:
#line 4593 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Curr_grpsyl_p->grpvalue = GV_ZERO;
		if (Curr_grpsyl_p->grpsize == GS_SMALL) {
			Curr_grpsyl_p->grpsize = GS_TINY;
		}
		else {
			Curr_grpsyl_p->grpsize = GS_SMALL;
		}
	}
#line 7230 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 465:
#line 4605 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p->headshape != HS_UNKNOWN) {
			l_warning(Curr_filename, yylineno,
				"diam is overriding previous headshapes specification");
		}
		Curr_grpsyl_p->headshape = get_shape_num("diam");
	}
#line 7242 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 466:
#line 4615 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p->headshape != HS_UNKNOWN) {
			l_warning(Curr_filename, yylineno,
				"xnote is overriding previous headshapes specification");
		}
		Curr_grpsyl_p->headshape = get_shape_num(
					Doing_tab_staff == YES ? "allx" : "x");
	}
#line 7255 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 4626 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = UP;
	}
#line 7263 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 468:
#line 4632 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = DOWN;
	}
#line 7271 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 469:
#line 4638 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* custom beaming cannot be nested */
		struct GRPSYL *prev_like_gs_p;
		/* Find previous group with same grace-ness. Can't use
		 * prevsimilar() here, since it looks at grpcont too. */
		for (prev_like_gs_p = Last_grpsyl_p; prev_like_gs_p != 0 &&
			prev_like_gs_p->grpvalue != Curr_grpsyl_p->grpvalue;
			prev_like_gs_p = prev_like_gs_p->prev) {
			;
		}
		if (prev_like_gs_p != 0 &&
				((prev_like_gs_p->beamloc == STARTITEM)
				|| (prev_like_gs_p->beamloc == INITEM)) ) {
			yyerror("custom beaming may not be nested");
		}
		/* Non-custom beaming, if any, is done later, in do_bar() */
		else {
			/* begin custom beaming */
			Curr_grpsyl_p->beamloc = STARTITEM;
			if (Curr_grpsyl_p->basictime < 8 && (yyvsp[0].intval) == CS_SAME) {
				yyerror("beamed notes must be 8th or shorter");
			}
		}
		Curr_grpsyl_p->beamto = (yyvsp[0].intval);
	}
#line 7301 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 470:
#line 4666 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Curr_grpsyl_p->autobeam = STARTITEM;
	}
#line 7309 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 471:
#line 4672 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Curr_grpsyl_p->autobeam = ENDITEM;
	}
#line 7317 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 472:
#line 4678 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Curr_grpsyl_p->breakbeam = YES;
	}
#line 7325 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 473:
#line 4684 "src/mup/gram.y" /* yacc.c:1646  */
    {
		struct GRPSYL *last_nongrace_p;

		/* find the previous group, skipping grace groups */
		for (last_nongrace_p = Last_grpsyl_p;
				last_nongrace_p != (struct GRPSYL *) 0
				&& last_nongrace_p->grpvalue == GV_ZERO;
				last_nongrace_p = last_nongrace_p->prev) {
			;
		}

		/* check that a custom beam is in progress */
		if ((last_nongrace_p == (struct GRPSYL *) 0)
				|| ((last_nongrace_p != (struct GRPSYL *) 0)
				&& (last_nongrace_p->beamloc != STARTITEM)
				&& (last_nongrace_p->beamloc != INITEM) )) {
			l_warning(Curr_filename, yylineno,
				"'ebm' unexpected: no custom beaming in progress; ignoring");
		}
		else {
			Curr_grpsyl_p->beamloc = ENDITEM;
			Curr_grpsyl_p->beamto = last_nongrace_p->beamto;
			if (Curr_grpsyl_p->basictime < 8
					&& Last_grpsyl_p->beamto == CS_SAME) {
				yyerror("beamed notes must be 8th or shorter");
			}
		}
	}
#line 7358 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 474:
#line 4714 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Use the same as last time or default timeunit.
		 * If that involves additive time values,
		 * save pointer to that info in Extra_time_p for later use. */
		Extra_time_p = copy_timeunit(Curr_grpsyl_p, Prev_grpsyl_p,
						Extra_time_p);
	}
#line 7370 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 475:
#line 4724 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p->is_meas == YES) {
			Curr_grpsyl_p->fulltime = Score.time;
		}
		else {
			Curr_grpsyl_p->fulltime = (yyvsp[0].ratval);
		}
	}
#line 7383 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 476:
#line 4734 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = CS_SAME;
	}
#line 7391 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 477:
#line 4740 "src/mup/gram.y" /* yacc.c:1646  */
    {
		CSBused = YES;
		switch ((yyvsp[0].intval)) {
		case PL_ABOVE:
			(yyval.intval) = CS_ABOVE;
			break;
		case PL_BELOW:
			(yyval.intval) = CS_BELOW;
			break;
		default:
			yyerror("bm with staff must be 'above' or 'below'");
			(yyval.intval) = CS_SAME;
		}
	}
#line 7410 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 478:
#line 4756 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.ratval).n = (yyvsp[0].intval);
		(yyval.ratval).d = 1;

		/* if filling in a GRPSYL struct, need to fill in basic time,
		 * could also be here due to beamstyle, in which case the
		 * Curr_grpsyl_p will be NULL, or when getting tuplet duration,
		 * in which case flag will be set */
		if (Curr_grpsyl_p != (struct GRPSYL *) 0
					&& Getting_tup_dur == NO) {
			/* If we are gathering basictime as part of a list
			 * of additive times, we will save the value a few
			 * lines down from here. But in the normal case,
			 * we set basictime in the current GRPSYL. */
			if (Extra_time_p == 0) {
				 Curr_grpsyl_p->basictime = multiwhole2basictime((yyvsp[0].intval));
			}
		}
		/* If doing additive times, need to save value. */
		if (Extra_time_p != 0) {
			Extra_basictime = multiwhole2basictime((yyvsp[0].intval));
		}
	}
#line 7438 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 479:
#line 4782 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* check that a power of two from 1 to MAXBASICTIME */
		if (power_of2check((yyvsp[0].intval), "note basic time value") == NO) {
			/* force to a power to two, so that other code
			 * (like in expandgrp) that expect a sane value
			 * will not blow up. This may lead to a somewhat
			 * misleading "time does not add up to time
			 * signature" message, but we don't know what
			 * time they really meant, and this is better
			 * than pfataling. */
			(yyvsp[0].intval) = 2;
		}
		/* can't use rangecheck here because the error message would
		 * say 0 and -1 are valid times, which is only true internally--
		 * the user has to use 1/2, 1/4, 1/8, or m. */
		if ((yyvsp[0].intval) < MINBASICTIME || (yyvsp[0].intval) > MAXBASICTIME) {
			l_yyerror(Curr_filename, yylineno,
				"time value must be between 1 and %d, or 1/2 or 1/4 or 1/8 or m",
				MAXBASICTIME);
			/* If user entered outrageous value, clamp to
			 * something semi-reasonable, else we could get
			 * rational overflow, and pfatal, even though it
			 * it is really a user error. */
			if ((yyvsp[0].intval) > MAXBASICTIME * 4) {
				(yyvsp[0].intval) = MAXBASICTIME * 4;
			}
		}
		(yyval.ratval).n = 1;
		/* avoid division by zero */
		if ((yyvsp[0].intval) == 0) {
			(yyvsp[0].intval) = 1;
		}
		(yyval.ratval).d = (yyvsp[0].intval);
		if (Curr_grpsyl_p != (struct GRPSYL *) 0
					&& Getting_tup_dur == NO) {
			if (Curr_timelist_p == 0) {
				Curr_grpsyl_p->basictime = (yyvsp[0].intval);
			}
		}
		/* If doing additive times, need to save value */
		if (Extra_time_p != 0) {
			Extra_basictime = (yyvsp[0].intval);
		}
	}
#line 7487 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 480:
#line 4829 "src/mup/gram.y" /* yacc.c:1646  */
    {
		free_extra_time();
	}
#line 7495 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 482:
#line 4839 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Set basictime to what we saved in basic_time_val rule,
		 * then calculate fulltime from that and number of dots. */
		Curr_timelist_p->basictime = Extra_basictime;
		Curr_timelist_p->fulltime = calcfulltime((yyvsp[-1].ratval), (yyvsp[0].intval));
		/* handle subtracted times by negating the fulltime */
		if ((yyvsp[-3].intval) == -1) {
			Curr_timelist_p->fulltime = rneg(Curr_timelist_p->fulltime);
		}
	}
#line 7510 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 483:
#line 4853 "src/mup/gram.y" /* yacc.c:1646  */
    {
		struct TIMELIST *timelist_p;

		MALLOC(TIMELIST, timelist_p, 1);
		/* Add to end of linked list */
		timelist_p->next = 0;
		/* Init fulltime to something to avoid garbage if there
		 * is a user input error */
		timelist_p->fulltime = Zero;
		if (Extra_time_p == 0) {
			Last_alloced_timelist_p = Extra_time_p = timelist_p;
		}
		else {
			Curr_timelist_p->next = timelist_p;
		}
		/* Keep track of where to append next item to list, if any */
		Curr_timelist_p = timelist_p;
	}
#line 7533 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 484:
#line 4874 "src/mup/gram.y" /* yacc.c:1646  */
    {
		User_meas_time = NO;
	}
#line 7541 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 485:
#line 4880 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p != (struct GRPSYL *) 0
					&& Getting_tup_dur == NO) {
			Curr_grpsyl_p->is_meas = YES;
			User_meas_time = YES;
			Meas_rpt_type = MRT_SINGLE;
		}
		else {
			yyerror("'m' is not valid here");
		}
	}
#line 7557 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 486:
#line 4893 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = MRT_SINGLE;
	}
#line 7565 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 487:
#line 4899 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = MRT_DOUBLE;
	}
#line 7573 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 488:
#line 4905 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = MRT_QUAD;
	}
#line 7581 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 489:
#line 4911 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = 0;
	}
#line 7589 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 490:
#line 4917 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* count up the number of dots */
		(yyval.intval) = (yyvsp[-1].intval) + 1;
	}
#line 7598 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 491:
#line 4923 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* We can't distinguish between the default 0.0 and
		 * if user explicitly sets to 0.0, so if they set to 0.0
		 * then to something else, we won't catch that as setting
		 * twice, but that shouldn't be common. Besides, if they
		 * expect them to be additive, adding to zero will work
		 * as they expect... Because of roundoff, we can't do
		 * exact compare for specifying the same value more than once,
		 * so treat as identical if pretty close. */
		if (Curr_grpsyl_p->padding != 0.0 && 
				fabs(Curr_grpsyl_p->padding - ((yyvsp[0].floatval) * STEPSIZE))
				> 0.0001) {
			l_warning(Curr_filename, yylineno,
				"padding specified more than once; using last instance");
		}
		Curr_grpsyl_p->padding = (yyvsp[0].floatval) * STEPSIZE;
	}
#line 7620 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 492:
#line 4943 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.floatval) = (float) (yyvsp[-1].intval) * (yyvsp[0].floatval);
	}
#line 7628 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 493:
#line 4948 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* no sign--must be a positive number */
		(yyval.intval) = 1;
	}
#line 7637 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 494:
#line 4955 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* user wants a negative number */
		(yyval.intval) = -1;
	}
#line 7646 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 495:
#line 4961 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Curr_grpsyl_p->grpcont = GC_NOTES;
		if ((yyvsp[0].intval) == 0) {
			/* no notes listed, use same as previous group */
			copy_notes(Curr_grpsyl_p, Last_grpsyl_p);
		}
		else {
			resize_notelist(Curr_grpsyl_p);
		}
	}
#line 7661 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 499:
#line 4986 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* allocate GRPSYL for the case where everything is defaulted
		 * from the previous group, with just an extra attribute
		 * like ? or ~ specified. */
		if (Curr_grpsyl_p == (struct GRPSYL *) 0) {
			/* shouldn't ever happen, but just in case... */
			Curr_grpsyl_p = newGRPSYL(GS_GROUP);
		}
		if (Last_grpsyl_p != (struct GRPSYL *) 0 &&
					Last_grpsyl_p->nnotes >= 1) {
			copy_notes(Curr_grpsyl_p, Last_grpsyl_p);
		}
		else if (Last_grpsyl_p != (struct GRPSYL *) 0 && 
				Last_grpsyl_p->grpcont == GC_REST) {
			Curr_grpsyl_p->grpcont = GC_REST;
		}
	}
#line 7683 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 500:
#line 5006 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p->grpcont == GC_NOTES &&
					Curr_grpsyl_p->nnotes > 0) {
			if (Curr_grpsyl_p->grpvalue == GV_ZERO) {
				Curr_grpsyl_p->notelist[Curr_grpsyl_p->nnotes - 1]
						.notesize = GS_TINY;
			}
			else {
				Curr_grpsyl_p->notelist[Curr_grpsyl_p->nnotes - 1]
						.notesize = GS_SMALL;
			}
		}
		else if (Curr_grpsyl_p->grpcont == GC_REST) {
			Curr_grpsyl_p->grpsize  = GS_SMALL;
		}
		else {
			yyerror("no note specified for '?'");
		}
	}
#line 7707 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 501:
#line 5028 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p->grpcont != GC_NOTES) {
			yyerror("can't tie a rest or space");
		}
		else if (Curr_grpsyl_p->nnotes > 0) {
			struct NOTE *n_p;
			n_p = &(Curr_grpsyl_p->notelist[Curr_grpsyl_p->nnotes - 1]);
			n_p->tie = YES;
			n_p->tiestyle = (yyvsp[-2].intval);
			n_p->tiedir = (yyvsp[-1].intval);
			n_p->tied_to_voice = (yyvsp[0].intval);
		}
		else {
			yyerror("no note specified for '~'");
		}
	}
#line 7728 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 502:
#line 5047 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p->nnotes > 0) {
			switch (Curr_grpsyl_p->notelist
                                        [Curr_grpsyl_p->nnotes - 1].letter) {
			case PP_REST:
				/* If we haven't already allocated space for
				 * the restc array, so that now. It could
				 * already be allocated if user specified
				 * more than one tag. */
				if (Curr_grpsyl_p->restc == 0) {
					MALLOCA(float, Curr_grpsyl_p->restc, NUMCTYPE);
				}
				addsym((yyvsp[0].stringval), Curr_grpsyl_p->restc, CT_NOTE);
				break;
			case PP_SPACE:
			case PP_RPT:
			case PP_NO_PITCH:  /* this one not really possible */
				addsym((yyvsp[0].stringval), Curr_grpsyl_p->c, CT_GRPSYL);
				break;
			default:
				addsym((yyvsp[0].stringval), Curr_grpsyl_p->notelist
					[Curr_grpsyl_p->nnotes - 1].c, CT_NOTE);
				break;
			}
			var_valid();
		}
		else if (Curr_grpsyl_p->grpcont == GC_REST) {
			/* This should really never be hit anymore since
			 * chord-at-a-time code was added, but shouldn't
			 * hurt to leave it, just in case. */
			addsym((yyvsp[0].stringval), Curr_grpsyl_p->c, CT_GRPSYL);
			var_valid();
		}
		else {
			l_yyerror(Curr_filename, yylineno,
				"no note specified for location tag '%s'", (yyvsp[0].stringval));
		}
	}
#line 7771 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 503:
#line 5088 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* this is for bend on a non-tablature staff */
		if (Doing_tab_staff == YES) {
			yyerror("^ bend not allowed on tablature staff; use quoted bend string");
		}
		else {
			add_slurto(Curr_grpsyl_p, (yyvsp[-1].intval), (yyvsp[0].intval),
					Curr_grpsyl_p->nnotes - 1, L_NORMAL);
			if (Curr_grpsyl_p->nnotes > 0) {
				Curr_grpsyl_p->notelist
						[Curr_grpsyl_p->nnotes - 1]
						.is_bend = YES;
			}
		}
	}
#line 7791 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 504:
#line 5106 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* this is for a small bend (1/4 step) on a non-tab staff */
		if (Doing_tab_staff == YES) {
			yyerror("^/ not allowed on tablature staff; use quoted bend string");
		}
		else if (Curr_grpsyl_p != 0 && Curr_grpsyl_p->nnotes > 0) {
			Curr_grpsyl_p->notelist[Curr_grpsyl_p->nnotes - 1]
					.smallbend = YES;
		}
	}
#line 7806 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 505:
#line 5119 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p->grpcont == GC_NOTES &&
					Curr_grpsyl_p->nnotes > 0) {
			if ((Curr_grpsyl_p->notelist[Curr_grpsyl_p->nnotes - 1]
					.headshape = get_shape_num((yyvsp[0].stringval) + 2))
					== HS_UNKNOWN) {
				l_yyerror(Curr_filename, yylineno,
					"'%s' is not a valid head shape name",
					ascii_str((yyvsp[0].stringval), YES, NO, TM_NONE));
			}
		}
		else {
			yyerror("no note specified for headshape");
		}
		FREE((yyvsp[0].stringval));
	}
#line 7827 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 506:
#line 5138 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p->nnotes == 0) {
			l_yyerror(Curr_filename, yylineno,
				"noteleft must be specified after note");
		}
		/* This check relies on the fact that the PP_* values are > 'g' */
		else if (Curr_grpsyl_p->notelist[Curr_grpsyl_p->nnotes - 1].letter > 'g' ) {
			l_warning(Curr_filename, yylineno,
					"noteleft can only be specified on a note");
		}
		else {
			if (Curr_grpsyl_p->notelist[Curr_grpsyl_p->nnotes - 1].noteleft_string != 0) {
				l_warning(Curr_filename, yylineno,
					"noteleft specified more than once; using last");
  fprintf(stderr, "previous string was %s\n", Curr_grpsyl_p->notelist[Curr_grpsyl_p->nnotes-1].noteleft_string);
			}
			Curr_grpsyl_p->notelist[Curr_grpsyl_p->nnotes - 1].noteleft_string = (yyvsp[0].stringval);
		}
	}
#line 7851 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 510:
#line 5171 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[-1].intval) + (yyvsp[0].intval);	/* total number of notes */
	}
#line 7859 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 511:
#line 5177 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = 0;
	}
#line 7867 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 512:
#line 5183 "src/mup/gram.y" /* yacc.c:1646  */
    {
		switch ((yyvsp[0].intval)) {
		case PL_ABOVE:
			Curr_grpsyl_p->stemto = CS_ABOVE;
			break;
		case PL_BELOW:
			Curr_grpsyl_p->stemto = CS_BELOW;
			break;
		default:
			yyerror("cross staff stem must be with 'above' or 'below'");
			Curr_grpsyl_p->stemto = CS_SAME;
		}
		if ((yyvsp[-1].intval) == 0) {
			/* Maybe this wouldn't really hurt to allow,
			 * but it's rather silly--why would user bother to go
			 * to the trouble of saying there are cross staff stem
			 * notes, but then not list any?
			 */
			yyerror("cross-staff stem note list is empty");
		}

		/* It doesn't make sense to do "with r below" or "with s below"
		 * since we don't allow mixing rests and notes, and the only
		 * reason for CSS is for something that has a stem. */
		else if ((yyvsp[-1].intval) > 0) {
			int idx;
			int pitch;

			for (idx = FCNI(Curr_grpsyl_p);
					idx <= LCNI(Curr_grpsyl_p); idx++) {
				pitch = Curr_grpsyl_p->notelist[idx].letter;
				if (pitch == PP_REST || pitch == PP_SPACE) {
					yyerror("can't use with above/below on rest or space");
				}
			}
		}
		(yyval.intval) = (yyvsp[-1].intval);
	}
#line 7910 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 513:
#line 5223 "src/mup/gram.y" /* yacc.c:1646  */
    {
		CSSused = YES;
		Curr_grpsyl_p->stemto_idx = Curr_grpsyl_p->nnotes;
	}
#line 7919 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 514:
#line 5229 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* No notes.  If this is for the list of "normal" staff notes,
		 * and there are no "other" staff notes (for cross-staff stems),
		 * this means use the same notes as the last group. */
		(yyval.intval) = 0;
	}
#line 7930 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 515:
#line 5238 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* return number of notes in notelist */
		(yyval.intval) = (yyvsp[-2].intval) + 1;
	}
#line 7939 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 517:
#line 5247 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_note(Curr_grpsyl_p, (int) PP_REST, No_accs,
				USE_DFLT_OCTAVE, 0, NO, (char *) 0);
		if (Meas_rpt_type == MRT_DOUBLE || Meas_rpt_type == MRT_QUAD) {
			l_yyerror(Curr_filename, yylineno, "cannot use dbl/quad with mr");
		}
	}
#line 7951 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 518:
#line 5257 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* temporarily stash uncompressibility (NO in this case)
		 * in the octave field */
		add_note(Curr_grpsyl_p, (int) PP_SPACE, No_accs, NO,
							0, NO, (char *) 0);
		if (Curr_grpsyl_p->is_meas == YES && User_meas_time == YES) {
			l_warning(Curr_filename, yylineno,
				"specifying time value on measure space is pointless; ignoring");
		}
		if (Meas_rpt_type == MRT_DOUBLE || Meas_rpt_type == MRT_QUAD) {
			l_yyerror(Curr_filename, yylineno, "cannot use dbl/quad with ms");
		}
	}
#line 7969 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 519:
#line 5273 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* temporarily stash uncompressibility (YES in this case)
		 * in the octave field */
		add_note(Curr_grpsyl_p, (int) PP_SPACE, No_accs, YES,
							0, NO, (char *) 0);
		if (Curr_grpsyl_p->is_meas == YES && User_meas_time == YES) {
			l_warning(Curr_filename, yylineno,
				"specifying time value on measure uncollapsible space is pointless; ignoring");
		}
		if (Meas_rpt_type == MRT_DOUBLE || Meas_rpt_type == MRT_QUAD) {
			l_yyerror(Curr_filename, yylineno, "cannot use dbl/quad with mus");
		}
	}
#line 7987 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 520:
#line 5289 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_grpsyl_p->is_meas == YES) {
			if (User_meas_time == YES) {
				l_warning(Curr_filename, yylineno,
					"specifying time value on measure repeat is pointless; ignoring");
			}
		}
		else {
			yyerror("rpt can only be used with m");
		}
		add_note(Curr_grpsyl_p, (int) PP_RPT, No_accs, USE_DFLT_OCTAVE,
							0, NO, (char *) 0);
		Mrptused = YES;
		Curr_grpsyl_p->meas_rpt_type = Meas_rpt_type;
	}
#line 8007 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 521:
#line 5307 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) == SINGLEBAR) {
			/* lexer thinks this is 'bar'
			 * but is really 'b' 'a' 'r' */
			keyword_notes(yytext);
		}
		else if ((yyvsp[0].intval) == ENDBAR) {
			/* lexer thinks this is 'endbar'
			 * but is really 'en' 'd' 'b' 'a' 'r' */
			add_acc("nat");
			add_note(Curr_grpsyl_p, (int) 'e', Curr_accs,
				USE_DFLT_OCTAVE, 0, NO, (char *) 0);
			keyword_notes(yytext + 2);
		}
		else {
			yyerror("bar type not valid here");
		}
	}
#line 8030 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 522:
#line 5328 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* lexer thinks this is 'grace' but really 'g' 'r' 'a' 'c' 'e' */
		keyword_notes(yytext);
	}
#line 8039 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 523:
#line 5335 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) == ENDING_BARRED) {
			keyword_notes(yytext);
		}
		else {
			l_yyerror(Curr_filename, yylineno,
					"%s not valid here", yytext);
		}
	}
#line 8053 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 524:
#line 5346 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) == J_RAGPARA) {
			keyword_notes(yytext);
		}
		else {
			l_yyerror(Curr_filename, yylineno,
					"%s not valid here", yytext);
		}
	}
#line 8067 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 525:
#line 5358 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) == BRACELIST) {
			keyword_notes(yytext);
		}
		else {
			l_yyerror(Curr_filename, yylineno,
					"%s not valid here", yytext);
		}
	}
#line 8081 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 526:
#line 5370 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) == BASS) {
			keyword_notes(yytext);
		}
		else {
			l_yyerror(Curr_filename, yylineno,
					"%s not valid here", yytext);
		}
	}
#line 8095 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 527:
#line 5382 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* in chord-at-time mode, lex could mistake useaccs
		 * for a 6-note chord: us e a c c s  */
		keyword_notes(yytext);
	}
#line 8105 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 528:
#line 5390 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Curr_grpsyl_p->notelist[Curr_grpsyl_p->nnotes - 1].note_has_paren = YES;
	}
#line 8113 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 529:
#line 5395 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Doing_tab_staff == YES) {
			add_note(Curr_grpsyl_p, (yyvsp[-1].intval), No_accs, NOFRET, 0, NO, (yyvsp[0].stringval));
		}
		else {
			add_note(Curr_grpsyl_p, (yyvsp[-1].intval), No_accs, USE_DFLT_OCTAVE,
								0, NO, (yyvsp[0].stringval));
		}
	}
#line 8127 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 530:
#line 5407 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Doing_tab_staff == YES) {
			l_warning(Curr_filename, yylineno,
				"parentheses around accidentals are extraneous on tab staffs; ignoring");
		}
		add_note(Curr_grpsyl_p, (yyvsp[-4].intval), Curr_accs, (yyvsp[0].intval), 0, YES, (char *) 0);
	}
#line 8139 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 531:
#line 5417 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Doing_tab_staff == NO) {
			l_warning(Curr_filename, yylineno,
				"parentheses around octave are extraneous; ignoring");
		}
		add_note(Curr_grpsyl_p, (yyvsp[-4].intval), No_accs, (yyvsp[-2].intval), 0, YES, (yyvsp[0].stringval));
	}
#line 8151 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 532:
#line 5427 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Whoops! The left paren was really for a new note,
		 * which happens to be parenthesized. But beause yacc only
		 * looks ahead one token, it finds out too late. So we
		 * catch it here, push the parenthesis and pitch back into
		 * the input and return back to the parent grammar rule,
		 * since we now have complete note. */
		pushback(yytext[0]);
		pushback('(');
		add_note(Curr_grpsyl_p, (yyvsp[-2].intval), No_accs,
			(Doing_tab_staff ? NOFRET : USE_DFLT_OCTAVE),
			0, NO, (char *) 0);
	}
#line 8169 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 533:
#line 5443 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_note(Curr_grpsyl_p, (yyvsp[-4].intval), Curr_accs, (yyvsp[-1].intval), (yyvsp[-2].intval), NO, (yyvsp[0].stringval));
	}
#line 8177 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 534:
#line 5449 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Doing_tab_staff == NO) {
			l_warning(Curr_filename, yylineno,
				"extraneous parentheses around octave; ignoring");
		}
		add_note(Curr_grpsyl_p, (yyvsp[-6].intval), Curr_accs, (yyvsp[-2].intval), (yyvsp[-4].intval), YES, (yyvsp[0].stringval));
	}
#line 8189 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 535:
#line 5459 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Whoops! The left paren was really for a new note,
		 * which happens to be parenthesized. But beause yacc only
		 * looks ahead one token, it finds out too late. So we
		 * catch it here, push the parenthesis and pitch back into
		 * the input and return back to the parent grammar rule,
		 * since we now have complete note. */
		pushback(yytext[0]);
		pushback('(');
		add_note(Curr_grpsyl_p, (yyvsp[-4].intval), Curr_accs,
			(Doing_tab_staff ? NOFRET : USE_DFLT_OCTAVE),
			(yyvsp[-2].intval), NO, (char *) 0);
	}
#line 8207 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 536:
#line 5475 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_note(Curr_grpsyl_p, (yyvsp[-3].intval), No_accs, (yyvsp[-1].intval), (yyvsp[-2].intval), NO, (yyvsp[0].stringval));
	}
#line 8215 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 537:
#line 5481 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_note(Curr_grpsyl_p, (yyvsp[-5].intval), No_accs, (yyvsp[-2].intval), (yyvsp[-4].intval), YES, (yyvsp[0].stringval));
	}
#line 8223 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 538:
#line 5487 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Doing_tab_staff == YES && Curr_accs[0] != '\0') {
			yyerror("accidental must be before fret number");
		}
		add_note(Curr_grpsyl_p, (yyvsp[-3].intval), Curr_accs, (yyvsp[-2].intval), 0, NO, (yyvsp[0].stringval));
	}
#line 8234 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 539:
#line 5496 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_note(Curr_grpsyl_p, (yyvsp[-4].intval), Curr_accs, (yyvsp[-3].intval), 0, YES, (char *) 0);
	}
#line 8242 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 540:
#line 5502 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Whoops! The left paren was really for a new note,
		 * which happens to be parenthesized. But beause yacc only
		 * looks ahead one token, it finds out too late. So we
		 * catch it here, push the parenthesis and pitch back into
		 * the input and return back to the parent grammar rule,
		 * since we now have complete note. */
		pushback(yytext[0]);
		pushback('(');
		add_note(Curr_grpsyl_p, (yyvsp[-3].intval), No_accs, (yyvsp[-2].intval), 0, NO, (char *) 0);
	}
#line 8258 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 541:
#line 5515 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.stringval) = (char *) 0;
	}
#line 8266 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 542:
#line 5521 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Doing_tab_staff == NO) {
			/* try to give helpful error message */
			if (get_shape_num((yyvsp[0].stringval) + 2) != HS_UNKNOWN) {
				yyerror("missing 'hs' before headshape string");
			}
			else if (strcmp((yyvsp[0].stringval) + 2, "full") == 0 || isdigit((yyvsp[0].stringval)[2])) {
				yyerror("bend string not allowed on non-tablature staff; use ^");
			}
			else {
				yyerror("unexpected string");
			}
			(yyval.stringval) = (char *) 0;
		}
	}
#line 8286 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 543:
#line 5538 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* return 'a' to 'g' value */
		(yyval.intval) = (int) *yytext;
	}
#line 8295 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 544:
#line 5544 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* no accidental */
		(yyval.intval) = 0;
	}
#line 8304 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 545:
#line 5551 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 8311 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 546:
#line 5555 "src/mup/gram.y" /* yacc.c:1646  */
    {
		clear_curr_accs();
	}
#line 8319 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 547:
#line 5561 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 8326 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 548:
#line 5564 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* no octave or fret designation */
		(yyval.intval) = (Doing_tab_staff ? NOFRET : USE_DFLT_OCTAVE);
	}
#line 8335 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 549:
#line 5571 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 8342 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 550:
#line 5576 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 8349 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 551:
#line 5580 "src/mup/gram.y" /* yacc.c:1646  */
    {
		clear_curr_accs();
	}
#line 8357 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 552:
#line 5585 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 8364 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 553:
#line 5590 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 8371 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 554:
#line 5595 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_acc("sharp");
	}
#line 8379 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 555:
#line 5601 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_acc("flat");
	}
#line 8387 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 556:
#line 5607 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_acc("nat");
	}
#line 8395 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 557:
#line 5613 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_acc("dblsharp");
	}
#line 8403 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 558:
#line 5619 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_acc("dblflat");
	}
#line 8411 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 559:
#line 5625 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_acc((yyvsp[-1].stringval) + 2);
		Tuning_used = YES;
	}
#line 8420 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 560:
#line 5632 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = '#';
	}
#line 8428 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 561:
#line 5638 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = '&';
	}
#line 8436 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 562:
#line 5644 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* natural */
		(yyval.intval) = 'n';
	}
#line 8445 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 563:
#line 5651 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* double sharp */
		(yyval.intval) = 'x';
	}
#line 8454 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 564:
#line 5658 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = 'B';
	}
#line 8462 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 565:
#line 5664 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 8470 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 566:
#line 5670 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* we can't really fill in the actual octave yet, because
		 * it may be different on different staffs or voices, so
		 * we store the relative octave and fill in actual value
		 * later.
		 */
		/* this will be a negative number */
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 8484 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 567:
#line 5682 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* we can't really fill in the actual octave yet, because
		 * it may be different on different staffs or voices, so
		 * we store the relative octave and fill in actual value
		 * later.
		 */
		(yyval.intval) = USE_DFLT_OCTAVE + (yyvsp[0].intval);
	}
#line 8497 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 568:
#line 5692 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = -1;
	}
#line 8505 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 569:
#line 5698 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* count up the number of minus signs */
		(yyval.intval) = (yyvsp[-1].intval) - 1;
	}
#line 8514 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 570:
#line 5704 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = 1;
	}
#line 8522 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 571:
#line 5710 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* count up the number of plus signs */
		(yyval.intval) = (yyvsp[-1].intval) + 1;
	}
#line 8531 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 572:
#line 5717 "src/mup/gram.y" /* yacc.c:1646  */
    {
		set_slurdir(Curr_grpsyl_p, Curr_grpsyl_p->nnotes - 1, (yyvsp[-1].intval), (yyvsp[0].intval));
	}
#line 8539 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 573:
#line 5724 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Linetype = (yyvsp[0].intval);
		begin_slur(Curr_grpsyl_p, Curr_grpsyl_p->nnotes - 1);
	}
#line 8548 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 574:
#line 5730 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* empty list. Only allowed if only one note in following
		 * group. However, we don't know that yet, so marked pitch
		 * as 'U' for unknown */
		add_slurto(Curr_grpsyl_p, 'U', USE_DFLT_OCTAVE,
				Curr_grpsyl_p->nnotes - 1, Linetype);
	}
#line 8560 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 575:
#line 5740 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_slurto(Curr_grpsyl_p, 0, (yyvsp[0].intval), Curr_grpsyl_p->nnotes - 1,
						Linetype);
	}
#line 8569 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 579:
#line 5758 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Doing_tab_staff == YES) {
			yyerror("cannot specify string inside <> on tab staffs");
		}
		else {
			add_slurto(Curr_grpsyl_p, (yyvsp[-1].intval), (yyvsp[0].intval),
					Curr_grpsyl_p->nnotes - 1, Linetype);
		}
	}
#line 8583 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 580:
#line 5770 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* save address associated with entire group */
		if ( (yyvsp[0].stringval) != (char *) 0) {
			addsym((yyvsp[0].stringval), Curr_grpsyl_p->c, CT_GRPSYL);
			var_valid();
		}
	}
#line 8595 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 581:
#line 5779 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
#line 8603 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 582:
#line 5785 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* a-g are usually pitches, but in this context, they
		 * are 1-character variable names. */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
#line 8613 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 583:
#line 5793 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* usually m means measure, but here it is the variable m */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
#line 8622 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 584:
#line 5800 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* usually rest, here variable r */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
#line 8631 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 585:
#line 5807 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* usually space, here variable s */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
#line 8640 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 586:
#line 5814 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* usually uncompressible, here variable u */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
#line 8649 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 587:
#line 5821 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* usually natural, here variable n */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
#line 8658 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 588:
#line 5828 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* usually double sharp, here variable x */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
#line 8667 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 589:
#line 5835 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* tag name with more than one character */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
#line 8676 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 590:
#line 5842 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(void) sprintf(Stringbuff + strlen((yyvsp[-2].stringval)), ".%d", (yyvsp[0].intval));
		(yyval.stringval) = Stringbuff;
	}
#line 8685 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 591:
#line 5849 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* tag name with more than one character */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
#line 8694 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 592:
#line 5856 "src/mup/gram.y" /* yacc.c:1646  */
    {
		end_tuplet((yyvsp[-4].intval), (yyvsp[-2].ratval), (yyvsp[-3].intval), (yyvsp[-5].intval), (yyvsp[-1].floatval));
		Getting_tup_dur = NO;
	}
#line 8703 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 593:
#line 5862 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* nothing -- use default of when to print tuplet number/bracket */
		(yyval.intval) = PT_DEFAULT;
	}
#line 8712 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 594:
#line 5869 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* don't print tuplet or bracket */
		(yyval.intval) = PT_NEITHER;
	}
#line 8721 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 595:
#line 5876 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* print number only */
		(yyval.intval) = PT_NUMBER;
	}
#line 8730 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 596:
#line 5883 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (*yytext == 'y') {
			(yyval.intval) = PT_BOTH;
		}
		else {
			yyerror("tuplet number/bracket qualifier must be y or n or num");
		}
	}
#line 8743 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 597:
#line 5895 "src/mup/gram.y" /* yacc.c:1646  */
    {
		begin_tuplet();
	}
#line 8751 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 598:
#line 5900 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Getting_tup_dur = YES;
	}
#line 8759 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 599:
#line 5905 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = PL_UNKNOWN;
	}
#line 8767 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 600:
#line 5911 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (yylval.intval == PL_BETWEEN) {
			if (Currstruct_p->str == S_LINE) {
				yyerror("between not allowed for line text strin side");
			}
			else {
				yyerror("between not allowed for tuplet side");
			}
			(yyval.intval) = PL_UNKNOWN;
		}
	}
#line 8783 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 601:
#line 5924 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* optional time value is missing */
		(yyval.ratval).n = 0;
		(yyval.ratval).d = 1;
	}
#line 8793 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 602:
#line 5932 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.ratval) = (yyvsp[0].ratval);
	}
#line 8801 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 603:
#line 5938 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.floatval) = NOTUPLETANGLE;
	}
#line 8809 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 604:
#line 5943 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyvsp[0].floatval) *= (yyvsp[-1].intval);
		if (frangecheck((yyvsp[0].floatval), MINTUPLETANGLE, MAXTUPLETANGLE, "slope") == YES) {
			(yyval.floatval) = (yyvsp[0].floatval);
		}
		else {
			(yyval.floatval) = NOTUPLETANGLE;
		}
	}
#line 8823 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 605:
#line 5955 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 8830 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 606:
#line 5959 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Last_grpsyl_p = Curr_grpsyl_p = (struct GRPSYL *) 0;
	}
#line 8838 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 607:
#line 5964 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* If user does "all" without specifying a place,
		 * all() will call dflt_place() which was really intended
		 * to only handle STUFF. So we have to tell it we have lyrics,
		 * not a true STUFF. */
		set_stuff_type(-1);
	}
#line 8850 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 608:
#line 5973 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Using_staff = -1;
		Using_voice = -1;
	}
#line 8859 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 609:
#line 5980 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Using_staff = (yyvsp[0].intval);
		Using_voice = 1;
	}
#line 8868 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 610:
#line 5987 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Using_staff = (yyvsp[-1].intval);
		Using_voice = (yyvsp[0].intval);
	}
#line 8877 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 611:
#line 5993 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* empty, use default */
		begin_range(PL_UNKNOWN);
		(yyval.intval) = PL_UNKNOWN;
	}
#line 8887 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 612:
#line 6001 "src/mup/gram.y" /* yacc.c:1646  */
    {
		begin_range((yyvsp[0].intval));
	}
#line 8895 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 613:
#line 6006 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval)= PL_UNKNOWN;
	}
#line 8903 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 614:
#line 6012 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) == PL_BETWEEN) {
			yyerror("place for ph, if specified, must be above or below, not between");
		}
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 8914 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 616:
#line 6023 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* means goes above or below all the staffs, regardless if
		 * some happen to be invisible at the moment, so find top
		 * or bottom visible staff as appropriate,and save that
		 * away as the staff range */
		all();
	}
#line 8926 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 618:
#line 6036 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* if staff_range == 0, then only one staff specified, so
		 * use first staff number for both beginning and end of range */
		save_staff_range((yyvsp[-1].intval), ((yyvsp[0].intval) == 0 ? (yyvsp[-1].intval) : (yyvsp[0].intval)) );
	}
#line 8936 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 619:
#line 6043 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* empty */
		chk_range_type(NO);
		(yyval.intval) = 0;
	}
#line 8946 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 620:
#line 6051 "src/mup/gram.y" /* yacc.c:1646  */
    {
		chk_range_type(NO);
		(yyval.intval) = (yyvsp[0].intval);
		if ((yyvsp[0].intval) == 0) {
			yyerror("staff of 0 is illegal");
		}
	}
#line 8958 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 621:
#line 6061 "src/mup/gram.y" /* yacc.c:1646  */
    {
		chk_range_type(YES);
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 8967 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 623:
#line 6070 "src/mup/gram.y" /* yacc.c:1646  */
    { Place = (yyvsp[0].intval); }
#line 8973 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 625:
#line 6072 "src/mup/gram.y" /* yacc.c:1646  */
    { Place = PL_BELOW; }
#line 8979 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 627:
#line 6077 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 8986 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 628:
#line 6082 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (*yytext != 'c') {
			yyerror("verse must be 'c' or number(s)");
		}
		else {
			save_vno_range(0, 0);
		}
	}
#line 8999 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 629:
#line 6093 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 9006 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 630:
#line 6098 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 9013 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 631:
#line 6103 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* if end of range is 0, not really a range, use first number
		 * for both beginning and end */
		lyr_verse((yyvsp[-1].intval), ((yyvsp[0].intval) == 0 ? (yyvsp[-1].intval) : (yyvsp[0].intval)));
	}
#line 9023 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 632:
#line 6110 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* empty */
		(yyval.intval) = 0;
	}
#line 9032 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 633:
#line 6117 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 9040 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 634:
#line 6122 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* null token to allocate a GRPSYL for a lyric */
		Last_grpsyl_p = Curr_grpsyl_p;
		Curr_grpsyl_p = newGRPSYL(GS_SYLLABLE);
		if (Last_grpsyl_p == (struct GRPSYL *) 0) {
			Lyrics_p = Curr_grpsyl_p;
		}
	}
#line 9053 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 635:
#line 6132 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* If user didn't specify a place, fix that. */
		if (Place == PL_UNKNOWN) {
			Place = PL_BELOW;
		}
		/* copies of the lyrics info has been made for all staffs/verses
		 * at this point, so get rid of master copy */
		free_grpsyls(Lyrics_p);
	}
#line 9067 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 636:
#line 6143 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* empty -- need to derive times from music */
		Lyrics_p = derive_lyrtime();
	}
#line 9076 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 637:
#line 6150 "src/mup/gram.y" /* yacc.c:1646  */
    {
		not_derived();
	}
#line 9084 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 641:
#line 6165 "src/mup/gram.y" /* yacc.c:1646  */
    {
		link_notegroup(Curr_grpsyl_p, Last_grpsyl_p);
		/* Save pointer to current GRPSYL in case the next
		 * group gets its time value based on this one,
		 * and there are additive times on this one. */
		Prev_grpsyl_p = Curr_grpsyl_p;
		/* If there are additive times, add those in.
		 * We don't need to make extra groups for lyrics, because we
		 * don't need to tie groups together--the lyrics time
		 * can hold any legal RATIONAL, even those that aren't
		 * specifiable with a single time value. */
		if (Extra_time_p != 0) {
			struct TIMELIST *timelist_p;
			for (timelist_p = Extra_time_p; timelist_p != 0;
						timelist_p = timelist_p->next) {
				Curr_grpsyl_p->fulltime = radd(Curr_grpsyl_p->fulltime, timelist_p->fulltime);
			}
		}
	}
#line 9108 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 642:
#line 6187 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 9115 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 643:
#line 6191 "src/mup/gram.y" /* yacc.c:1646  */
    {
		end_tuplet((yyvsp[-1].intval), (yyvsp[0].ratval), NO, PL_UNKNOWN, NOTUPLETANGLE);
		Getting_tup_dur = NO;
	}
#line 9124 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 644:
#line 6197 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* empty, will fill in an actual syllable later */
		Curr_grpsyl_p->syl = (char *) 0;
	}
#line 9133 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 645:
#line 6204 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* space, not a lyric, so mark for later use */
		Curr_grpsyl_p->grpcont = GC_SPACE;
	}
#line 9142 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 648:
#line 6217 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* If no [verseno] is specified, use -1 as special flag
		 * to be resolved later to "one more than previous",
		 * or if there wasn't a previous, to verse 1.
		 */
		lyr_verse(-1, -1);
		proc_lyrics(Lyrics_p, (yyvsp[-1].stringval));
	}
#line 9155 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 649:
#line 6228 "src/mup/gram.y" /* yacc.c:1646  */
    {
		proc_lyrics(Lyrics_p, (yyvsp[-1].stringval));
	}
#line 9163 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 650:
#line 6233 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* If user set measnum=every N and did not already put some
		 * kind of reh mark on this bar, and this measure is a
		 * multiple of N, we add a mnum mark,
		 * but using measnumstyle */
		if (Currstruct_p != 0 && IS_EVERY(Score.measnum) &&
				Currstruct_p->u.bar_p->reh_type == REH_NONE &&
				Meas_num % Score.measnum == 0) {
			Currstruct_p->u.bar_p->reh_type = REH_BAR_MNUM;
			/* Do like the code in set_reh_string() except use the
			 * measnum* parameters for family, font, and size. */
			Currstruct_p->u.bar_p->reh_string =
					copy_string(num2str(Meas_num) + 2,
                        		Score.measnumfamily + Score.measnumfont,
                        		Score.measnumsize);
		}

		Currstruct_p = (struct MAINLL *) 0;
		/* If there are alternating time signature,
		 * add an implicit time signature SSV for the
		 * next time signature in the list.
		 */
		if (Alt_timesig_list != 0) {
			end_prev_context();
			Context = C_SCORE;
			Currstruct_p = newMAINLLstruct(S_SSV, -1);
			Currstruct_p->u.ssv_p->context = Context;
			if (Tsig_visibility == PTS_ALWAYS &&
					Next_alt_timesig != Alt_timesig_list) {
				/* If user wants alternating time signatures
				 * printed on every measure, if there is
				 * a multirest, we will print multiple
				 * time signatures there, and might have to
				 * wrap around to the beginning of the list.
				 * So make a copy of the entire list,
				 * starting from wherever we are now,
				 * wrapping around to the beginning,
				 * and ending just before where we are now.
				 * Most of the time,
				 * there probably won't be a multirest,
				 * so this will be a waste, but unfortunately,
				 * we don't know yet whether there will be
				 * one or not, so need to do the whole list
				 * just in case.
				 *
				 * Calculate length of the two pieces:
				 * from where we are to end, and from
				 * beginning to where we are.
				 */
				int remlength;
				int wraplength;
				remlength = strlen(Next_alt_timesig);
				wraplength = strlen(Alt_timesig_list)
						- remlength;
				/* need one more for terminator. */
				MALLOCA(char, Currstruct_p->u.ssv_p->timerep,
						remlength + wraplength + 1);

				/* copy remainder into beginning */
				strcpy(Currstruct_p->u.ssv_p->timerep,
						Next_alt_timesig);
				/* copy the wrap-around part of list,
				 * but move the TSR_ALTERNATING from the
				 * end of that part to between the two parts */
				Currstruct_p->u.ssv_p->timerep[remlength]
						= TSR_ALTERNATING;
				strncpy(Currstruct_p->u.ssv_p->timerep +
						remlength + 1, Alt_timesig_list,
						wraplength - 1);
				/* Add the terminator */
				Currstruct_p->u.ssv_p->timerep
						[remlength + wraplength]
						= TSR_END;

				assign_timesig(Currstruct_p, PTS_ALWAYS,
							&Next_alt_timesig);


				/* Make this new copy the new
				 * head of the list */
				Alt_timesig_list =
						Currstruct_p->u.ssv_p->timerep;
			}
			else {
				/* make a copy of the remaining alternating
				 * signatures and assign that */
				MALLOCA(char, Currstruct_p->u.ssv_p->timerep,
					strlen(Next_alt_timesig) + 1);
				strcpy(Currstruct_p->u.ssv_p->timerep,
							Next_alt_timesig);
				assign_timesig(Currstruct_p,
					(Tsig_visibility == PTS_ALWAYS ?
					PTS_ALWAYS : PTS_NEVER),
					&Next_alt_timesig);

				/* If we reached end of list, start over */
				if (Next_alt_timesig == 0) {
					Next_alt_timesig = Alt_timesig_list;
				}
			}

			asgnssv(Currstruct_p->u.ssv_p);
			end_prev_context();
			Context = C_MUSIC;
		}
	}
#line 9274 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 653:
#line 6348 "src/mup/gram.y" /* yacc.c:1646  */
    {
		struct MAINLL * mll_p;
		char *name;


		name = ((yyvsp[0].intval) == YES ? "newpage" : "newscore");

		(void) contextcheck(C_MUSIC | C_BLOCK, name);
		if (Mainlltc_p != 0 && Mainlltc_p->str == S_FEED) {
			/* Must be in block; Last thing on the list is a
			 * FEED, and it is illegal to have two FEEDs in a
			 * row, we just reuse the existing */
			Currstruct_p = Mainlltc_p;
			/* If this need feed is a pagefeed, set that in the
			 * existing struct. If not, leave it however it was.
			 * Otherwise if it was already a pagefeed, we would
			 * be downgrading, and we probably want to max */
			if ((yyvsp[0].intval) == YES) {
				Currstruct_p->u.feed_p->pagefeed = (yyvsp[0].intval);
			}
		}
		else {
			Currstruct_p = newMAINLLstruct(S_FEED, yylineno);
			Currstruct_p->u.feed_p->pagefeed = (yyvsp[0].intval);
		}

		/* make sure we're not in the middle of a measure. Go
		 * backwards in main list. If we hit STAFF before a BAR,
		 * then there is a problem.
		 */
		for (mll_p = Mainlltc_p; mll_p != (struct MAINLL *) 0;
					mll_p = mll_p->prev) {

			if (mll_p->str == S_BAR) {
				break;
			}
			else if (mll_p->str == S_STAFF) {
				l_yyerror(Curr_filename, yylineno,
					"%s not allowed in middle of measure",
					name);
				break;
			}
			else if (mll_p->str == S_FEED) {
				struct MAINLL *m_p;
				/* Need to look backwards for blocks, but need
				 * to ignore any SSVs that are in between */
				for (m_p = mll_p->prev;
						m_p != 0 && m_p->str == S_SSV;
						m_p = m_p->prev) {
					;
				}
				if (m_p != 0 && m_p->str == S_BLOCKHEAD) {
					/* This is a feed following a block.
					 * If it was an implicit feed,
					 * we can get rid of it, because
					 * user now put an explicit one.
					 */
					if (mll_p->inputlineno == -1) {
						unlinkMAINLL(mll_p);
						FREE(mll_p);
					}
					/* We must be in block context,
					 * so no need to check farther back.
					 */
					break;
				}
				else {
					l_yyerror(Curr_filename, yylineno,
						"consecutive newscore/newpage not allowed");
				}
				break;
			}
		}

		/* If inside a "samescore" zone, doing a feed is contradictory */
		if (Doing_samescore == YES) {
			l_yyerror(Curr_filename, yylineno,
				"cannot have a %s inside a samescore zone",
				name);
		}

		/* If inside a "samepage" zone, doing a page feed
		 * is contradictory, though a scorefeed is okay. */
		if ( (Doing_samepage == YES) && ((yyvsp[0].intval) == YES) ) {
			l_yyerror(Curr_filename, yylineno,
				"cannot have a pagefeed inside a samepage zone");
		}

		/* Add to main list, unless reusing the tail cell FEED */
		if (Currstruct_p != Mainlltc_p) {
			insertMAINLL(Currstruct_p, Mainlltc_p);
		}

		/* If this is inside a block, we need to create a new block
		 * and feed after it.
		 */
		if (Context == C_BLOCK) {
			CALLOC(BLOCKHEAD, Currblock_p, 1);
			set_win_coord(Currblock_p->c);
			Next_print_link_p_p = &(Currblock_p->printdata_p);
			insertMAINLL(newMAINLLstruct(S_BLOCKHEAD, yylineno),
						Mainlltc_p);
			Mainlltc_p->u.blockhead_p = Currblock_p;
			insertMAINLL(newMAINLLstruct(S_FEED, -1), Mainlltc_p);
		}

	}
#line 9386 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 654:
#line 6456 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Currstruct_p = (struct MAINLL *) 0;
	}
#line 9394 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 655:
#line 6462 "src/mup/gram.y" /* yacc.c:1646  */
    {
		char *name;

		name = ((yyvsp[0].intval) == YES ? "samescorebegin" : "samescoreend");
		(void) contextcheck(C_MUSIC, name);

		if ( ((yyvsp[0].intval) == YES) && (Doing_samescore == YES) ) {
			l_yyerror(Curr_filename, yylineno,
				"cannot nest samescorebegin zones");
		}
		if ((yyvsp[0].intval) == NO) {
			if (Doing_samescore == NO) {
				l_yyerror(Curr_filename, yylineno,
					"cannot have samescoreend without previous matching samescorebegin");
			}
			else {
				/* Need to undo the samescore setting on the
				 * most recent bar. */
				struct MAINLL *mll_p;

				for (mll_p = Mainlltc_p; mll_p != 0;
							mll_p = mll_p->prev) {
					if (mll_p->str == S_BAR) {
						mll_p->u.bar_p->samescore = NO;
						break;
					}
				}
			}
		}
		Doing_samescore = (yyvsp[0].intval);
	}
#line 9430 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 656:
#line 6496 "src/mup/gram.y" /* yacc.c:1646  */
    {
		char *name;

		name = ((yyvsp[0].intval) == YES ? "samepagebegin" : "samepageend");
		(void) contextcheck(C_MUSIC | C_BLOCK, name);

		if ( ((yyvsp[0].intval) == YES) && (Doing_samepage == YES) ) {
			l_yyerror(Curr_filename, yylineno,
				"cannot nest samepagebegin zones");
		}
		if ((yyvsp[0].intval) == NO) {
			if (Doing_samepage == NO) {
				l_yyerror(Curr_filename, yylineno,
					"cannot have samepageend without previous matching samespagebegin");
			}
			else {
				/* Need to undo the samescore setting on the
				 * most recent bar or block. */
				struct MAINLL *mll_p;

				for (mll_p = Mainlltc_p; mll_p != 0;
							mll_p = mll_p->prev) {
					if (mll_p->str == S_BAR) {
						mll_p->u.bar_p->samepage = NO;
						break;
					}
					else if (mll_p->str == S_BLOCKHEAD) {
						mll_p->u.blockhead_p->samepage = NO;
						break;
					}
				}
			}
		}
		Doing_samepage = (yyvsp[0].intval);
	}
#line 9470 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 662:
#line 6551 "src/mup/gram.y" /* yacc.c:1646  */
    {
		int mot;	/* margin override type */

		if ((yyvsp[-1].intval) == 0) {
			/* User didn't specify a sign, so this is an
			 * absolute, not relative value. Or auto. */
			if ((yyvsp[0].floatval) == MG_AUTO) {
				mot = MOT_AUTO;
			}
			else {
				mot = MOT_ABSOLUTE;
			}
		}
		else {
			mot = MOT_RELATIVE;
		}

		if ((yyvsp[0].floatval) > 0.0) {
			(yyvsp[-1].intval) = adjust2inches((yyvsp[-1].intval));	/* in case we are in centimeter mode */
		}
		if ((yyvsp[-3].intval) == RIGHTMARGIN) {
			if (Currstruct_p->u.feed_p->right_mot != MOT_UNUSED) {
				l_warning(Curr_filename, yylineno,
					"rightmargin specified more than once, using last instance");
				/* fall through to override the previous */
			}
			if (mot == MOT_ABSOLUTE) {
				Currstruct_p->u.feed_p->rightmargin = (yyvsp[0].floatval);
			}
			else if (mot == MOT_RELATIVE) {
				Currstruct_p->u.feed_p->rightmargin
						= Score.rightmargin + (yyvsp[-1].intval) * (yyvsp[0].floatval);
				/* Even if user specified as relative,
				 * we have now converted to absolute */
				mot = MOT_ABSOLUTE;
			}
			Currstruct_p->u.feed_p->right_mot = mot;
		}
		else if ((yyvsp[-3].intval) == LEFTMARGIN) {
			if (mot == MG_AUTO) {
				l_warning(Curr_filename, yylineno,
					"auto can only be used with rightmargin, not leftmargin; ignoring");
				mot = MOT_UNUSED;
			}
			if (Currstruct_p->u.feed_p->left_mot != MOT_UNUSED) {
				l_warning(Curr_filename, yylineno,
					"leftmargin specified more than once, using last instance");
				/* fall through to override the previous */
			}
			if (mot == MOT_ABSOLUTE) {
				Currstruct_p->u.feed_p->leftmargin = (yyvsp[0].floatval);
			}
			else if (mot == MOT_RELATIVE) {
				Currstruct_p->u.feed_p->leftmargin
						= Score.leftmargin + (yyvsp[-1].intval) * (yyvsp[0].floatval);
				/* Even if user specified as relative,
				 * we have now converted to absolute */
				mot = MOT_ABSOLUTE;
			}
			Currstruct_p->u.feed_p->left_mot = mot;
		}
		else {
			yyerror("unexpected parameter; only 'leftmargin' or 'rightmargin' allowed here");
		}
		chkmargin(Score.topmargin, Score.botmargin,
				Currstruct_p->u.feed_p->leftmargin,
				Currstruct_p->u.feed_p->rightmargin);
	}
#line 9543 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 663:
#line 6621 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.floatval) = (yyvsp[0].floatval);
	}
#line 9551 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 664:
#line 6627 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.floatval) = MG_AUTO;
	}
#line 9559 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 665:
#line 6633 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ( SEP_IS_VALID(Currstruct_p->u.feed_p->scoresep) ) {
			l_warning(Curr_filename, yylineno, "scoresep specified more than once, last being used");
		}
		if ( Currstruct_p->u.feed_p->pagefeed == YES) {
			l_warning(Curr_filename, yylineno, "scoresep ignored on newpage; only used on newscore");
		}
		frangecheck((yyvsp[0].floatval), -MAXSEPVAL, MAXSEPVAL, "scoresep value");
		Currstruct_p->u.feed_p->scoresep = (yyvsp[-1].intval) *(yyvsp[0].floatval);
	}
#line 9574 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 672:
#line 6664 "src/mup/gram.y" /* yacc.c:1646  */
    {

		/* build a BAR struct and add it to the main list */
		if (contextcheck(C_MUSIC, "bar") == YES) {

			Currstruct_p = add_bar((yyvsp[0].intval), (yyvsp[-2].intval), Endingloc,
						Endending_type, Mainlltc_p);
			Got_ending = NO;
			Currstruct_p->u.bar_p->samescore = Doing_samescore;
			Currstruct_p->u.bar_p->samepage = Doing_samepage;
		}
		if ((yyvsp[0].intval) == RESTART && Endingloc != NOITEM) {
			yyerror("restart cannot be used inside an ending");
		}

		/* User can specify bar type to use on preceding staff when
		 * a repeatstart gets moved to the next scores's pseudo-bar */
		if ((yyvsp[-1].intval) != -1) {
			if ((yyvsp[0].intval) != REPEATSTART) {
				l_warning(Curr_filename, yylineno,
					"bar type for preceding score only allowed on repeatstart; ignoring");
			}
			else if (Currstruct_p != 0 && Currstruct_p->u.bar_p != 0) {
				Currstruct_p->u.bar_p->precbartype = (yyvsp[-1].intval);
				if ((yyvsp[-1].intval) != SINGLEBAR && (yyvsp[-1].intval) != DOUBLEBAR &&
						(Linetype == L_DASHED ||
						Linetype == L_DOTTED)) {
					l_warning(Curr_filename, yylineno,
						"dashed/dotted only allowed on bar or dblbar; ignoring");
					Linetype = L_NORMAL;
				}
				Currstruct_p->u.bar_p->linetype = Linetype;
			}
		}
		else {
			/* Default is single bar. It could be argued that in
			 * the case of a key change on this bar, it really
		 	 * should be a dblbar, but user can force that
			 * if they want it. */
			if (Currstruct_p != 0 && Currstruct_p->u.bar_p != 0) {
				Currstruct_p->u.bar_p->precbartype = SINGLEBAR;
			}
		}
		/* Placement phase indirectly uses Doing_tab_staff when it
		 * calls notecomp, so clear it in case we don't get a
		 * non-tab staff input before the end of file.
		 * We could probably get by just doing after parsing is done,
		 * but this seems cleaner, and cheap enough.
		 */
		Doing_tab_staff = NO;
	}
#line 9630 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 673:
#line 6718 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = -1;	/* special value to mean "none specified" */
		Linetype = L_NORMAL;
	}
#line 9639 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 674:
#line 6725 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Parens wouldn't be strictly necessary to be able to parse,
		 * but seem useful semantically to make it clear this is
		 * optional, only applying when repeatstart is moved to
		 * next score's pseudo bar. */
		(yyval.intval) = (yyvsp[-1].intval);
		if ((yyvsp[-2].intval) == L_DOTTED || (yyvsp[-2].intval) == L_DASHED) {
			if ((yyvsp[-1].intval) != SINGLEBAR && (yyvsp[-1].intval) != DOUBLEBAR) {
				l_warning(Curr_filename, yylineno,
					"Only bar or dblbar can be dashed or dotted; ignoring");
			}
			else {
				Linetype = (yyvsp[-2].intval);
			}
		}
		else if ((yyvsp[-2].intval) != L_NORMAL) {
			l_warning(Curr_filename, yylineno,
					"Bar line type modifier can only can be dashed or dotted; ignoring");
		}
	}
#line 9664 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 675:
#line 6747 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Call proc_emptymeas() to free up the last buffer, if any,
		 * and return back to normal input stream. */
		proc_emptymeas(MAXSTAFFS+1);
		(yyval.intval) = (yyvsp[-1].intval);
	}
#line 9675 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 676:
#line 6755 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* If there was any empty voices in the input for this
		 * measure which have emptymeas parameter set,
		 * proc_emptymeas() will arrange to create just-in-time
		 * virtual input for it that will get parsed via
		 * the emptymeas_input rule.
		 * We pass arg of 1 to tell it to start looking from
		 * staff 1. Subsequent calls to proc_emptymeas(), if any,
		 * will generate input for additional voices, until
		 * no more are needed for this measure.
		 */
		if ((yyvsp[0].intval) != RESTART) {
			EM_staff = proc_emptymeas(1);
		}
		else {
			/* don't create any music before a restart */
			EM_staff = MAXSTAFFS + 1;
		}
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 9700 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 677:
#line 6777 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 9707 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 678:
#line 6782 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* See if there is any more virtual input needed */
		EM_staff = proc_emptymeas(EM_staff);
	}
#line 9716 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 681:
#line 6795 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != (struct MAINLL *) 0) {
			Currstruct_p->u.bar_p->padding += (yyvsp[0].floatval) * STEPSIZE;
		}
	}
#line 9726 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 682:
#line 6803 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != (struct MAINLL *) 0) {
			/* fill in location info */
			if ((yyvsp[0].stringval) != (char *) 0) {
				addsym((yyvsp[0].stringval), Currstruct_p->u.bar_p->c, CT_BAR);
			}
		}
	}
#line 9739 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 683:
#line 6814 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Got_ending == YES) {
			yyerror("Only one ending allowed per bar");
		}
		Got_ending = YES;

		if (Currstruct_p != (struct MAINLL *) 0) {
			if (Currstruct_p->u.bar_p->bartype == RESTART) {
				yyerror("ending not allowed on restart");
			}
			/* fill in ending label if any */
			Currstruct_p->u.bar_p->endinglabel = (yyvsp[0].stringval);
			Currstruct_p->u.bar_p->endingloc = Endingloc;
			Currstruct_p->u.bar_p->endending_type = Endending_type;
			ped_endings(Endingloc);

			/* for next time around, figure out what endingloc will
			 * be if user doesn't specify something different */
			switch (Endingloc) {
			case STARTITEM:
				Endingloc = INITEM;
				break;
			case ENDITEM:
				Endingloc = NOITEM;
				break;
			default:
				break;
			}
		}
	}
#line 9774 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 684:
#line 6847 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0) {
			if (Currstruct_p->u.bar_p->bartype == RESTART) {
				l_warning(Curr_filename, yylineno,
					"hidechanges not allowed on restart; ignoring");
			}
			else {
				Currstruct_p->u.bar_p->hidechanges = YES;
			}
		}
	}
#line 9790 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 685:
#line 6860 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0) {
			set_mnum(Currstruct_p->u.bar_p, (yyvsp[0].intval));
		}
	}
#line 9800 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 686:
#line 6867 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0) {
			int newval;

			newval = Meas_num + ((yyvsp[-1].intval) * (yyvsp[0].intval));
			if (newval < 1) {
				l_warning(Curr_filename, yylineno,
				"resulting measure number of %d is less than 1; using 1", newval);
				newval = 1;
			}
			set_mnum(Currstruct_p->u.bar_p, newval);
		}
	}
#line 9818 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 687:
#line 6882 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* +2 to skip font/size */
		init_reh(-1, (yyvsp[0].stringval) + 2, Currstruct_p);
	}
#line 9827 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 688:
#line 6888 "src/mup/gram.y" /* yacc.c:1646  */
    {
		init_reh((yyvsp[0].intval), (char *)0, Currstruct_p);
	}
#line 9835 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 689:
#line 6894 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != 0 && Currstruct_p->str == S_BAR) {
			if (Currstruct_p->u.bar_p->reh_string != 0) {
				/* This indicates user specified multiple
				 * rehearsal strings. We would have already
				 * given a warning message. */
				FREE(Currstruct_p->u.bar_p->reh_string);
				Currstruct_p->u.bar_p->reh_string = 0;
			}
			set_reh_string(Currstruct_p->u.bar_p, (yyvsp[-4].intval), (yyvsp[-3].intval), (yyvsp[-2].intval), (yyvsp[-1].stringval));
			Currstruct_p->u.bar_p->dist = Dist;
			Currstruct_p->u.bar_p->dist_usage = Dist_usage;
		}
	}
#line 9854 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 690:
#line 6911 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.stringval) = (yyvsp[0].stringval);
		(void) fix_string((yyvsp[0].stringval), FONT_TR, DFLT_SIZE, Curr_filename, yylineno);
		Endingloc = STARTITEM;
		Endending_type = EE_DEFAULT;
	}
#line 9865 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 691:
#line 6920 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Endingloc == NOITEM) {
			l_warning(Curr_filename, yylineno,
				"no ending in progress; extraneous 'endending' ignored");
			Endending_type = EE_DEFAULT;
		}
		else {
			Endingloc = ENDITEM;
			Endending_type = (yyvsp[0].intval);
		}
		(yyval.stringval) = (char *) 0;
	}
#line 9882 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 692:
#line 6934 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* null token to check for more than one rehearsal mark
		 * on one BAR */
		if (Currstruct_p != (struct MAINLL *) 0 &&
				Currstruct_p->u.bar_p->reh_type != REH_NONE) {
			l_warning(Curr_filename, yylineno,
				"only one rehearsal mark allowed per bar; using last");
		}
	}
#line 9896 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 693:
#line 6945 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != (struct MAINLL *) 0) {
			Currstruct_p->u.bar_p->reh_type = REH_STRING;
		}
	}
#line 9906 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 694:
#line 6953 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != (struct MAINLL *) 0) {
			Currstruct_p->u.bar_p->reh_type = REH_MNUM;
		}
		(yyval.stringval) = (char *) 0;
	}
#line 9917 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 695:
#line 6962 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != (struct MAINLL *) 0) {
			Currstruct_p->u.bar_p->reh_type = REH_NUM;
		}
		(yyval.stringval) = (char *) 0;
	}
#line 9928 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 696:
#line 6971 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Currstruct_p != (struct MAINLL *) 0) {
			Currstruct_p->u.bar_p->reh_type = REH_LET;
		}
		(yyval.stringval) = (char *) 0;
	}
#line 9939 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 697:
#line 6979 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.inpcoord_p) = (yyvsp[-4].inpcoord_p);
		(yyvsp[-4].inpcoord_p)->hexpr_p = (yyvsp[-3].expr_p);
		(yyvsp[-4].inpcoord_p)->vexpr_p = (yyvsp[-1].expr_p);
	}
#line 9949 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 698:
#line 6986 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* null token to allocate an INPCOORD */
		CALLOC(INPCOORD, Curr_loc_info_p, 1);
		(yyval.inpcoord_p) = Curr_loc_info_p;
		/* set to positive in case input starts with an absolute
		 * x coordinate */
		Plus_minus = 1;
	}
#line 9962 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 699:
#line 6996 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = Plus_minus = 1;
	}
#line 9970 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 700:
#line 7002 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = Plus_minus = -1;
	}
#line 9978 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 701:
#line 7009 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.expr_p) = (yyvsp[0].expr_p);
		Curr_timeref_tag_p = 0;
	}
#line 9987 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 702:
#line 7017 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.expr_p) = (yyvsp[0].expr_p);

		/* Put lex back into normal (not coord arithemetic) mode */
		set_lex_mode(NO);
	}
#line 9998 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 703:
#line 7026 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Put lex into special mode to return different tokens
		 * for arithmetic operators. This is just in case the
		 * precedence rules might mess up other rules if we used
		 * the same tokens. The + - * / symbols are used for very
		 * different things elsewhere in the grammer, where
		 * precedence doesn't make sense. It probably wouldn't hurt,
		 * but it seems better to be safe, and only do the precedence
		 * when really needed.
		 */
		set_lex_mode(YES);
		Curr_timeref_tag_p = 0;
	}
#line 10016 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 704:
#line 7044 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.expr_p) = (yyvsp[-1].expr_p);
	}
#line 10024 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 705:
#line 7050 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.expr_p) = newnode((yyvsp[-1].intval));
		(yyval.expr_p)->left.lchild_p = (yyvsp[-2].expr_p);
		(yyval.expr_p)->right.rchild_p = (yyvsp[0].expr_p);
	}
#line 10034 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 706:
#line 7058 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.expr_p) = newnode((yyvsp[-1].intval));
		(yyval.expr_p)->left.lchild_p = (yyvsp[-2].expr_p);
		(yyval.expr_p)->right.rchild_p = (yyvsp[0].expr_p);
	}
#line 10044 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 707:
#line 7066 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].intval) == OP_SUB) {
			(yyval.expr_p) = newnode(OP_MUL);
			(yyval.expr_p)->left.lchild_p = newnode(OP_FLOAT_LITERAL);
			(yyval.expr_p)->left.lchild_p->left.value = -1.0;
			(yyval.expr_p)->right.rchild_p = (yyvsp[0].expr_p);
		}
		else {
			(yyval.expr_p) = (yyvsp[0].expr_p);
		}
	}
#line 10060 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 708:
#line 7080 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.expr_p) = newnode((yyvsp[-3].intval));
		(yyval.expr_p)->left.lchild_p = (yyvsp[-1].expr_p);
	}
#line 10069 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 709:
#line 7088 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.expr_p) = newnode((yyvsp[-5].intval));
		(yyval.expr_p)->left.lchild_p = (yyvsp[-3].expr_p);
		(yyval.expr_p)->right.rchild_p = (yyvsp[-1].expr_p);
	}
#line 10079 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 710:
#line 7096 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.expr_p) = newnode(OP_FLOAT_LITERAL);
		(yyval.expr_p)->left.value = (yyvsp[0].floatval);
	}
#line 10088 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 711:
#line 7103 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.expr_p) = newnode(OP_TAG_REF);

		/* Get space to save info about this tag reference */
		MALLOC(TAG_REF, (yyval.expr_p)->left.ltag_p, 1);

		/* Get the address of the c[] associated with this tag.
		 * We also save which index into the c[]
		 */
		if (((yyval.expr_p)->left.ltag_p->c = symval((yyvsp[-2].stringval), &((yyval.expr_p)->left.ltag_p->c))) != 0) {
			(yyval.expr_p)->left.ltag_p->c_index = (yyvsp[0].intval);
			save_tag_ref((yyval.expr_p)->left.ltag_p->c, &((yyval.expr_p)->left.ltag_p->c));
		}

		if (index_type((yyvsp[0].intval)) == AX) {
			/* Remember this tag, in case user
			 * wants to do a time offset relative to it.
			 * We always take time offsets relative
			 * to the most recent horizontal tag
			 * in the current expression.
			 * Since there may be expressions as arguments
			 * to functions, we keep a stack of these. */
			Curr_timeref_tag_p = (yyval.expr_p)->left.ltag_p;
		}

		/* If this is the first tag of the proper direction in the
		 * expression, that's the base tag used to determine
		 * which staff/score the tag is associated with, if any */
		if (index_type((yyvsp[0].intval)) == AX && Curr_loc_info_p->hor_p == 0) {
			Curr_loc_info_p->hor_p = (yyval.expr_p)->left.ltag_p->c;
			save_tag_ref(Curr_loc_info_p->hor_p,
						&(Curr_loc_info_p->hor_p));
		}
		else if (index_type((yyvsp[0].intval)) == AY && Curr_loc_info_p->vert_p == 0) {
			Curr_loc_info_p->vert_p = (yyval.expr_p)->left.ltag_p->c;
			save_tag_ref(Curr_loc_info_p->vert_p,
						&(Curr_loc_info_p->vert_p));
		}
	}
#line 10132 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 712:
#line 7145 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Curr_timeref_tag_p == 0) {
			yyerror("time offset requires a prior horizontal tag reference");
			(yyval.expr_p) = 0;
		}
		else if (is_builtin_tag(Curr_timeref_tag_p->c)) {
			yyerror("cannot have a time offset relative to a builtin tag like _win or _page");
			(yyval.expr_p) = 0;
		}
		else {
			(yyval.expr_p) = newnode(OP_TIME_OFFSET);
			(yyval.expr_p)->left.value = (yyvsp[0].floatval);
			MALLOC(TAG_REF, (yyval.expr_p)->right.rtag_p, 1);
			(yyval.expr_p)->right.rtag_p = Curr_timeref_tag_p;
			save_tag_ref((yyval.expr_p)->right.rtag_p->c,
						&((yyval.expr_p)->right.rtag_p->c));
		}
	}
#line 10155 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 713:
#line 7167 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* only valid letters are w and y */
		if (*yytext == 'w') {
			(yyval.intval) = AW;
		}
		else if (*yytext == 'y') {
			(yyval.intval) = AY;
		}
		else {
			yyerror("invalid direction: must be x, y, e, w, n or s");
			/* Return something valid, so if any code tries
			 * to use it later, it won't core dump */
			(yyval.intval) = AX;
		}
	}
#line 10175 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 714:
#line 7184 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = AX;
	}
#line 10183 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 715:
#line 7190 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* only valid value is e */
		if (*yytext != 'e') {
			yyerror("invalid direction: must be x, y, e, w, n or s");
		}
		(yyval.intval) = AE;
	}
#line 10195 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 716:
#line 7200 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = AN;
	}
#line 10203 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 717:
#line 7206 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = AS;
	}
#line 10211 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 718:
#line 7212 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.floatval) = (float) (yyvsp[0].intval);
	}
#line 10219 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 719:
#line 7217 "src/mup/gram.y" /* yacc.c:1646  */
    {
		sprintf(Tmpbuff,"%d.%s", (yyvsp[-2].intval), (yyvsp[0].stringval));
		(yyval.floatval) = (float) atof(Tmpbuff);
	}
#line 10228 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 720:
#line 7223 "src/mup/gram.y" /* yacc.c:1646  */
    {
		sprintf(Tmpbuff,"0.%s", (yyvsp[0].stringval));
		(yyval.floatval) = (float) atof(Tmpbuff);
	}
#line 10237 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 721:
#line 7229 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* no decimal fraction part of float number */
		(yyval.stringval) = "";
	}
#line 10246 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 723:
#line 7239 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.stringval) = yytext;
	}
#line 10254 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 725:
#line 7247 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Currstruct_p->u.line_p->linetype = (yyvsp[-7].intval);
		Currstruct_p->u.line_p->start = *((yyvsp[-4].inpcoord_p));
		Currstruct_p->u.line_p->end = *((yyvsp[-2].inpcoord_p));
		rep_inpcoord((yyvsp[-4].inpcoord_p), &(Currstruct_p->u.line_p->start));
		rep_inpcoord((yyvsp[-2].inpcoord_p), &(Currstruct_p->u.line_p->end));
		Currstruct_p->u.line_p->string = (yyvsp[-1].stringval);

		if (((yyvsp[-1].stringval) == 0) && ((yyvsp[0].intval) != PL_UNKNOWN)) {
			yyerror("above/below only allowed with a string");
		}
		Currstruct_p->u.line_p->side =
				((yyvsp[0].intval) == PL_BELOW ? PL_BELOW : PL_ABOVE);

		/* copies of the location info went into the LINE struct,
		 * so we can free the original copy of the information */
		if ((yyvsp[-4].inpcoord_p)) {
			FREE((yyvsp[-4].inpcoord_p));
		}
		if ((yyvsp[-2].inpcoord_p)) {
			FREE((yyvsp[-2].inpcoord_p));
		}
		insertMAINLL(Currstruct_p, Mainlltc_p);
		Currstruct_p = (struct MAINLL *) 0;
	}
#line 10284 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 726:
#line 7274 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* null token to cause allocation of LINE struct */
		(void) contextcheck(C_MUSIC, "line");
		Currstruct_p = newMAINLLstruct(S_LINE, yylineno);
	}
#line 10294 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 727:
#line 7281 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = L_NORMAL;
	}
#line 10302 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 729:
#line 7291 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.stringval) = 0;
	}
#line 10310 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 730:
#line 7296 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.stringval) = fix_string((yyvsp[0].stringval), Titlefont, Titlesize, Curr_filename, yylineno);
	}
#line 10318 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 731:
#line 7302 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-6].intval) == L_WAVY) {
			l_warning(Curr_filename, yylineno,
						"wavy curve not allowed; using normal curve");
			(yyvsp[-6].intval) = L_NORMAL;
		}
		Currstruct_p->u.curve_p->curvetype = (yyvsp[-6].intval);
		insertMAINLL(Currstruct_p, Mainlltc_p);
		Currstruct_p = (struct MAINLL *) 0;
	}
#line 10333 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 732:
#line 7314 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(void) contextcheck(C_MUSIC, "curve");
		Currstruct_p = newMAINLLstruct(S_CURVE, yylineno);

		/* get space for a list of locations and mark it as empty */
		Item_count = 0;
		Currstruct_p->u.curve_p->ncoord = (short) Item_count;
		Currstruct_p->u.curve_p->nbulge = (short) Item_count;
		MALLOC(INPCOORD, Currstruct_p->u.curve_p->coordlist, ITEMS);
		Max_items = ITEMS;
	}
#line 10349 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 739:
#line 7348 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* get enough space to store some values if don't have enough */
		if (Currstruct_p->u.curve_p->nbulge == 0) {
			MALLOCA(float, Currstruct_p->u.curve_p->bulgelist, ITEMS);
		}
		else if ( (Currstruct_p->u.curve_p->nbulge % ITEMS) == 0) {
			REALLOCA(float, Currstruct_p->u.curve_p->bulgelist,
				Currstruct_p->u.curve_p->nbulge + ITEMS);
		}

		/* fill in the value and increment the count of how many */
		Currstruct_p->u.curve_p->bulgelist[Currstruct_p->u.curve_p->nbulge] = (yyvsp[-1].intval) * (yyvsp[0].floatval);
		(Currstruct_p->u.curve_p->nbulge)++;
	}
#line 10368 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 740:
#line 7364 "src/mup/gram.y" /* yacc.c:1646  */
    {
		struct INPCOORD *curve_inpcoord_p;

		/* If ran off end of list, make list bigger.
		 * We cannot use REALLOC here, since we need to update
		 * the tag reference information on each individual array
		 * element, so we alloc all new space, copy the existing data,
		 * and update the tag references, then free the old space,
		 * and redirect the pointer to the new space. */
		if (Currstruct_p->u.curve_p->ncoord >= Max_items) {
			struct INPCOORD *newlist_p;
			int n;
			Max_items += ITEMS;
			MALLOC(INPCOORD, newlist_p, Max_items);
			for (n = 0; n < Currstruct_p->u.curve_p->ncoord; n++) {
				newlist_p[n] = Currstruct_p->u.curve_p->coordlist[n];
				rep_inpcoord(
				    &(Currstruct_p->u.curve_p->coordlist[n]),
				    &(newlist_p[n]));
			}
			FREE(Currstruct_p->u.curve_p->coordlist);
			Currstruct_p->u.curve_p->coordlist = newlist_p;
		}

		/* Add this entry to the end of the list, update the
		 * tag reference to point to this permanent copy rather
		 * the temporary one we will be deleting, and update the
		 * count of how many elements in the list. */
		curve_inpcoord_p = &(Currstruct_p->u.curve_p->coordlist
					[Currstruct_p->u.curve_p->ncoord]);
		*curve_inpcoord_p = *((yyvsp[0].inpcoord_p));
		rep_inpcoord((yyvsp[0].inpcoord_p), curve_inpcoord_p);
		(Currstruct_p->u.curve_p->ncoord)++;
		FREE((yyvsp[0].inpcoord_p));
	}
#line 10408 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 741:
#line 7401 "src/mup/gram.y" /* yacc.c:1646  */
    {
		attach_stuff();
		/* so reset flag */
		Defining_multiple = NO;
	}
#line 10418 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 742:
#line 7409 "src/mup/gram.y" /* yacc.c:1646  */
    {
		chk_stuff_header((yyvsp[-5].intval), (yyvsp[-4].intval), (yyvsp[-3].intval), Dist_usage);
		add_to_sv_list();
	}
#line 10427 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 743:
#line 7416 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* Separate rule for phrase because it has the linetype
		 * modifier in front, unlike any other STUFF. The size,
		 * and dist are not really allowed, but we match them
		 * if they are there in order to give more clear error
		 * message than just "syntax error," since there was
		 * already code elsewhere to check for these errors.
		 */
		set_stuff_type(ST_PHRASE);
		chk_stuff_header((yyvsp[-3].intval), (yyvsp[-5].intval), (yyvsp[-2].intval), Dist_usage);
		add_to_sv_list();
		Aligntag = NOALIGNTAG;
	}
#line 10445 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 744:
#line 7431 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* need a separate rule for midi, because it can include
		 * a voice as well as staff. It also cannot have the chord,
		 * size or place, although those are checked elsewhere anyway */
		chk_stuff_header(-1, NO, PL_UNKNOWN, SD_NONE);
		Aligntag = NOALIGNTAG;
	}
#line 10457 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 745:
#line 7441 "src/mup/gram.y" /* yacc.c:1646  */
    {
		set_stuff_type(ST_MIDI);
		begin_range(PL_UNKNOWN);
	}
#line 10466 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 747:
#line 7451 "src/mup/gram.y" /* yacc.c:1646  */
    {
		all();
		add_to_sv_list();
	}
#line 10475 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 748:
#line 7458 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* dummy token for sole purpose of saving away current
		 * stuff type. We have to do this in order to have it in
		 * time to figure out the default place for "all" */
		set_stuff_type((yyvsp[0].intval));
	}
#line 10486 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 749:
#line 7467 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Curr_family = (yyvsp[-1].intval);

		switch ((yyvsp[0].intval)) {
		case FONT_TR:
			(yyval.intval) = ST_ROM;
			break;
		case FONT_TI:
			(yyval.intval) = ST_ITAL;
			break;
		case FONT_TB:
			(yyval.intval) = ST_BOLD;
			break;
		case FONT_TX:
			(yyval.intval) = ST_BOLDITAL;
			break;
		default:
			pfatal("unknown font");
			break;
		}
	}
#line 10512 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 750:
#line 7491 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) != L_NORMAL) {
			/* user used 'dotted' or 'dashed' which applies only
			 * to use of T_L_ANGLE for slurs. Use generic error
			 * message so looks like any other similar error. */
			yyerror("syntax error");
		}
		(yyval.intval) = ST_CRESC;
	}
#line 10526 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 751:
#line 7503 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = ST_DECRESC;
	}
#line 10534 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 752:
#line 7509 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = ST_PEDAL;
	}
#line 10542 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 753:
#line 7515 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = ST_MUSSYM;
	}
#line 10550 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 754:
#line 7521 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = ST_OCTAVE;
	}
#line 10558 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 755:
#line 7527 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* use -1 to indicate user didn't specify so must use default */
		(yyval.intval) = -1;
	}
#line 10567 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 756:
#line 7534 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[-1].intval);
	}
#line 10575 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 757:
#line 7539 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = TM_NONE;
	}
#line 10583 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 758:
#line 7545 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 10591 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 759:
#line 7550 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Dist = 0.0;
		Dist_usage = SD_NONE;
	}
#line 10600 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 760:
#line 7557 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].intval) != DIST) {
			yyerror("unexpected parameter name instead of 'dist'");
		}
		else {
			if (frangecheck((yyvsp[0].floatval), -MAXDIST, MAXDIST, "dist") == YES) {
				Dist = (yyvsp[0].floatval);
			}
		}
	}
#line 10615 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 761:
#line 7570 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.floatval) = (yyvsp[-1].floatval);
	}
#line 10623 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 762:
#line 7576 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (Dist_usage != SD_FORCE) {
			l_warning(Curr_filename, yylineno,
				"negative dist requires !, setting to 0");
			(yyval.floatval) = 0.0;
		}
		else {
			(yyval.floatval) = - (yyvsp[-1].floatval);
		}
	}
#line 10638 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 763:
#line 7588 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Dist_usage = SD_MIN;
	}
#line 10646 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 764:
#line 7594 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Dist_usage = SD_FORCE;
	}
#line 10654 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 765:
#line 7599 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Aligntag = NOALIGNTAG;
	}
#line 10662 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 766:
#line 7605 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (rangecheck((yyvsp[0].intval), MINALIGNTAG, MAXALIGNTAG, "align tag number") == YES) {
			Aligntag = (yyvsp[0].intval);
		}
		else {
			Aligntag = NOALIGNTAG;
		}
	}
#line 10675 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 769:
#line 7623 "src/mup/gram.y" /* yacc.c:1646  */
    {
		add_stuff_item((yyvsp[-4].floatval), (yyvsp[-3].floatval), Start_gracebackup, (yyvsp[-2].stringval),
			Til_bars, Til_offset, Til_steps, End_gracebackup,
			Dist, Dist_usage, Aligntag, Grid_alias);
	}
#line 10685 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 770:
#line 7631 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Til_bars = 0;
		Til_offset = 0.0;
		Til_steps = 0.0;
		(yyval.floatval) = (yyvsp[-1].floatval);
		Start_gracebackup = (yyvsp[0].intval);
	}
#line 10697 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 771:
#line 7640 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = 0;
	}
#line 10705 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 772:
#line 7646 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = (yyvsp[-1].intval);
	}
#line 10713 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 773:
#line 7651 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.floatval) = 0.0;
	}
#line 10721 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 774:
#line 7657 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.floatval) = (yyvsp[-1].floatval) * (float) (yyvsp[-2].intval);
	}
#line 10729 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 775:
#line 7662 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.stringval) = (char *) 0;
	}
#line 10737 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 776:
#line 7668 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.stringval) = (yyvsp[0].stringval);
	}
#line 10745 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 777:
#line 7673 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.stringval) = 0;
		Grid_alias = 0;
	}
#line 10754 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 778:
#line 7679 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.stringval) = (yyvsp[0].stringval);
		Grid_alias = 0;
	}
#line 10763 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 779:
#line 7686 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (get_stuff_type() != ST_PEDAL) {
			yyerror("'*' only valid with pedal");
		}
		MALLOCA(char, (yyval.stringval), 12);
		(yyval.stringval)[0] = FONT_MUSIC;
		(yyval.stringval)[1] = DFLT_SIZE;
		sprintf((yyval.stringval) + 2, "\\(endped)");
		Grid_alias = 0;
	}
#line 10778 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 780:
#line 7699 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.stringval) = (yyvsp[-3].stringval);
		Grid_alias = (yyvsp[-1].stringval);
	}
#line 10787 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 781:
#line 7705 "src/mup/gram.y" /* yacc.c:1646  */
    {
		End_gracebackup = 0;
	}
#line 10795 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 782:
#line 7711 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 10802 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 783:
#line 7716 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/** if there is a non-empty til_suffix, the floatnum better
		 ** have been an integer, and is really the number
		 * of bars. **/
		if ((yyvsp[0].intval) == YES) {
			Til_bars = (int) (yyvsp[-1].floatval);
			if ((yyvsp[-1].floatval) - Til_bars != 0.0) {
				yyerror("number of measures in til clause must be a whole number");
			}
		}
		else {
			/* only a number, that means it was really a beat offset */
			Til_offset = (yyvsp[-1].floatval);
		}
	}
#line 10822 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 784:
#line 7734 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = NO;
		End_gracebackup = (yyvsp[-1].intval);
		Til_steps = (yyvsp[0].floatval);
	}
#line 10832 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 785:
#line 7742 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = YES;
	}
#line 10840 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 786:
#line 7748 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Til_offset = 0.0;
		Til_steps = (yyvsp[0].floatval);
		End_gracebackup = (yyvsp[-1].intval);
	}
#line 10850 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 787:
#line 7756 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Til_offset = (yyvsp[-2].floatval);
		Til_steps = (yyvsp[0].floatval);
		End_gracebackup = (yyvsp[-1].intval);
	}
#line 10860 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 789:
#line 7766 "src/mup/gram.y" /* yacc.c:1646  */
    {
		newROLLINFO();
	}
#line 10868 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 790:
#line 7772 "src/mup/gram.y" /* yacc.c:1646  */
    {
		newROLLINFO();
		setrolldir(UP);
	}
#line 10877 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 791:
#line 7779 "src/mup/gram.y" /* yacc.c:1646  */
    {
		newROLLINFO();
		setrolldir(DOWN);
	}
#line 10886 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 793:
#line 7790 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* save staffnum and voice 1 for start of roll */
		rollparam((yyvsp[0].intval), 1, -1, -1);
	}
#line 10895 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 794:
#line 7797 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* save staff and voice for start of roll */
		rollparam((yyvsp[-1].intval), (yyvsp[0].intval), -1, -1);
	}
#line 10904 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 796:
#line 7806 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* save staffnum, voice 1 for end of roll */
		rollparam(-1, -1, (yyvsp[0].intval), 1);
	}
#line 10913 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 797:
#line 7813 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* save staffnum and voice for end of roll */
		rollparam(-1, -1, (yyvsp[-1].intval), (yyvsp[0].intval));
	}
#line 10922 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 798:
#line 7820 "src/mup/gram.y" /* yacc.c:1646  */
    {
		rolloffset( (double) (yyvsp[-1].floatval));
	}
#line 10930 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 799:
#line 7826 "src/mup/gram.y" /* yacc.c:1646  */
    {	
		rolloffset( (double) (yyvsp[-1].floatval));
	}
#line 10938 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 800:
#line 7831 "src/mup/gram.y" /* yacc.c:1646  */
    {
		int size;

		if (Curr_family == FAMILY_DFLT) {
			Curr_family = Score.fontfamily;
		}
		String1 = (yyvsp[0].stringval);
		size = Curr_size;
		if (Curr_loc_info_p != 0) {
			if (references_page(Curr_loc_info_p) == YES) {
				size = adj_size(size, 1.0 / Score.musicscale,
					Curr_filename, yylineno);
			}
		}
		Extra = extra_needed(Curr_family + Curr_font, size, &String1);
		(void) proc_printcmd((yyvsp[-2].intval), Curr_loc_info_p, String1,
			Curr_family + Curr_font, size, (yyvsp[-1].intval),
			NO, PU_NORMAL, NO, 0,
			((yyvsp[-1].intval) == YES ? Extra : (double) 0.0));
	}
#line 10963 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 801:
#line 7854 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(void) proc_printcmd(J_NONE, Curr_loc_info_p, (yyvsp[0].stringval), FONT_UNKNOWN,
				DFLT_SIZE, NO, YES, (yyvsp[-3].intval), (yyvsp[-1].intval), (yyvsp[-2].export_p), (double) 0.0);
		if ((yyvsp[-1].intval) == NO) {
			end_raw();
		}
	}
#line 10975 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 802:
#line 7864 "src/mup/gram.y" /* yacc.c:1646  */
    {
	}
#line 10982 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 803:
#line 7868 "src/mup/gram.y" /* yacc.c:1646  */
    {
		begin_raw();
		(yyval.intval) = NO;
	}
#line 10991 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 804:
#line 7875 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = YES;
	}
#line 10999 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 805:
#line 7881 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].intval) == YES) {
			warning("nl ignored for postscript");
		}
		(yyval.intval) = PU_NORMAL;
	}
#line 11010 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 806:
#line 7890 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Curr_loc_info_p = (struct INPCOORD *) 0;
		(yyval.intval) = (yyvsp[0].intval);
	}
#line 11019 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 807:
#line 7896 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.export_p) = 0;
	}
#line 11027 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 808:
#line 7902 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.export_p) = (yyvsp[0].export_p);
	}
#line 11035 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 810:
#line 7911 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* add onto list and return the list */
		struct VAR_EXPORT *exp_p;
		for (exp_p = (yyvsp[-2].export_p); exp_p->next != 0; exp_p = exp_p->next) {
			;
		}
		exp_p->next = (yyvsp[0].export_p);
		(yyval.export_p) = (yyvsp[-2].export_p);
	}
#line 11049 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 811:
#line 7923 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyvsp[0].export_p)->tag_addr = symval((yyvsp[0].export_p)->name, &((yyvsp[0].export_p)->tag_addr));
		(yyval.export_p) = (yyvsp[0].export_p);
	}
#line 11058 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 812:
#line 7930 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyvsp[0].export_p)->tag_addr = symval((yyvsp[0].export_p)->name, &((yyvsp[0].export_p)->tag_addr));
		(yyval.export_p) = (yyvsp[0].export_p);
	}
#line 11067 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 813:
#line 7937 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].export_p)->index == NUMCTYPE && (yyvsp[0].export_p)->index != NUMCTYPE && (yyvsp[0].export_p)->index != EXPORT_ALL_STAFFS) {
			l_yyerror(Curr_filename, yylineno,
			"if alias does not have a dot and direction, tag must not either");
		}
		if ((yyvsp[-2].export_p)->index != NUMCTYPE && (yyvsp[0].export_p)->index == NUMCTYPE) {
			l_yyerror(Curr_filename, yylineno,
			"if alias has dot and direction, tag must also");
		}
		(yyvsp[0].export_p)->alias = (yyvsp[-2].export_p);
		(yyval.export_p) = (yyvsp[0].export_p);
	}
#line 11084 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 814:
#line 7951 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.export_p) = (yyvsp[0].export_p);
	}
#line 11092 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 815:
#line 7957 "src/mup/gram.y" /* yacc.c:1646  */
    {
		if (strcmp((yyvsp[0].stringval), "_staff") != 0) {
			pfatal("got arraytag other than _staff");
		}
		(yyval.export_p) = add_export((yyvsp[0].stringval), EXPORT_ALL_STAFFS);
	}
#line 11103 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 816:
#line 7966 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.export_p) = (yyvsp[0].export_p);
	}
#line 11111 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 817:
#line 7972 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* export all six [nsewxy] values */
		(yyval.export_p) = add_export((yyvsp[0].stringval), NUMCTYPE);
	}
#line 11120 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 818:
#line 7979 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.export_p) = add_export((yyvsp[-2].stringval), (yyvsp[0].intval));
	}
#line 11128 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 822:
#line 7993 "src/mup/gram.y" /* yacc.c:1646  */
    {
		/* this means print at default location */
		Curr_loc_info_p = (struct INPCOORD *) 0;
		(yyval.intval) = NO;
	}
#line 11138 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 823:
#line 8001 "src/mup/gram.y" /* yacc.c:1646  */
    {
		Curr_loc_info_p = (struct INPCOORD *) 0;
		(yyval.intval) = YES;
	}
#line 11147 "src/mup/ytab.c" /* yacc.c:1646  */
    break;

  case 824:
#line 8008 "src/mup/gram.y" /* yacc.c:1646  */
    {
		(yyval.intval) = NO;
	}
#line 11155 "src/mup/ytab.c" /* yacc.c:1646  */
    break;


#line 11159 "src/mup/ytab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 8013 "src/mup/gram.y" /* yacc.c:1906  */


#include <stdio.h>


/* print error message along with current filename and line number */

int
yyerror(msg)

char *msg;

{
	if (strncmp(msg, "syntax error", 12) == 0 ||
			strncmp(msg, "parse error", 11) == 0) {
		/* beef up yacc's default syntax error message */
		if (*yytext == '\n') {
			l_yyerror(Curr_filename, yylineno,
				"error detected at end of line (maybe missing semicolon or other required element?)");
		}
		else if (is_internal_token(yytext) == YES) { 
			/* We add some funny tokens for our internal use
			 * when doing emptymeas parameter expansion.
			 * It is conceivable that there could be
			 * some (rare) scenarios where a user error
			 * in their value for that parameter would cause the
			 * parser to detect the error when it got to our
			 * funny token, and it would be very confusing to the
			 * user if we printed that out as the offending token,
			 * since they didn't input it, and it is chosen
			 * specifically to be strange looking.
			 */
			l_yyerror(Curr_filename, yylineno,
				"error detected during internal emptymeas parameter processing");
		}
		else {
			l_yyerror(Curr_filename, yylineno,
				"error detected at '%s'", yytext);
		}
	}
	else {
		l_yyerror(Curr_filename, yylineno, "%s", msg);
	}

	/* return something to keep lint happy */
	return(0);
}


/* if argument is surrounded by double quotes, remove them and return the
 * unquoted string. Actually just NULL out the end quote and return a
 * pointer to beyond the leading quote */

static char *
stripquotes(string)

char *string;

{
	char *p;

	p = string + strlen(string) - 1;
	if (*p == '"') {
		*p = '\0';
	}
	return( *string == '"' ? string + 1 : string);
}


/* Check if the given header/footer type has already been specified,
 * and if so, issue a warning. In any case, set Currblock_p
 * to the passed in BLOCKHEAD pointer. */

static void
chkdup_headfoot(bit, which, block_p)

int bit;	/* which GOT_* bit is associated with this head/foot thing */
char *which;	/* header, footer, header2, footer2 or left/right versions */
struct BLOCKHEAD *block_p;	/* assign this to Currblock_p */

{
	if ((bit & Gotheadfoot) != 0) {
		l_yyerror(Curr_filename, yylineno,
				"%s context specified more than once", which);
	}
	Gotheadfoot |= bit;
	Currblock_p = block_p;
}


/* If the given top/bot block has already been set without having been used,
 * issue a warning. In any case, set it to the Currblock_p value.
 */

static void
chkdup_topbot(block_p_p, blocktype)

struct BLOCKHEAD **block_p_p;	/* address of a FEED field like top_p, bot2_p,
				 * lefttop_p, rightbot_p, etc. What it points
				 * to will be updated with the value of
				 * Currblock_p. */
char *blocktype;		/* Name to be used on error message if the
				 * field was already set before. */

{
	if (*block_p_p != 0) {
		warning("%s redefined before being used", blocktype);
	}
	*block_p_p = Currblock_p;

}


/* when entering new context, need to save away everything about current one */

static void
end_prev_context()

{
	struct MAINLL *place_p;		/* where to insert SSV in main list */


	/* assume we will place at the end of main list. Later we'll set
	 * the right value if that assumption is wrong */
	place_p = Mainlltc_p;

	/* If current main list item hasn't been added to list yet,
	 * do that now. */
	if (Currstruct_p != (struct MAINLL *) 0 && Currstruct_p != place_p) {

		if (Currstruct_p->str == S_SSV) {

			if (List_of_staffs_p != (struct MAINLL *) 0) {
				yyerror("can't change context inside a measure");
				Currstruct_p = (struct MAINLL *) 0;
				return;
			}

			check_beamstyle(Currstruct_p->u.ssv_p);

			/* if is an SSV struct, we also need to set the
			 * correct values at this point, because the
			 * parser needs to know current values of some
			 * things (like font and point size) */
			asgnssv(Currstruct_p->u.ssv_p);

			/* if this SSV is after a FEED, we have to move it
			 * before the FEED in order to follow the rules of
			 * what comes when on the main list */
			for (   ; place_p != (struct MAINLL *) 0 &&
					place_p->str == S_FEED;
					place_p = place_p->prev) {
			}
		}

		/* Usually we want to insert, but if there were syntax
		 * errors in the bar_info, followed by a context change,
		 * error recovery could skip over the code that
		 * would zero Currstruct_p, but we would already have
		 * inserted it, so we need to not insert it again.
		 * Oterwise, we could end up with consecutive BAR structs in
		 * the main list, which is not legal, and could lead to
		 * problems like an infinite loop in prev_grpsyl().
		 */
		if (Currstruct_p->str != S_BAR) {
			insertMAINLL(Currstruct_p, place_p);
		}
		else if (Errorcount == 0) {
			pfatal("unexpected BAR struct in end_prev_context()");
		}
	}

	if (Currstruct_p != 0 && Currstruct_p->str == S_SSV) {
		/* memorize or recall beamstyle and timeunit if appropriate */
		remember_tsig_params(Currstruct_p);

		/* If user specified multiple staffs/voices, clone the
		 * necessary SSV nows */
		if (Currstruct_p->u.ssv_p->context == C_STAFF) {
			clone_staff_ssvs(place_p);
			free_rlists();
		}
		else if (Currstruct_p->u.ssv_p->context == C_VOICE) {
			clone_voice_ssvs(place_p);
			free_rlists();
		}
		Defining_multiple = NO;
	}

	if (Curr_usym_p != 0) {
		define_usym();
		Curr_usym_p = 0;
	}

	if (Context == C_SHAPES) {
		/* Note that if the user puts a shapes context as the very
		 * last context in their input, end_prev_context would not
		 * get called, so this finish_shape_map call would not
		 * get hit,  but since since nothing could refer to it,
		 * that wouldn't actually hurt anything. */
		finish_shape_map();
	}

	Curr_grpsyl_p = (struct GRPSYL *) 0;
	Currblock_p = (struct BLOCKHEAD *) 0;
	Currstruct_p = (struct MAINLL *) 0;
	set_win_coord(0);
}


/* If user gave a list of staffs for a "staff" context, clone copies of
 * the SSV that we made for the first on the list for the rest of the list. */

static void
clone_staff_ssvs(insert_p)

struct MAINLL *insert_p;
{
	struct SVRANGELIST *svr_p;
	struct RANGELIST *sr_p;		/* list of staff ranges */
	struct SSV *clone_src_p;	/* the SSV to clone */
	int s;				/* staff number */

	clone_src_p = Currstruct_p->u.ssv_p;
	for (svr_p = Svrangelist_p; svr_p != 0; svr_p = svr_p->next) {
		for (sr_p = svr_p->stafflist_p; sr_p != 0; sr_p = sr_p->next) { 
			for (s = sr_p->begin; s <= sr_p->end && s <= Score.staffs; s++) {
				if (clone_src_p->staffno == s) {
					/* skip past the clone source */
					continue;
				}
				clone1ssv(clone_src_p, insert_p, s, clone_src_p->voiceno);
			}
		}
	}
}


/* If user gave a list of staffs and/or voices  for a "voice" context,
 * clone copies of the SSV that we made for the first on the list
 * for the rest of the list. */

static void
clone_voice_ssvs(insert_p)

struct MAINLL *insert_p;

{
	struct SVRANGELIST *svr_p;
	struct RANGELIST *sr_p;		/* list of staff ranges */
	struct RANGELIST *vr_p;		/* list of voice ranges */
	struct SSV *clone_src_p;	/* the SSV to clone */
	int s;				/* staff number */
	int v;				/* voice number */
	int numvoices;			/* how many voices on current staff */
	int have_non_v3 = NO;		/* If any voice other than voice 3 */


	clone_src_p = Currstruct_p->u.ssv_p;
	for (svr_p = Svrangelist_p; svr_p != 0; svr_p = svr_p->next) {
	    for (sr_p = svr_p->stafflist_p; sr_p != 0; sr_p = sr_p->next) { 
		for (s = sr_p->begin; s <= sr_p->end && s <= Score.staffs; s++) {
		    numvoices = vscheme_voices(svpath(s, VSCHEME)->vscheme);
		    for (vr_p = svr_p->vnolist_p; vr_p != 0; vr_p = vr_p->next) {
			for (v = vr_p->begin; v <= vr_p->end && v <= numvoices; v++) {
				if (v != 3) {
					have_non_v3 = YES;
				}
				if (clone_src_p->staffno == s
						&& clone_src_p->voiceno == v) {
					/* skip past the clone source */
					continue;
				}
				clone1ssv(clone_src_p, insert_p, s, v);
			}
		    }
		}
	    }
	}

	if (clone_src_p->used[ALIGNRESTS] == YES && have_non_v3 == NO) {
		l_warning(Curr_filename, yylineno,
				"alignrests not used for voice 3; ignoring");
	}
}

/* Clone the given SSV and insert it in the specified place in the main list.
 * Change the copied versions staffno/voiceno to the specified values,
 * and do any additional error checks and processsing as needed.
 */

static void
clone1ssv(clone_src_p, insert_p, staffno, voiceno)

struct SSV *clone_src_p;
struct MAINLL *insert_p;
int staffno;
int voiceno;

{
	struct MAINLL *newmllssv_p;	/* the cloned SSV */

	newmllssv_p = newMAINLLstruct(S_SSV, Currstruct_p->inputlineno);
	memcpy(newmllssv_p->u.ssv_p, clone_src_p, sizeof(struct SSV));
	newmllssv_p->u.ssv_p->staffno = staffno;
	newmllssv_p->u.ssv_p->voiceno = voiceno;
	/* Fix beamstyle/timeunit. It could be different for each clone */
	remember_tsig_params(newmllssv_p);
	insertMAINLL(newmllssv_p, insert_p);

	/* Make sure any tab staffs have non-tabs above them.
	 * One disadvantage of waiting till making the clone to check this is
	 * that if there is a user error, the line number will be the end
	 * of the context rather than the one with "stafflines" on it.
	 * But the error message will tell them which staff is the problem,
	 * and this should be pretty rare--they have to be setting stafflines
	 * in a staff context for multiple staffs where the combination of
	 * staffs is illegal--so it doesn't seem worth the extra work it would
	 * be to be more precise. */
	if (newmllssv_p->u.ssv_p->context == C_STAFF &&
				newmllssv_p->u.ssv_p->used[STAFFLINES] == YES) {
		chk_tab(newmllssv_p);
	}
	asgnssv(newmllssv_p->u.ssv_p);
}


/* Check that the staffs/voices specified for an SSV are valid.
 * We only give a warning if all values specified are out of range.
 * If at least one is valid, we assume user did something like
 * 	voice 1-40 3
 * to set something for voice 3 on all staffs without having to worry
 * about which staffs actually have a voice 3.
 */

static void
chk_ssv_ranges(context)

UINT32B context;	/* expected to only be either C_STAFF or C_VOICE */

{
	struct SVRANGELIST *svr_p;	/* list of staff/voice ranges */
	struct RANGELIST *sr_p;		/* list of staff ranges */
	struct RANGELIST *vr_p;		/* list of voice ranges */
	int s;				/* staff number */
	int v;				/* voice number */
	int numvoices;			/* how many voices on current staff */


	for (svr_p = Svrangelist_p; svr_p != 0; svr_p = svr_p->next) {
	    for (sr_p = svr_p->stafflist_p; sr_p != 0; sr_p = sr_p->next) { 
		for (s = sr_p->begin; s <= sr_p->end; s++) {
		    if (context == C_STAFF) {
			if (s >= MINSTAFFS && s <= Score.staffs) {
				/* Found a valid one. One is all we need. */
				return;
			}
			continue;
		    }

		    /* a voice context */
		    numvoices = vscheme_voices(svpath(s, VSCHEME)->vscheme);
		    for (vr_p = svr_p->vnolist_p; vr_p != 0; vr_p = vr_p->next) { 
			for (v = vr_p->begin; v <= vr_p->end; v++) {
			    if (s >= MINSTAFFS && s <= Score.staffs &&
					v >= MINVOICES && v <= numvoices) {
				/* Found a valid one. One is all we need. */
				return;
			    }
			}
		    }
		}
	    }
	}
	/* Fell through all the loops without finding a single valid case */
	if (context == C_STAFF) {
		l_warning(Curr_filename, yylineno,
			"staff out of range; must be between %d and %d",
			MINSTAFFS, Score.staffs);
	}
	else {
		l_warning(Curr_filename, yylineno,
			"staff/voice combination out of range; staff must be between %d and %d, voice between %d and %d and within vscheme limit for the staff",
			MINSTAFFS, MAXSTAFFS, MINVOICES, MAXVOICES);
	}
}


/* if defining more than one voice at the moment, not valid to set
 * a location variable. Print message and reset flag so we don't
 * give any more of the same message this measure */

static void
var_valid()

{
	if (Defining_multiple == YES) {
		yyerror("location tag is only allowed when defining a single voice");
		Defining_multiple = NO;
	}
	else if (Chord_at_a_time == YES) {
		yyerror("location tag not allowed with chord-at-a-time input");
	}
}


/* Save information about a Mup variable that the user wants to have
 * exported to their PostScript */

static struct VAR_EXPORT *
add_export(varname, index)

char *varname;	/* Name of variable to be exported */
int index;	/* AX, AW, etc or NUMCTYPE if all are to be exported,
		 * or EXPORT_ALL_STAFFS for all indexes of all staffs */

{
	struct VAR_EXPORT *var_p;

	MALLOC(VAR_EXPORT, var_p, 1);
	var_p->name = strdup(varname);
	/* For now we set the alias to ourself. If the user specifies an
	 * alias, then that will be set later. But by defaulting to pointing
	 * to ourself, code can assume there is always an alias. */
	var_p->alias = var_p;
	var_p->index = index;
	var_p->next = 0;
	return(var_p);
}


/* do a print command like left, right, or center. Allocate a PRINTDATA
 * struct and fill in all the information about what to print and where
 * to print it. */

static struct PRINTDATA *
proc_printcmd(justifytype, inpc_p, str, font, size, got_nl, isPostScript, ps_usage, isfilename, export_p, extra)

int justifytype;	/* J_LEFT, etc */
struct INPCOORD *inpc_p;	/* where to print */
char *str;		/* the string to print */
int font;
int size;
int got_nl;	/* YES if should go to next line before printing */
int isPostScript;	/* YES if is raw PostScript rather than normal print */
int ps_usage;		/* PU_* value; tells how is PostScript is used */
int isfilename;		/* Yes if the string is the name of a file containing PostScript */
struct VAR_EXPORT *export_p; /* Mup vars to export to user PostScript */
double extra;	/* how much extra vertical padding to add */

{
	struct PRINTDATA *curr_print_p;
	struct EXPR_NODE *node_p;
	int htype;


	(void) contextcheck(C_MUSIC | C_BLOCKHEAD, "print");

	/* save all the info in a PRINTDATA struct */
	MALLOC(PRINTDATA, curr_print_p, 1);
	curr_print_p->mirror_p = 0;

	if (inpc_p == (struct INPCOORD *) 0) {

		/* print at default location */
		curr_print_p->location.vert_p = symval("_cur", (float **) 0);
		/* Create an expression that is _cur - extra */
		node_p = newnode(OP_SUB);
		curr_print_p->location.vexpr_p = node_p;

		node_p->left.lchild_p = newnode(OP_TAG_REF);
		MALLOC(TAG_REF, node_p->left.lchild_p->left.ltag_p, 1);
		node_p->left.lchild_p->left.ltag_p->c = curr_print_p->location.vert_p;
		node_p->left.lchild_p->left.ltag_p->c_index = AY;
		save_tag_ref(node_p->left.lchild_p->left.ltag_p->c,
					&(node_p->left.lchild_p->left.ltag_p->c));

		node_p->right.rchild_p = newnode(OP_FLOAT_LITERAL);
		node_p->right.rchild_p->left.value = extra;

		switch (justifytype) {
		case J_LEFT:
		case J_RAGPARA:
		case J_JUSTPARA:
			/* default x is relative to _win.w */
			curr_print_p->location.hor_p = symval("_win", (float **) 0);
			htype = AW;
			break;
		case J_RIGHT:
			/* default x is relative to _win.e */
			curr_print_p->location.hor_p = symval("_win", (float **) 0);
			htype = AE;
			break;
		case J_CENTER:
			/* default x is relative to _win.x */
			curr_print_p->location.hor_p = symval("_win", (float **) 0);
			htype = AX;
			break;
		case J_NONE:
		default:
			/* default is at current location */
			curr_print_p->location.hor_p = symval("_cur", (float **) 0);
			htype = AX;
			break;
		}

		curr_print_p->location.hexpr_p = newnode(OP_TAG_REF);
		MALLOC(TAG_REF, curr_print_p->location.hexpr_p->left.ltag_p, 1);
		curr_print_p->location.hexpr_p->left.ltag_p->c = curr_print_p->location.hor_p;
		curr_print_p->location.hexpr_p->left.ltag_p->c_index = htype;
		save_tag_ref(curr_print_p->location.hexpr_p->left.ltag_p->c,
			&(curr_print_p->location.hexpr_p->left.ltag_p->c));

		/* If this is the first print command in a block,
		 * we implicitly go down by the font ascent. */
		if (isPostScript == NO && Currblock_p != 0
					&& Next_print_link_p_p
					== &(Currblock_p->printdata_p) ) {
			/* Alter expression, to subtract the fontascent */
			node_p = newnode(OP_SUB);
			node_p->left.lchild_p = curr_print_p->location.vexpr_p;
			curr_print_p->location.vexpr_p = node_p;
			node_p->right.rchild_p = newnode(OP_FLOAT_LITERAL);
			node_p->right.rchild_p->left.value = fontascent(font, size) / STEPSIZE;

			got_nl = NO;
		}

	}
	else {
		curr_print_p->location = *(inpc_p);
		rep_inpcoord(inpc_p, &(curr_print_p->location) );
		FREE(inpc_p);
	}

	curr_print_p->isPostScript = isPostScript;
	curr_print_p->ps_usage = ps_usage;
	curr_print_p->export_p = export_p;
	if (isPostScript == YES) {
		curr_print_p->width = 0.0;
	}
	else {
		curr_print_p->width = strwidth(str);
	}
	curr_print_p->isfilename = isfilename;
	curr_print_p->justifytype = (short) justifytype;
	curr_print_p->string = str;
	curr_print_p->inputfile = Curr_filename;
	curr_print_p->inputlineno = (short) yylineno;

	/* For PostScript hooks that apply once to the entire file,
	 * store directly into hook table. */
	switch (ps_usage) {
	case PU_AFTERPROLOG:
	case PU_BEFORETRAILER:
		if (PostScript_hooks[ps_usage] != 0) {
		l_warning(Curr_filename, yylineno, "PostScript hook already set on line %d of %s; using last",
			PostScript_hooks[ps_usage]->inputlineno,
			PostScript_hooks[ps_usage]->inputfile);
		}
		PostScript_hooks[ps_usage]  = curr_print_p;
		return(curr_print_p);
	default:
		break;
	}

	/* special case of user asking that this be printed
	 * on the next line. In this case we go down by the
	 * current point size */
	if (got_nl) {
		node_p = newnode(OP_SUB);
		node_p->left.lchild_p = curr_print_p->location.vexpr_p;
		curr_print_p->location.vexpr_p = node_p;
		node_p->right.rchild_p = newnode(OP_FLOAT_LITERAL);
		node_p->right.rchild_p->left.value = fontheight(font, size) / STEPSIZE;
	}

	/* Now link onto proper list -- could be in BLOCKHEAD
	 * context or doing a PRHEAD. If we are in BLOCKHEAD context, we
	 * definitely have something in the main list to attach to.
	 * If in C_MUSIC, we may or may not depending on whether
	 * this is the first in a series of print commands. */
	if ( ((Context & C_BLOCKHEAD) != 0)
		|| ((Currstruct_p != (struct MAINLL *) 0) &&
		(Currstruct_p->str == S_PRHEAD) ) ) {
			if (Next_print_link_p_p == (struct PRINTDATA **) 0) {
				pfatal("Next_print_link_p_p is null");
			}
			/* this means the value of Next_print_link_p_p
			 * is valid and will tell us where to link */
			*Next_print_link_p_p = curr_print_p;
	}
	else {
		/* We must be in music context, but the last
		 * thing we saw wasn't a print command, so
		 * we have to allocate a PRHEAD and put it
		 * in the main list and attach to that. */
		/* allocate a new struct, put on main list and attach
		 * the print command to it */
		Currstruct_p = newMAINLLstruct(S_PRHEAD, yylineno);
		insertMAINLL(Currstruct_p, Mainlltc_p);
		Currstruct_p->u.prhead_p->printdata_p = curr_print_p;
		Currstruct_p = (struct MAINLL *) 0;
	}

	/* in any case, if we get another print command right away, it
	 * should be linked onto this one, so remember where we are */
	Next_print_link_p_p = &(curr_print_p->next);
	curr_print_p->next = (struct PRINTDATA *) 0;

	return(curr_print_p);
}


/* For mirrored titles, point the information about the left and right 
 * string to each other */

static void
mirror(left_p, right_p)

struct PRINTDATA *left_p;	/* left when not mirrored */
struct PRINTDATA *right_p;	/* right when not mirrored */

{
	if (Mirrored == YES) {
		left_p->mirror_p = right_p;
		right_p->mirror_p = left_p;
	}
}


/* if the given string has a higher ascent than the given font/size, return
 * the amount is it higher, in stepsizes */

static double
extra_needed(font, size, string_p)

int font;	/* default font for this string */
int size;	/* default size for this string */
char **string_p;/* string, before being put in internal format,
		 * which might contain \s(xx) to make it bigger than normal.
		 * If it is key-mapped, the passed-in pointer will be
		 * updated to point to the mapped string. */

{
	double usual_ascent;
	double this_string_ascent;


	/* get expected ascent for this font/size and actual for string */
	usual_ascent = fontascent(font, size);
	(void) fix_string(*string_p, font, size, Curr_filename, yylineno);
	*string_p = map_print_str(*string_p, Curr_filename, yylineno);
	this_string_ascent = strascent(*string_p);

	/* if this string is too tall, return by how much it is too tall */
	if (this_string_ascent > usual_ascent) {
		return (this_string_ascent - usual_ascent) / STEPSIZE;
	}
	else {
		return(0.0);
	}
}


/* Sometimes lexer will recognize something as a keyword, but it's
 * really a bunch of note letters, due to context. This function turns
 * the mistaken keyword into notes. It handles a through g and r and s, and
 * us, but not n, which would also be troublesome, but which we don't (yet)
 * need to handle.
 */

static void
keyword_notes(str)

char *str;

{
	for (  ; *str != '\0'; str++) {
		if (*str == 'u' && *(str+1) == 's') {
			str++;
			continue;
		}

		/* On the last letter, if it's a true pitch, have to
		 * push it back into input, because it could be followed
		 * by an accidental or octave mark or tick or something. */
		if (*(str+1) == '\0' && *str >= 'a' && *str <= 'g') {
			pushback(*str);
		}
		else {
			add_note(Curr_grpsyl_p, (int) *str, No_accs,
					USE_DFLT_OCTAVE, 0, NO, (char *) 0);
		}
	}
}


/* Free up the current additive time list, if any */

static void
free_extra_time()
{
	struct TIMELIST *tl_p;

	/* If this was the most recently allocated list, we can free it.
	 * We can't free otherwise, since Extra_time_p might be
	 * pointing to one from an SSV, which must be kept around. */
	if (Extra_time_p == Last_alloced_timelist_p) {
		while (Extra_time_p != 0) {
			tl_p = Extra_time_p->next;
			FREE(Extra_time_p);
			Extra_time_p = tl_p;
		}
	}
	Extra_time_p = 0;
	Last_alloced_timelist_p = 0;
	Curr_timelist_p = 0;
}


/* Add an item to the internal representation of the time signature
 * currently being collected */

static void
tsig_item(item)

int item;	/* the byte to add to timerep */

{
	if (Tsig_offset >= MAXTSLEN  - 1) {
		l_ufatal(Curr_filename, yylineno,
				"time signature is too complicated");
	}
	Timerep[Tsig_offset++] = (char) item;
}


/* Allocate a new expression node, fill in its opearator field, and return it. */

static struct EXPR_NODE *
newnode(op)

int op;		/* OP_* value for the new node */

{
	struct EXPR_NODE * node_p;

	CALLOC(EXPR_NODE, node_p, 1);
	node_p->op = op;
	return(node_p);
}


/* Zero out the list of accidentals for the current note */

static void
clear_curr_accs()

{
	CLEAR_ACCS(Curr_accs);
	Acc_offset = 0;
}


/* Add given accidental to the list of accidental for the current note.
 * (if it is valid and there is room) */

static void
add_acc(acc_name)

char *acc_name;

{
	int code;
	int font;
	int is_small;

	if (Acc_offset >= 2 * MAX_ACCS) {
		l_yyerror(Curr_filename, yylineno,
				"Too many accidentals (%d max)", MAX_ACCS);
		return;
	}
	is_small = NO;
	if (is_bad_char((code = find_char(acc_name, &font, &is_small, NO))) == YES) {
		l_yyerror(Curr_filename, yylineno,
			"No symbol named %s to use as accidental", acc_name);
		return;
	}

	/* Note that probably the font should be either one of the music
	 * fonts or user defined font, but we go ahead and allow anything. */
	Curr_accs[Acc_offset++] = font;
	Curr_accs[Acc_offset++] = code;

	/* If we have a non standard accidental, or if the accidentals
	 * net out to something outside the range of double flat to
	 * double sharp, mark Tuning_used, because we can't use simple
	 * ordinary MIDI commands. */
	if (accs_offset(Curr_accs) == BAD_ACCS_OFFSET) {
		Tuning_used = YES;
	}
}


/* Add another entry to the list of accidentals in accidentals context.
 * It is passed the name of the accidental. It allocates an entry,
 * if necessary, sets Curr_acc_index to the index of the entry, fills in
 * the code and font, and sets offsets to a negative value to indicate
 * "not yet filled in."
 */

static void
new_acc_entry(acc_name)

char *acc_name;		/* like "sharp" or "dlbflat" or a user name */

{
	int i;
	int is_small;


	if (Acc_contexts_list_p == 0) {
		/* must have been an earlier error */
		return;
	}

	/* Check for already defined */
	for (i = 0; i < Acc_contexts_list_p->size; i++) {
		if (strcmp(acc_name, get_charname(
				Acc_contexts_list_p->info[i].code,
				Acc_contexts_list_p->info[i].font))
				== 0) {
			/* Use the existing entry */
			Curr_acc_index = i;
			return;
		}
	}

	/* If space is full, alloc another chunk */
	if (Acc_contexts_list_p->size % ITEMS == 0
				&& Acc_contexts_list_p->size > 0) {
		REALLOC(ACCINFO, Acc_contexts_list_p->info,
				Acc_contexts_list_p->size + ITEMS);
	}

	/* Use the next available slot */
	Curr_acc_index = Acc_contexts_list_p->size;

	/* One more slot being used */
	(Acc_contexts_list_p->size)++;

	/* Fill in all the offset slots with an illegal
	 * (i.e., negative) value, so we can tell later which the user
	 * has set. Normally I wouldn't hard-code a 7, but if the
	 * number of "white keys" a-g changes from 7, we have
	 * much bigger problems ;-). 
	 */
	for (i = 0; i < 7; i++) {
		CURR_ACC_ENTRY.offset[i] = -1.0;
	}

	/* Translate symbol name to code and font */
	CURR_ACC_ENTRY.code = find_char(acc_name,
					&(CURR_ACC_ENTRY.font), &is_small, YES);
}


/* Fill in an element of the offset[] array for a accidental,
 * in accidentals context. 
 */

static void
add_acc_offset(letter, offset)

int letter;	/* which index into offset[], 'a' is 0, 'b' is 1, etc */
double offset;	/* what value to fill in */

{
	int index;

	if (Context != C_ACCIDENTALS) {
		return;
	}
	if (Acc_contexts_list_p == 0) {
		/* Must have been earlier error */
		return;
	}

	index = letter - 'a';

	/* Check if already has been set */
	if (CURR_ACC_ENTRY.offset[index] >= 0 ) {
		l_warning(Curr_filename, yylineno,
			"offset for accidental '%s' specified more than once, using last", get_charname(CURR_ACC_ENTRY.code, CURR_ACC_ENTRY.font));
	}

	/* Warn about outrageous values. We consider an accidental
	 * that changes by more than a major third outrageous. */
	if (offset < 0.8 || offset > 1.25) {
		l_warning(Curr_filename, yylineno,
			"dubious accidental offset (factor of %f alters pitch by more than a major third)", offset);
	}

	/* Fill in the value */
	CURR_ACC_ENTRY.offset[index] = offset;
}


static int
comp_subbar(item1_p, item2_p)

#ifdef __STDC__
const void *item1_p;            /* the subbars to compare */
const void *item2_p;
#else
char *item1_p;          	/* the subbars to compare */
char *item2_p;
#endif

{
	struct SUBBAR_INSTANCE *sb1_p, *sb2_p;

	sb1_p = (struct SUBBAR_INSTANCE *) item1_p;
	sb2_p = (struct SUBBAR_INSTANCE *) item2_p;
	if (sb1_p->count < sb2_p->count) {
		return(-1);
	}
	else if (sb1_p->count > sb2_p->count) {
		return(1);
	}
	else {
		return(0);
	}
}


/* Given a MULTIWHOLE value (2, 4, or 8) return the corresponding BT_* value */
static int
multiwhole2basictime(value)

int value;

{
	if (value == 2) {
		return(BT_DBL);
	}
	else if (value == 4) {
		return(BT_QUAD);
	}
	else if (value == 8) {
		return(BT_OCT);
	}
	else {
		pfatal("invalid value %d passed to multiwhole2basictime", value);
		/*NOTREACHED*/
		return(0);
	}
}


/* Given a chordtranslation parameter "do/re/mi" string, split it into
 * the 7 syllables, and place them in the doremi_syls field of current SSV. */

static void
parse_doremi_string(str)

char *str;	/* Typically "do re mi fa sol la si" */

{
	int nsyl;	/* count of syllables */
	int syl_leng;
	char saved;


	if (Currstruct_p == 0 || Currstruct_p->u.ssv_p == 0) {
		/* Must have been a user error earlier */
		return;
	}

	CALLOCA(char *, Currstruct_p->u.ssv_p->doremi_syls, 7);
	/* This code is similar to that for noteheads parameter in assign.c */
	for (nsyl = 0; nsyl < 7; nsyl++) {
		/* skip any leading spaces */
		while (isspace(*str)) {
			str++;
		}
		if (*str == '\0') {
			break;
		}
		syl_leng = strcspn(str, " \t\r\n");
		saved = str[syl_leng];
		str[syl_leng] = '\0';
		Currstruct_p->u.ssv_p->doremi_syls[nsyl] =
				copy_string(str, FONT_TR, DFLT_SIZE);
		fix_string(Currstruct_p->u.ssv_p->doremi_syls[nsyl],
				FONT_TR, DFLT_SIZE,
				Curr_filename, yylineno);
		str[syl_leng] = saved;
		str += syl_leng;
	}
	while (isspace(*str)) {
		str++;
	}
	if (nsyl != 7 || *str != '\0') {
		l_yyerror(Curr_filename, yylineno,
			 "Wrong number of do/re/mi syllables; expecting 7");
		/* If there were less than 7, later code could attempt to
		 * access an uninitalized value, so fix that. */
		for (  ; nsyl < 7; nsyl++) {
			Currstruct_p->u.ssv_p->doremi_syls[nsyl] =
				copy_string(" ", FONT_TR, DFLT_SIZE);
		}
	}
}


/* Give warning if user forgot to add an end to match a samescorebegin
 * or samepagebeing. It doesn't really hurt anything, but might mean they
 * included more in the zone than intended, so seems worth a warning,
 * but not a error.
 */

void
check_same_ended()

{
	if (Doing_samescore == YES) {
		l_warning(Curr_filename, yylineno,
			"missing samescoreend");
	}
	if (Doing_samepage == YES) {
		l_warning(Curr_filename, yylineno,
			"missing samepageend");
	}
}
